﻿IfNotExist, %PROGRAM_PATH%
	FileCreateDir, %PROGRAM_PATH%
FileInstall , .\qc_icons.icl, %PROGRAM_PATH%\qc_icons.icl, 0
;----------------------------------------------------------

NOICO_HANDLE := IconExtract( IconGetPath(NOICO), IconGetIndex(NOICO), 24 )

CheckArguments(params,param1,param2)
{
	global Exit_NoNotify,MB_NAME
	if (param1 = "-admintry" && !A_IsAdmin)
	{
		MsgBox, 16, Failed to start with Admin rights, Quick Cliq could not be run under Admin rights
		Exit_NoNotify = 1
		ExitApp
	}
	If param1 in -xpaddr,-smreg,-smreg_del,-en_recent,ResetAsAdmin_On,ResetAsAdmin_Off
		if !A_IsAdmin
		{
			MsgBox, 16, Failed to start with Admin rights, Quick Cliq could not be run under Admin rights
			Exit_NoNotify = 1
			ExitApp
		}
	If (params = 2 && param1 = "-xpaddr" && A_IsAdmin)				;param2 here is SID
	{
		SetAddressStateXP(param2)					
		MsgBox, 64, Success, The registry has been successfully modified.
		Exit_NoNotify = 1
		ExitApp
	}
	If (params = 1 && param1 = "-smreg" && A_IsAdmin)
	{
		CheckSMenuRegs()
		MsgBox, 64, Success, Separate Menus settings has been set!
		Exit_NoNotify = 1
		ExitApp
	}
	If (params = 1 && param1 = "-smreg_del" && A_IsAdmin)
	{
		CheckSMenuRegs(0)
		MsgBox, 64, Success, Separate Menus has been successfully removed.
		Exit_NoNotify = 1
		ExitApp
	}
	If (params = 2 && param1 = "-en_recent" && A_IsAdmin)		;param2 here is SID
	{
		if EnableWindowsRecent(param2)
			MsgBox, 64, Success, Windows Recent Items were successfully enabled.
		else
			MsgBox, 16, Failed to write to registry, Quick Cliq was unable to make necessary changes to the registry.
		Exit_NoNotify = 1
		ExitApp
	}
	If (params = 1 && param1 = "ResetAsAdmin_On" && A_IsAdmin)
	{
		Context_Reg(1)
		MsgBox, 64, Success, Context menu item has been successfully added.
		Exit_NoNotify = 1
		ExitApp
	}
	If (params = 1 && param1 = "ResetAsAdmin_Off" && A_IsAdmin)
	{
		Context_Reg(0)
		MsgBox, 64, Success, Context menu item has been successfully removed.
		Exit_NoNotify = 1
		ExitApp
	}

	if (params = 2 && param1 = "-a")
	{
		CreateNewShortcut(param2)
		Exit_NoNotify = 1
		ExitApp
	}
	else if (params = 2 && param1 = "-sm")
	{
		DF_SetIconsHandle()
		MMenu_InitArrays()
		RunSMenu(param2)
		Exit_NoNotify = 1
		ExitApp
	}
	else if (param1 != "-admintry")
	{
		PID := DllCall("GetCurrentProcessId")
		Process, Exist, %A_ScriptName%
		if (PID != ErrorLevel && ErrorLevel != 0)
		{
			MsgBox, 16, Only one instance allowed, You already have an instance of "%MB_NAME%" running, 3
			Exit_NoNotify = 1
			ExitApp
		}
	}
	return
}