﻿;############################### CREATE NEW SHORTCUT
CreateNewShortcut(target)
{
	global
	local name, ext
	Gui, 4:Default
	Gui, -0x10000 -0x20000
	if global_NoGuiTheme
		Gui,-Theme
	SplitPath, target,,,Ext,Name
	StringUpper, Name, Name, T 
	gui, add, text, , Shortcut name:
	Gui, Add, Edit, W250 vshortcutName R1, %Name%
	gui, add, text, , Target:
	Gui, Add, Edit, W250 vsh_target R1, "%target%"
	gui, add, text, , Choose menu:
	Gui, add, DropDownList,r15 AltSubmit vmenusDdl w250, %MAIN_SECTION_NAME%||
	AddMenusToDDL("menusDdl",MAIN_SECTION_NAME)
	Gui, add, button, xm+60 w50 gAddChoosenShortcut, Ok
	Gui, add, button, X+30 w50, Cancel
	Gui, Show,, Add Shortcut
	Loop
	{
		GuiControlGet,shortcutName,,shortcutName
		if ErrorLevel
			break
		sleep 300
	}
	return
	
	;############################### 
	4GuiEscape:
	4GuiClose:
	4ButtonCancel:
	Gui, 4:Destroy
	return

	;############################### ADD CHOOSED SHORCUT
	AddChoosenShortcut:
	Gui, 4:+OwnDialogs
	GuiControlGet,shortcutName,,shortcutName
	shortcutName := RegExReplace(shortcutName, "i)^" . MAIN_SECTION_NAME . "$|#|" . SEPARATOR_STRING . "|^$|ERROR", "_")
	GuiControlGet,menunum,,menusDdl
	FileGetAttrib, af_attribs, %param2%
	if instr(af_attribs,"D")
	{
		if RegExMatch(Target,"^\\.*")
			ico_f := REMOTE_ICO
		else
			ico_f := FOLDER_ICO	
	}
	else if (Ext = "exe")
		ico_f := param2 . ":0"
	else
		ico_f := IconFromExt(ext)
	if (ico_f = 0)
		ico_f := ""
	GuiControlGet, sh_target,,sh_target
	def = ^"\s*(?!").*(?<!")\s*"$
	if RegExMatch(sh_target,def)				;if target is enclosed in quotes once from the both sides
		sh_target := RegExReplace(sh_target,"(^\s*""|""\s*$)","""""")		;then we make em double quotes because one from each side will be removed on ini reading
	if IsNameAvailable(shortcutName,menu%menuNum%)
		AddNew(shortcutName,0,0,1,ico_f,menu%menuNum%,sh_target)
	else
	{
		MsgBox,16,Invalid shortcut, Invalid shortcut name!`nEither already exist in that menu or contain invalid symbols.
		return
	}
	af_attribs =
	Gui, 4:Destroy
	PID := DllCall("GetCurrentProcessId")
	Process, Exist, %A_ScriptName%
	if (ErrorLevel != PID)
	{
		DetectHiddenWindows, On
		PostMessage, 0x7777,,,, ahk_pid %ErrorLevel%		
		DetectHiddenWindows,Off
	}
	return	
}


;############################### ISSHORTCUTNAMEAVAILABLE
IsNameAvailable(name,menusection)
{
	global MAIN_SECTION_NAME, SEPARATOR_STRING
	flag := 1
	if RegExMatch(name, "i)^" . MAIN_SECTION_NAME . "$|#|" . SEPARATOR_STRING . "|^$|ERROR") ;|^[0-9]+$
		flag := 0
	else If TVNameExist( Name, Menusection )
		flag := 0
	return flag
}
;############################### ADDMENUSTODDL
AddMenusToDDL(DDLVar,MenuSection,PreviousMenu="")
{
	global
	local order, itemName, MenuName, NewMenuName
	static menuNum
	if !PreviousMenu
	{
		menuNum := 1
		menu%menuNum% := MenuSection
	}
;~ 	msgbox % menuNum "`n" menu%menuNum%
	Gui, 4:Default
	order:=0
	Loop
	{
		itemName := ItemGet(order,MenuSection)
		if (itemName == "ERROR")
			break
		ifInString,itemName, #M#
		{
			StringReplace, itemName, itemName, #M#
			StringReplace, itemName, itemName, #B#
			if PreviousMenu
				MenuName := PreviousMenu . ">" . GetItemID(itemName)
			else
				MenuName := MenuSection . ">" . GetItemID(itemName)
			if (StrLen(MenuName) > 37)
			{
				NewMenuName := SubStr(MenuName,1,(StrLen(MenuName)/2 - (StrLen(MenuName)-37)/2 -2)) . "..." . SubStr(MenuName,((StrLen(MenuName)-37)/2 - StrLen(MenuName)/2+2))
				GuiControl,,%DDLVar%,%NewMenuName%
			}
			else
				GuiControl,,%DDLVar%,%MenuName%
			menuNum++
			menu%menuNum% := MenuSection . "#" . GetItemID(itemName)
;~ 			msgbox % menuNum "`n" menu%menuNum%
			AddMenusToDDL(DDLVar,MenuSection . "#" . GetItemID(itemName),">" . PreviousMenu)
		}
		order++
	}
	return
}