﻿DragnDrop_TrackWheel(wParam, lParam, msg, hwnd)
{
	global dnd_wheel_rotated, TV_hwnd
	dnd_wheel_rotated := 1
	SendMessage(TV_hwnd, msg, wParam, lParam )
	return
}

TVDragDrop(DraggedItemID)
{
	global TV_hwnd, AnTreeView, dnd_wheel_rotated
	Gui,1:Default
	Gui, TreeView, AnTreeView
	
	TVGN_CARET := 0x9,	TVM_HITTEST := 0x1111,	TVM_SELECTITEM := 0x110B,	TVGN_DROPHILITE := 0x8
	TVM_GETITEMHEIGHT := 0x111C,	TVM_SETINSERTMARK := 0x111A,	TVM_GETITEMRECT := 0x1104
	TVM_SETINSERTMARKCOLOR := 0x1100 + 37	;TV_FIRST + 37
	TVM_CREATEDRAGIMAGE := 0x1100 + 18	;TV_FIRST + 18
	WM_MOUSEWHEEL := 0x20A
	OnMessage(WM_MOUSEWHEEL,"DragnDrop_TrackWheel")
	
	CoordMode, Mouse, Relative
	
	SendMessage( TV_hwnd, TVM_SELECTITEM, TVGN_CARET, 0 )		; Select the item before dragging so it's clear what you're dragging
	;~ SendMessage( TV_hwnd, TVM_SETINSERTMARKCOLOR, 0, 0xff0000 )				;here we can change the color of the insert mark
	if TV_Get(DraggedItemID, "Bold")
		hImg_list := SendMessage( TV_hwnd, TVM_CREATEDRAGIMAGE, 0, DraggedItemID )
	else
	{
		TV_Modify(DraggedItemID,"Bold")
		hImg_list := SendMessage( TV_hwnd, TVM_CREATEDRAGIMAGE, 0, DraggedItemID )
		TV_Modify(DraggedItemID,"-Bold")
	}

	DllCall("Comctl32\ImageList_BeginDrag","Ptr",hImg_list,"Int",0,"Int",0,"Int",0)
	MouseGetPos,X,Y
	Gui, +LastFoundExist
	gui_hWnd := WinExist()
	ControlGetPos,,TV_Y,,TV_height,,ahk_id %TV_hwnd%
	DllCall("Comctl32\ImageList_DragEnter","Ptr",TV_hwnd,"Int",X,"Int",Y-TV_Y)
	;~ DllCall("ShowCursor","Int",0)
	DllCall("SetCapture","Ptr",gui_hWnd)
	height := SendMessage( TV_hwnd, TVM_GETITEMHEIGHT, 0, 0 )
	
	While GetKeyState("LButton")
	{
		MouseGetPos,X,Y
		if (X != Xpre || Y != Ypre || dnd_wheel_rotated)
		{
			if dnd_wheel_rotated
			{
				GuiControl,MoveDraw,AnTreeView
				dnd_wheel_rotated =
			}
			; Create the TVHITTESTINFO struct...
			VarSetCapacity( tvht, 16, 0 )
			NumPut( X, tvht, 0, "int" )
			NumPut( Y-TV_Y, tvht, 4, "int" )
			; ... to determine whether the pointer is over an item. If it is...
			DllCall("Comctl32\ImageList_DragMove","Int",X+10,"Int",Y-TV_Y+10)
			DllCall("Comctl32\ImageList_DragShowNolock","Int",0)
			
			If hitTarget := SendMessage( TV_hwnd, TVM_HITTEST, 0, &tvht )
			{

				; ... if the pointer is in the top or bottom quarter of the item,
				; show an insertion mark before or after, respectively.
				; This way you can decide whether to make the dragged item
				; a child or sibling of the drop target item.   
				VarSetCapacity( rcitem, 16, 0 ), NumPut( hitTarget, rcitem )
				SendMessage( TV_hwnd, TVM_GETITEMRECT, 1, &rcitem )
				rcitem_top := NumGet( rcitem, 4, "int" )
				rcitem_bottom := NumGet( rcitem, 12, "int" )
				mark_pos = 
				div := TV_GetChild(hitTarget) ? 4 : 2
				SendMessage( TV_hwnd, TVM_SETINSERTMARK, 0, 0 ) ; hide insertion mark
				sleep 1
				mark_pos := ( Y - TV_Y - rcitem_top ) <= ( height/div ) ? 0 : ( rcitem_bottom - Y + TV_Y) <= ( height/div ) ? 1 : "OFF"
				if mark_pos in 0,1
					SendMessage( TV_hwnd, TVM_SETINSERTMARK, mark_pos, hitTarget ) ; show insertion mark, mark_pos = 0 - before,= 1 - after the item
				
				if (TV_GetChild(hitTarget) && mark_pos = "off")
					SendMessage( TV_hwnd, TVM_SELECTITEM, TVGN_DROPHILITE, hitTarget )
				else
					SendMessage( TV_hwnd, TVM_SELECTITEM, TVGN_DROPHILITE, 0 )
				DllCall("Comctl32\ImageList_DragShowNolock","Int",1)
			}
			else
			{
				SendMessage( TV_hwnd, TVM_SETINSERTMARK, 0, 0 ) ; hide insertion mark
				sleep 1
				SendMessage( TV_hwnd, TVM_SELECTITEM, TVGN_DROPHILITE, 0 )	;removing hilite
			}
			Xpre := X
			Ypre := Y
		}
		;following code is for menus auto-expanding
		if (TV_GetChild(hitTarget) && hover_target == hitTarget && mark_pos = "off")
		{
			hover_time++
			if (hover_time = 20)				;consider delay time before expanding menu = hover_time*50 milliseconds, so now it 1000 msec
				TV_Modify(hitTarget,"Expand")
		}
		else if (TV_GetChild(hitTarget) && mark_pos = "off")
		{
			hover_target := hitTarget
			hover_time =
		}
		else
		{
			hover_time =
			hover_target =
		}
		sleep 50
	}
	; Remove the drop-target highlighting and insertion mark
	SendMessage( TV_hwnd, TVM_SELECTITEM, TVGN_DROPHILITE, 0 )
	SendMessage( TV_hwnd, TVM_SETINSERTMARK, 0, 0 )
	DllCall("ShowCursor","Int",1)
	DllCall("ReleaseCapture")
	DllCall("Comctl32\ImageList_DragLeave","Ptr",TV_hwnd)
	DllCall("Comctl32\ImageList_EndDrag")
	DllCall("Comctl32\ImageList_Destroy","Ptr",hImg_list)
	DllCall("SetClassLong", "Ptr",TV_hwnd, "int", -12, "int",  TV_oldcursor)
	DllCall("DestroyCursor","Ptr",newcursor)

	If hDroppedTargetID := SendMessage( TV_hwnd, TVM_HITTEST, 0, &tvht )
	{
		TV_Modify(hDroppedTargetID)			;select item
		; Only do stuff if the droptarget is different from the drag item
		If ( DraggedItemID != hDroppedTargetID )
		{
		   ; To prevent infinite loops, first make sure "parent" isn't actually a
		   ; descendant of node (it's like going back in time and becoming your own
		   ; great-grandfather: no good can come of it)
		   If not IsParentADescendant( DraggedItemID, hDroppedTargetID )
		   {
			  
			  TV_Get_DragnDropIDs(hDroppedTargetID,mark_pos,pPID,pPreID)
			  ;~ AddNodeToParent( DraggedItemID, hDroppedTargetID )
			  MoveItem("",DraggedItemID,pPID,pPreID)
		   }
		}            
	}
	else
		TV_Modify(DraggedItemID)
	OnMessage(WM_MOUSEWHEEL,"")
	return
}

TV_Get_DragnDropIDs(tID,tPos,ByRef tPID,ByRef tPreID)	;tPID is a parent ID where the dragged item should be placed, PreID is ID of item AFTER which we will place dragged item
{
	Gui, 1:Default
	global AnTreeView
	Gui, TreeView, AnTreeView
	if (TV_GetChild(tID) && tPos = "OFF")	;if we going to drop item into the menu with tID
	{
		tPID := tID							;the menu's ID
		tPreID := 0							;means the item will be added on the first position in the menu
	}
	else if ( tPos = 1 )					;if we going to drop item after tID
	{
		tPID := TV_GetParent(tID)
		tPreID := tID
	}
	else if ( tPos = 0 )					;if we going to drop item before tID
	{
		tPID := TV_GetParent(tID)
		tPreID := TV_GetPrev(tID)
	}	
	return
}

IsParentADescendant( node, parent )
{
   dlist := GetDescendantsList( node )
   Loop, parse, dlist, `,
      If ( A_LoopField = parent )
         return 1
   return 0
}

; Wheeeee! Recursion is fun!
GetDescendantsList( node )
{
   If ( kid := TV_GetChild( node ) )
   {
      kids .= kid . "," . GetDescendantsList( kid )
      While ( kid := TV_GetNext( kid ) )
         kids .= kid . "," . GetDescendantsList( kid )
   }
   return kids
}