﻿OptionsGUI()
{
	global
	Gui 2:+LastFoundExist
	IfWinExist
	{
		ControlGet, is_gui_visible, Visible,,, % "ahk_id " WinExist()
		if !is_gui_visible
			Gui, 1:Show
		WinActivate
		is_gui_visible=
		return
	}
	Gui, 2:+owner1
	Gui, 1:+Disabled
	Gui, 2:Default
	Gui, +OwnDialogs
	if global_NoGuiTheme
		Gui,-Theme
	Gui, Add, TreeView, X0 Y0 W150 H435 AltSubmit Backgroundf1f1f1 c000000 gOptionsTreeEvents vOptions_TV HWNDOptions_TV_hwnd
		TV_Add("Main Menu")
		local fp := TV_Add("Features")
		TV_Add("Clips",fp)
		TV_Add("Windows",fp)
		TV_Add("Memos",fp)
		TV_Add("Recent",fp)
		TV_Add("Gestures/Hotkeys")
		TV_Add("Backup")
	Gui, add, button, xm W70 gAcceptSettings, Done
	Gui, Add, Tab2,X160 Y0 W460 H435 gTabClicked vTabControl, Main Menu|Clips|Windows|Memos|Recent|Gestures/Hotkeys|Backup
	Gui, Add, Tab2,X163 Y24 W430 H400 vHK_GS_TabControl Hidden Buttons, Hotkeys|Gestures
	Gui, Add, Tab2,X163 Y24 W430 H400 vMM_Tab Hidden Buttons, General|Appearance
	
	Gui,Tab,5,1	;############################### RECENT
	rec_state := GetRecentState()
	Gui, Add, Checkbox,% "section y+30 cNavy vRecentSwitcher gRecentOptions Checked" . rec_state, Enable "Recent" feature
	Gui, Add, Checkbox,% "y+5 xs cNavy vRecentShowInMain gRecentOptions Checked" . GetRecentSubState() . " Disabled" . !rec_state, Show "Recent" sub in Main Menu
	Gui,Add,Checkbox,% "y+5	xs+40 cNavy vLogRecentShortcuts gRecentOptions Checked" . GetRecentLogShortcuts() . " Disabled" . !rec_state, Log recently used shortcuts
	Gui,Add,Checkbox,% "y+5 xs+40 cNavy vLogFolders gRecentOptions Checked" . GetRecentLogFoldersState() . " Disabled" . !rec_state, Log closed Windows folders
	Gui,Add,Checkbox,% "y+5	xs+40 cNavy vLogProcs gRecentOptions Checked" . GetRecentLogProcsState() . " Disabled" . !rec_state, Log closed Processes
	Gui,Add,Checkbox,% "y+5	xs+40 cNavy vLogWinRecent gRecentOptions Checked" . GetRecentWinLog() . " Disabled" . !rec_state, Log Windows Recent Items
	Gui,Add,Text,% "y+7	xs+40 cNavy vRC_CountLabel Disabled" . !rec_state,Max items in menu:
	Gui,Add,Edit,% "x+10 w50 yp-3 Limit2 cNavy vRC_CountEdit gRecentOptions Number Disabled" . !rec_state
	Gui,Add,UpDown,% "x+10 cNavy vRC_CountUpDown gRecentOptions Range" . RC_MINITEMS . "-" . RC_MAXITEMS . " Disabled" . !rec_state,% GetRCItemsCount()
	
	Gui,Tab, 1, 1
	Gui,Tab, 1,3 ;############################### Main Menu General
	Gui, Add, Checkbox,section x+5 y+10 vIsShowAdd cNavy +Wrap gAddChange, Hide "Add/Change" in main menu
	Gui, Add, Checkbox,% "xs y+5 cNavy vQuickHelpItem W210 gQuickHelpItemChange Checked" . GetHelpItemState(), Hide "Help" shortcut in main menu
	Gui, Add, Checkbox,% "xs y+5 cNavy vSuspendItem W210 gSuspendItemChange Checked" . GetSuspendItemState(), Hide "Suspend" menu
	Gui, Add, Checkbox, vIsTrayHidden cNavy +Wrap gHideTrayBox, Hide tray icon
	
	Gui, Add, Checkbox,% "xs y+25 cNavy vaddcontx W400 gaddContxChange Checked" . Context_Reg(), Add "%CONTX_MENU%" option to the context menu
	Gui, Add, Checkbox,% "xs y+5 vRunOnStartup gStartUpSet cNavy +Wrap Checked" . GetStartup(), Run on Windows startup
	Gui, Add, Checkbox, xs y+5 vAutoUpdates gAutoUpdatesCB cNavy +Wrap, Check for updates automatically	
	Gui, Add, Checkbox, xs y+5 vSMenus gSMenusCB cNavy +Wrap, Enable S-Menus
	
	Gui, add, text,xs y+20 cNavy, Multi-Target Delay
	Gui, add, Edit, x+10 yp-2 R1 W55 vMiltiDelayEd gChangeMD Number Limit5,% GetMultiDelay()
	Gui, add, text,x+8 cNavy yp+2, msec
	
	Gui, add, GroupBox,xs Section cNavy y+15 w430 h70, Portability options
	Gui, add, Checkbox,% "xs+10 ys+25 cNavy w300 vmgIconRelative gmgSetIconRelative Checked" . opt[ "IconRelativePath" ],Always save icons relative path
	Gui, add, Checkbox,% "xs+10 y+5 cNavy w300 vmgCmdRelative gmgSetCmdRelative Checked" . opt[ "CmdRelativePath" ],Always save commands relative path

	Gui,Tab, 2,3 ;############################### Appearence tab
	Gui, add, text,xs y+8 cNavy,Icons Size:
	Gui, Add, DropDownList,x+50 yp-3 W100 vsizeddl giconSizeChanged, 16|24|32
	GuiControl, ChooseString, sizeddl,% GetIconSize()

	Gui, add, text,xs y+8 cNavy,Transparency:
	Gui, Add, Slider,x+25 yp-3 W115 ToolTip Range0-255 vmenus_trans gmenus_trans_change,% GetMenusTrans()
	Gui, add, text,x+-1 yp+3 cTeal vmenus_trans_cnt w30,% GetMenusTrans()

	Gui, add, text,xs y+20 cNavy,Items height adjust:
	tmp_val := GetItemsHeight()
	Gui, Add, Slider,x+2 yp-3 W115 ToolTip Range0-10 vItemsHeight_slider gItemsHeight_Change,% tmp_val
	Gui, add, text,x+-1 yp+3 cTeal w30 vItemsHeight_label,+%tmp_val%
	
	Gui, Add, Checkbox,% "xs y+15 vLightMenu gChangeLightMenuState cNavy +Wrap Checked" . GetLightMenuState(), Light-Style Menu
	Gui, Add, Checkbox,% "xs y+5 vThemeState gChangeGuiThemeState cNavy +Wrap Checked" . GetGuiThemeState(), Remove Theme
	tmp_val := GetOptIconsOnly()
	Gui, Add, Checkbox,% "xs y+5 vMenuOptIconsOnly gChangeOptIconsOnly cNavy +Wrap Checked" . tmp_val, Show icons only
	Gui, Add, Checkbox,% "xs+50 y+5 vMenuOptShowTlp gChangeOptShowTlp cNavy +Wrap Checked" . GetOptShowTlp() . " Disabled" . !tmp_val, Show tooltips
	tmp_val := GetOptUseColumns()
	Gui, Add, Checkbox,% "xs y+5 vMenuOptUseColumns gChangeOptUseColumns cNavy +Wrap Checked" . tmp_val, Divide menu by columns. Max items per column:
	Gui,Add,Edit,% "x+10 w50 yp-3 Limit3 cNavy vMenuMaxPerCol gChangeMenuMaxPerCol Number Disabled" . !tmp_val,% GetOptMaxPerColumn()
	Gui, Add, Checkbox,% "xs+50 y+5 vMenuOptColBreak gChangeOptColBreak cNavy +Wrap Checked" . GetOptBarBreak()  . " Disabled" . !tmp_val, Show column bar break
	Free(tmp_val)
	
	AutoUpdates := OptGet("AutoUpdates")
	if AutoUpdates not in 0,1
		AutoUpdates := DEFAULT_AUTOUPDATE
	GuiControl,,AutoUpdates,%AutoUpdates%

	Gui, Tab, 2,1 ;############################### ClipX options
	Gui, Add, Checkbox, section y+30 cNavy vClipXSwitcher gClipXFeatures, Enable "Clips" feature
	Gui, Add, Checkbox, y+5 cNavy vClipXShowInMain gClipXFeatures, Show "Clips" sub in Main Menu
	Gui, Add, Checkbox,% "y+5 cNavy vClipsSaveOnExit gClipXFeatures Checked" . GetClipsSave(), Save/Restore Clips on "Quick Cliq" start
	Gui, Add, Text, xs y+10 cNavy, Hotkeys:
	Gui, Add, Text, xs y+10 cNavy vCC, Clip Copy:
	Gui, Add, Text, xs y+10 cNavy vCA, Clip Append:
	Gui, Add, Text, xs y+10 cNavy vCP, Clip Paste:
	;Copy
	hk := Clips_GetCopyHK()
	Gui, Add, Checkbox,% "Section xs+80 ys+82  cNavy gClipsModifyHotkeysChanged vCC_Ctrl Checked" . instr(hk,"^"),Ctrl +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCC_Alt Checked" . instr(hk,"!"),Alt +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCC_Shift Checked" . instr(hk,"+"),Shift +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCC_Win Checked" . instr(hk,"#"),Win
	;Append
	hk := Clips_GetAppendHK()
	Gui, Add, Checkbox,% "xs y+10 cNavy gClipsModifyHotkeysChanged vCA_Ctrl Checked" . instr(hk,"^"),Ctrl +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCA_Alt Checked" . instr(hk,"!"),Alt +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCA_Shift Checked" . instr(hk,"+"),Shift +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCA_Win Checked" . instr(hk,"#"),Win
	Gui, Add, Text, x+20 yp cNavy, + 1-9
	;Paste
	hk := Clips_GetPasteHK()
	Gui, Add, Checkbox,% "xs y+10 cNavy gClipsModifyHotkeysChanged vCP_Ctrl Checked" . instr(hk,"^"),Ctrl +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCP_Alt Checked" . instr(hk,"!"),Alt +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCP_Shift Checked" . instr(hk,"+"),Shift +
	Gui, Add, Checkbox,% "x+1 yp cNavy gClipsModifyHotkeysChanged vCP_Win Checked" . instr(hk,"#"),Win

	Clips_CopyHotkey := Clips_AppendHotkey := Clips_PasteHotkey := 0

	ClipXSwitcher := OptGet("ClipXEnabled")
	if ClipXSwitcher not in 0,1
		ClipXSwitcher := DEFAULT_FEATURES_STATE
	GuiControl,,ClipXSwitcher,%ClipXSwitcher%

	ClipXShowInMain := OptGet("ClipXShowInMain")
	if ClipXShowInMain not in 0,1
		ClipXShowInMain := DEFAULT_SHOW_IN_MAIN
	GuiControl,,ClipXShowInMain,%ClipXShowInMain%
	

	
;############################################################## Win_hide options
	Gui, Tab, 3,1
	Gui, Add, Checkbox, Section y+30 cNavy vWin_Hide_Enabled gWin_Hide_Toggle, Enable "Windows" feature
	Gui, Add, Checkbox, y+5 cNavy vWin_Hide_Show gWin_Hide_Show_Toggle, Show "Windows" sub in Main Menu
	Gui, Add, Checkbox, y+5 cNavy vWH_fade gWH_fadechange, Enable fading while hiding/showing windows
	
	Gui, Add, Text, y+15 w400, Transparency level for a hidden windows preview:`n(hold CTRL while navigating "Windows" menu to see preview)
	Gui, Add, Slider,y+5 ToolTip Range0-255 vtransp_slider gtransp_changed, 150
	Gui, Add, Text, x+2 yp+3 w20 vtransparent_level cTeal
	Gui, Add, Text, x+10 yp cTeal, (less - more transparent)
	
		WH_fade := OptGet("WH_fade")
		if WH_fade not in 0,1
			WH_fade := DEFAULT_FADE
		GuiControl,,WH_fade,%WH_fade%
		
		transparent_level := OptGet("transparent_level")
		if transparent_level is not Digit
			transparent_level := DEFAULT_TRANSP_LEVEL
		GuiControl,,transparent_level,%transparent_level%
		GuiControl,,transp_slider,%transparent_level%

		Win_Hide_Enabled := OptGet("Win_Hide_Enabled")
		if Win_Hide_Enabled not in 0,1
			Win_Hide_Enabled := DEFAULT_FEATURES_STATE

		GuiControl, , Win_Hide_Enabled, %Win_Hide_Enabled%

		Win_hide_Show := OptGet("Win_Hide_Show")
		if Win_hide_Show not in 0,1
			Win_hide_Show := DEFAULT_SHOW_IN_MAIN
		GuiControl, , Win_hide_Show, %Win_hide_Show%
		

;############################################################## Memos	
	Gui, Tab, 4,1
	Gui, Add, Checkbox, section y+30 cNavy vMemos_On gMemosOptions, Enable "Memos"
	Gui, Add, Checkbox, y+5 cNavy vMemosShowInMain gMemosOptions, Show "Memos" sub in main menu
	Gui, Add, Checkbox, y+5 cNavy vMemosDelConfirm gMemosOptions, Memo delete confirmation

	Gui, Add, Text,y+15,Default colors for On-Top memos:
	Gui, Add, button,y+5 vOTM_bg_default_color gMemosOptions, Change...
	Gui, Add, Text,x+5 yp+4,Change default background color
	Gui, Add, button,xs y+12 vOTM_t_default_color gMemosOptions, Change...
	Gui, Add, Text,x+5 yp+4,Change default text color
	Gui, Add, button,xs y+12 vOTM_default_font gMemosOptions, Change...
	Gui, Add, Text,x+5 yp+4,Change default font

	
	Memos_On := OptGet("Memos_On")
	if Memos_On not in 0,1
		Memos_On := DEFAULT_FEATURES_STATE
	GuiControl,, Memos_On, %Memos_On%
	MemosShowInMain := OptGet("MemosShowInMain")
	if MemosShowInMain not in 0,1
		MemosShowInMain := DEFAULT_SHOW_IN_MAIN
	GuiControl,, MemosShowInMain, %MemosShowInMain%
	MemosDelConfirm := OptGet("MemosDelConfirm")
	if MemosDelConfirm not in 0,1
		MemosDelConfirm := 1
	GuiControl,, MemosDelConfirm, %MemosDelConfirm%	

;######################################################################################### Hotkeys & Mouse Gestures
	Gui, Tab, 6,1
	Gui, Tab, 1,2
	Gui, add, text,xs y+5 cMaroon w300 vhotkeysOFFnotify gfakesub,% (HotkeysGlobalState != 1 ? "Hotkeys are currently turned OFF globally!" : "")
	;Main Menu
	hk_text_options := "c3C0078 w135"
	Gui, add, text,Section y+15 cNavy,Main Menu
	local m_hk := GetMainHotkey()
	Gui,add,text,xs+105 yp %hk_text_options% vMainHK,% HotkeyToString(m_hk)
	Gui, add, button,xs+245 yp-5 W60 gChangeHotkey_Main, Change
	Gui, add, button,x+10 yp W120 gChangeDefaultHotkeys vdef_hks, Other default hotkeys
	;Clips
	Gui, add, text,xs ys+33 cNavy,"Clips" Menu
	local cl_hk := GetClipsHotkey()
	Gui,add,text,xs+105 yp %hk_text_options% vClipsHK,% HotkeyToString(cl_hk)
	Gui, add, button,xs+245 yp-5 W60 gChangeHotkey_Clips, Change
	;Windows
	Gui, Add, text, xs y+20 cNavy, "Windows" Menu
	local w_hk := GetWindowsHotkey()
	Gui,add,text,xs+105 yp %hk_text_options% vWinHK,% HotkeyToString(w_hk)
	Gui, add, button,xs+245 yp-5 W60 gChangeHotkey_Windows, Change
	Gui, Add, text,xs y+20 vWin_Hide_Descrip_Text cNavy,Hide Active Window:
	Gui, Add, Radio,x+13 vWH_UseCSpace gWH_UseCSpace_CB c3C0078,Ctrl+Space
	Gui, Add, Radio,xp y+5 w13 h15 vWH_UseOptHK gWH_UseCSpace_CB
	whhk := GetHideAWindowHotkey()
	Gui,add,text,x+5 yp c3C0078 w110 vWinHideHK gWinHide_SetHotkey,% HotkeyToString(whhk ? whhk : "None")
	Gui, add, button,xs+245 yp-5 W60 gChangeHotkey_WinHide, Change
	;Memos
	Gui, add, text,xs y+20 cNavy,"Memos" Menu
	local memo_hk := GetMemosHotkey()
	Gui,add,text,xs+105 yp %hk_text_options% vMemoHK,% HotkeyToString(memo_hk)
	Gui, add, button,xs+245 yp-5 W60 gChangeHotkey_Memos, Change
	;Recent
	Gui, add, text,xs y+20 cNavy,"Recent" Menu
	local rc_hk := GetRecentHotkey()
	Gui,add,text,xs+105 yp %hk_text_options% vRecentHK,% HotkeyToString(rc_hk)
	Gui, add, button,xs+245 yp-5 W60 gChangeHotkey_Recent, Change	
	
	Gui,Tab, 2,2	
		Gui, add, text,xs y+5 cMaroon w300 vgesturesOFFnotify gfakesub,% (GesturesGlobalState != 1 ? "Gestures are currently turned OFF globally!" : "")
		
		Gui, Add, Checkbox,Section xs y+15 cNavy vGesture_Main_enabled gGestureEnable,Main Menu
		Gui, Add, Edit, xs+110 yp-3 +Uppercase W120 Limit4 vMainGestureEdit gGestureChange
		
		Gui, Add, Checkbox,xs y+20 cNavy vGesture_Clipx_enabled gGestureEnable,"Clips" Menu
		Gui, Add, Edit, xs+110 yp-3 +Uppercase W120 Limit4 vClipsGestureEdit gGestureChange
		
		Gui, Add, Checkbox,xs y+20 cNavy vGesture_WH_enabled gGestureEnable,"Windows" Menu
		Gui, Add, Edit,xs+110 yp-3 +Uppercase W120 Limit4 vWinGestureEdit gGestureChange
		
		Gui, Add, Checkbox,xs y+20 cNavy vGesture_Memos_enabled gGestureEnable,"Memos" Menu
		Gui, Add, Edit,xs+110 yp-3 W120 +Uppercase Limit4 vMemoGestureEdit gGestureChange
		rc_gs_st := GetRecentGestureState()
		Gui, Add, Checkbox,% "xs y+20 cNavy vRecentGestureState gRecentOptions Checked" . rc_gs_st . " Disabled" . !rec_state,"Recent" Menu
		Gui, Add, Edit,xs+110 yp-3 W120 +Uppercase Limit4 vRecent_Gesture gGestureChange,% GetRecentGesture()
		
		Gui, Add, Text, xs y+40 cNavy, Gesture disable timer (Seconds):
		Gui, Add, Edit,limit3 Number vGesture_Disable_Time gSet_Gesture_Disable_Time
		Gui, Add, CheckBox,% "x+15 yp+3 vTempGestDis gTempGestDisChange Checked" . GetTGNotifyState(), Notification

	
		Gui, Add, Text,cNavy xs ys+280, Global Gesture Button:
		Gui, Add, DropDownList, x+15 yp-3 w150 vGlobalGestureButton gChangeGlobalGestureButton, Right Mouse Button|Middle Mouse Button|Mouse 3|Mouse 4
		
		Gui, Add, Text, xs ys+325 +Wrap W250, Use the following letters for mouse gestures:
		Gui, Add, Text,xp+215 w200 yp cTeal, U - up`, D - down`, L - left`, R - right
		
		Gesture_Disable_Time := OptGet("Gesture_Disable_Time")			;Gesture disable Time
		if (Gesture_Disable_Time = "ERROR" or Gesture_Disable_Time = "")
			Gesture_Disable_Time := Global_Gesture_Disable_Time 
		
		StringTrimRight, Cut_Gesture_Disable_Time, Gesture_Disable_Time, 3
		GuiControl,, Gesture_Disable_Time, %Cut_Gesture_Disable_Time%	               		;Set Slider
		
		GlobalGestureButton := OptGet("GlobalGestureButton")
			If GlobalGestureButton not in RButton,MButton,XButton1,XButton2
				{
					GlobalGestureButton := "RButton"
					OptSet("GlobalGestureButton","RButton")
				}
		If (GlobalGestureButton = "RButton")
			GuiControl, ChooseString, GlobalGestureButton, Right Mouse Button
		If (GlobalGestureButton = "MButton")
			GuiControl, ChooseString, GlobalGestureButton, Middle Mouse Button
		If (GlobalGestureButton = "XButton1")
			GuiControl, ChooseString, GlobalGestureButton, Mouse 3
		If (GlobalGestureButton = "XButton2")
			GuiControl, ChooseString, GlobalGestureButton, Mouse 4
		
		GuiControlSet("MainGestureEdit",GetMainGesture(),"",2)
		Gesture_Main_enabled := OptGet("Gesture_Main_enabled")
		if Gesture_Main_enabled not in 0,1
			Gesture_Main_enabled := DEFAULT_GESTURES_STATE
		GuiControlSet("Gesture_Main_enabled",Gesture_Main_enabled,"",2)
		
;~  ClipX sets
		
		GuiControlSet("ClipsGestureEdit",GetClipsGesture(),"",2)
		Gesture_Clipx_enabled := OptGet("Gesture_Clipx_enabled")
		if Gesture_Clipx_enabled not in 0,1
			Gesture_Clipx_enabled := DEFAULT_GESTURES_STATE
		GuiControlSet("Gesture_Clipx_enabled",Gesture_Clipx_enabled,"",2)
		GuiControlSet("ClipXShowInMain|Gesture_Clipx_enabled|ClipsSaveOnExit"
				,"","Enable" ClipXSwitcher,2,0)

		
;~  Win_Hide sets
		GuiControlSet("WinGestureEdit",GetWindowsGesture(),"",2)
		Gesture_WH_enabled := OptGet("Gesture_WH_enabled")
		if Gesture_WH_enabled not in 0,1
			Gesture_WH_enabled := DEFAULT_GESTURES_STATE
		GuiControl,, Gesture_WH_enabled, %Gesture_WH_enabled%	
		
		WH_UseCSpace := OptGet("WH_UseCSpace")
		if WH_UseCSpace not in 0,1
			WH_UseCSpace := 1
		GuiControl,, WH_UseCSpace, %WH_UseCSpace%
		GuiControl,, WH_UseOptHK,% !WH_UseCSpace
		
		GuiControlSet("Win_Hide_Show|Gesture_WH_enabled|transp_slider|WH_fade"
				,"","Enable" Win_Hide_Enabled,2,0)

;~  Memos sets
		GuiControlSet("MemoGestureEdit",GetMemosGesture(),"",2)	
		Gesture_Memos_enabled := OptGet("Gesture_Memos_enabled")
		if Gesture_Memos_enabled not in 0,1
			Gesture_Memos_enabled := DEFAULT_GESTURES_STATE
		GuiControlSet("Gesture_Memos_enabled",Gesture_Memos_enabled,"",2)
		GuiControlSet("MemosShowInMain|Gesture_Memos_enabled|OTM_bg_default_color|OTM_t_default_color|MemosDelConfirm|OTM_default_font"
				,"","Enable" Memos_On,2,0)

;####################################################################################### Back up
	Gui, Tab, 7,1 ;Back up
	Gui, Add, button,section Y+20 W60 h25 Center gsaveBackup vsv_bck, Save...
	Gui, Add, text, yp x+10 w200, Allow you to save all menu shortcuts settings
	Gui, Add, button,xs W60 h25 Center grestoreBackup vrst_bck, Restore...	
	Gui, Add, text, yp x+10 w200, Restores previously saved shortcuts settings
	
	;############################################################################################# SETTINGS CHECK
	IsTrayHidden := OptGet("HideTrayIcon")
	if (IsTrayHidden = 1)
		GuiControl,, IsTrayHidden, 1
	;###############################
	HideAddChange := OptGet("HideAddChange")
	if (HideAddChange = 1)
		GuiControl,, IsShowAdd, 1
	;#############################################################################################
	smenu := OptGet("smenu_on")
	if (smenu = 1)
		GuiControl,,SMenus,1
	;############################################################################################# GUI SHOW
	Gui, -0x10000 -0x20000
	GUi, +LastFoundExist
	WinGet, options_gui_hwnd, ID
	GuiControl,Focus,Options_TV
	Gui 1:+LastFoundExist
	WinGetPos, X, Y, W, H,% "AHK_ID " WinExist()
	Gui, show,% "x" . round(x+w/2-320) . " y" . round(y+h/10) . " AutoSize", Settings
	return
	
	mgSetCmdRelative:
	mgSetIconRelative:
		Gui, +OwnDialogs
		value := GuiControlGet( A_GuiControl, 2 )
		if value
		{
			MsgBox,52,Confirmation,Enabling this option allow you do not bother about making relative paths for icons/commands and let Quick Cliq to do all automatically.`n`nThis can be very useful if you use Quick Cliq from portable device and most of your shortcuts related to programs on this device.`nHowever, if you'll move Quick Cliq's executable from one place to another, all such commands/icons will stop work.`n`nEnable it only if you sure what you doing.`nTurn ON?
			IfMsgBox, No
			{
				GuiControlSet( A_GuiControl, 0, "", 2 )
				return
			}
		}
		if InStr( A_GuiControl, "Icon" )
			opt[ "IconRelativePath" ] := value
		else
			opt[ "CmdRelativePath" ] := value
		return
	
	ChangeHotkey_Main:
	ChangeHotkey_Memos:
	ChangeHotkey_Clips:
	ChangeHotkey_Recent:
	ChangeHotkey_Windows:
	ChangeHotkey_WinHide:
		lbl := A_ThisLabel
		if instr(lbl,"Main") {
			hk := GetMainHotkey(),hkopt := "HotKeyString",hkdef := MAIN_DEFAULT_HOTKEY
			hkvar := "MainHK",hklbl := "OpenMenu"
		}
		else if instr(lbl,"Memos") {		
			hk := GetMemosHotkey(),hkopt := "Memos_Hotkey",hkdef := MEMOS_DEFAULT_HOTKEY
			hkvar := "MemoHK",hklbl := "ShowMemos"
		}
		else if instr(lbl,"Clips") {
			hk := GetClipsHotkey(),hkopt := "ClipXHotkey",hkdef := CLIPX_DEFAULT_HOTKEY
			hkvar := "ClipsHK",hklbl := "ShowClipsMenu"
		}
		else if instr(lbl,"Recent") {
			hk := GetRecentHotkey(),hkopt := "Recent_Hotkey",hkdef := DEFAULT_RECENT_HOTKEY
			hkvar := "RecentHK",hklbl := "ShowRecent"
		}
		else if instr(lbl,"Windows") {
			hk := GetWindowsHotkey(),hkopt := "Win_Hide_Show_Hotkey",hkdef := WIN_HIDE_DEFAULT_HOTKEY
			hkvar := "WinHK",hklbl := "ShowWinHideMenu"
		}
		else if instr(lbl,"WinHide") {
			hk := GetHideAWindowHotkey(),hkopt := "Hide_OptionalHotkey",hkdef := HIDE_WINDOW_DEFAULT_HOTKEY
			hkvar := "WinHideHK",hklbl := "Win_Hotkey_Ex"
		}
		new_hk := CustomHotkey_EditGUI(hk,2,"Change Hotkey")
		if (new_hk == hk)
			return
		if (new_hk = "#" || new_hk = "") {
			new_hk := hkdef
		}
		OptSet(hkopt,new_hk)
		Hotkey(hk,0,hklbl)
		GuiControlSet( hkvar, new_hk ? HotkeyToString(new_hk) : "None", "", 2 )
		return
	
	ChangeGuiThemeState:
		Gui,+OwnDialogs
		value := GuiControlGet("ThemeState")
		SetGuiThemeState(value)
		MsgBox,68,Quick Cliq restart required,Quick Cliq requires a restart to change this option..`nDo you want to restart now?
		IfMsgBox,Yes
		{
			Exit_NoNotify = 1
			Reload
			ExitApp
		}
		return
	
	ChangeOptShowTlp:
		value := GuiControlGet("MenuOptShowTlp")
		SetOptShowTlp(value)
		return
	
	ChangeOptColBreak:
		value := GuiControlGet("MenuOptColBreak")
		SetOptBarBreak(value)
		value =	
		return
	
	ChangeMenuMaxPerCol:
		value := GuiControlGet("MenuMaxPerCol")
		SetOptMaxPerColumn(value)
		value =	
		return
	
	ChangeOptUseColumns:
		value := GuiControlGet("MenuOptUseColumns")
		SetOptUseColumns(value)
		GuiControlSet("MenuMaxPerCol|MenuOptColBreak","","Enabled" . value,"",0)
		value =		
		return
	
	ItemsHeight_Change:
		value := GuiControlGet("ItemsHeight_slider")
		SetItemsHeight(value)
		GuiControlSet("ItemsHeight_label","+" . value)
		value =
		return
	
	ChangeOptIconsOnly:
		value := GuiControlGet("MenuOptIconsOnly")
		SetOptIconsOnly(value)
		GuiControlSet("MenuOptShowTlp","","Enabled" . value,"",0)
		value =
		return
	
	ClipsModifyHotkeysChanged:
		clips_copy := GuiControlGet("CC_Ctrl") . GuiControlGet("CC_Alt") . GuiControlGet("CC_Shift") . GuiControlGet("CC_Win")
		clips_append := GuiControlGet("CA_Ctrl") . GuiControlGet("CA_Alt") . GuiControlGet("CA_Shift") . GuiControlGet("CA_Win")
		clips_paste := GuiControlGet("CP_Ctrl") . GuiControlGet("CP_Alt") . GuiControlGet("CP_Shift") . GuiControlGet("CP_Win")
		;checking checkboxes
		GuiControlSet("CC_Ctrl|CC_Alt|CC_Shift|CC_Win|CA_Ctrl|CA_Alt|CA_Shift|CA_Win|CP_Ctrl|CP_Alt|CP_Shift|CP_Win|CP|CC|CA",""," +cNavy","",0)		;return back default color first
		Clips_HotkeysError := 0
		if (clips_copy == clips_append  && clips_copy != "0000")	;we able to have "empty" hotkeys, in which way they will just not be set
		{
			GuiControlSet("CC_Ctrl|CC_Alt|CC_Shift|CC_Win|CA_Ctrl|CA_Alt|CA_Shift|CA_Win|CC|CA",""," +cRed","",0)									;sets red color for similar hotkeys
			Clips_HotkeysError := 1
		}
		else if (clips_copy == clips_paste && clips_copy != "0000")
		{
			GuiControlSet("CC_Ctrl|CC_Alt|CC_Shift|CC_Win|CP_Ctrl|CP_Alt|CP_Shift|CP_Win|CC|CP",""," +cRed","",0)
			Clips_HotkeysError := 1
		}
		if (clips_append == clips_paste && clips_append != "0000")
		{
			GuiControlSet("CA_Ctrl|CA_Alt|CA_Shift|CA_Win|CP_Ctrl|CP_Alt|CP_Shift|CP_Win|CA|CP",""," +cRed","",0)
			Clips_HotkeysError := 1
		}
		Clips_HotkeysModified := 1			;we will use it in exit sub to avoid too many ini writings on each hotkeys change
		if (substr(A_GuiControl,1,2) = "CC")
			Clips_CopyHotkey := (GuiControlGet("CC_Win") ? "#" : "") . (GuiControlGet("CC_Ctrl") ? "^" : "") . (GuiControlGet("CC_Shift") ? "+" : "") . (GuiControlGet("CC_Alt") ? "!" : "")
		if (substr(A_GuiControl,1,2) = "CA")
			Clips_AppendHotkey := (GuiControlGet("CA_Win") ? "#" : "") . (GuiControlGet("CA_Ctrl") ? "^" : "") . (GuiControlGet("CA_Shift") ? "+" : "") . (GuiControlGet("CA_Alt") ? "!" : "")
		if (substr(A_GuiControl,1,2) = "CP")
			Clips_PasteHotkey := (GuiControlGet("CP_Win") ? "#" : "") . (GuiControlGet("CP_Ctrl") ? "^" : "") . (GuiControlGet("CP_Shift") ? "+" : "") . (GuiControlGet("CP_Alt") ? "!" : "")
		clips_copy := clips_append := clips_paste := ""
		return
	
	ChangeLightMenuState:
		SetLightMenu(GuiControlGet("LightMenu",2))
		return
	
	TempGestDisChange:
		SetTGNotifyState(GuiControlGet("TempGestDis",2))
		return
	
	SuspendItemChange:
		SetSuspendItemState(GuiControlGet("SuspendItem",2))
		return
	
	QuickHelpItemChange:
		SetHelpItemState(GuiControlGet("QuickHelpItem",2))
		return
	
	Set_Gesture_Disable_Time:
	GuiControlGet, Value,, %A_GuiControl%
	if (Value < 5)
		Value := 5
	OptSet("Gesture_Disable_Time",Value . "000")
	Return
	

	RecentOptions:
		Gui, +OwnDialogs
		GuiControlGet, value,,%A_GuiControl%
		if (A_GuiControl = "RecentSwitcher")
		{
			local st := SetRecentState(value)
			GuiControlSet("RecentShowInMain|RecentGestureState|LogFolders|LogProcs|RC_CountLabel|RC_CountEdit|RC_CountUpDown|LogWinRecent|LogRecentShortcuts","","Disabled" . !st,"",0)
			return
		}
		else if (A_GuiControl = "RecentShowInMain")
		{
			SetRecentSubState(value)
			return
		}
		else if (A_GuiControl = "RecentGestureState")
		{
			SetRecentGestureState(value)
			return
		}
		else if (A_GuiControl = "LogFolders")
		{
			if A_OSVersion in WIN_XP,WIN_2003,WIN_2000
				if (value = 1 && !GetAddressStateXP())
				{
					MsgBox,52,Display Full Address?, In order for this feature to work in XP you should have the option `n"Display the full path in the address bar" enabled`n`nWould you like to enable that now?
					IfMsgBox,Yes
						SetAddressStateXP()
					else
					{
						GuiControlSet("LogFolders",0)
						Return
					}
				}
			SetRecentLogFoldersState(value)
			FoldersTracker(value)
			return
		}
		else if (A_GuiControl = "LogProcs")
		{
			if (value = 1)
			{
				msgbox,68,Recent processes functioning notes,
				(
Enabling this feature will allow Quick Cliq to log any closed process even if it wasn't closed by you manually.`n`nWould you like to enable this? 
				)
				IfMsgBox,Yes
				{
					SetRecentLogProcsState(value)
					EnableDeleteNotification()
				}
				else
					GuiControlSet("LogProcs",0)
			}
			else
			{
				SetRecentLogProcsState(value)
				StopClProcNotify()
			}
			return
		}
		else if (A_GuiControl = "RC_CountUpDown" || A_GuiControl = "RC_CountEdit")
		{
			if (value > RC_MAXITEMS)
			{
				GuiControlSet("RC_CountUpDown",RC_MAXITEMS)
				SetRCItemsCount(RC_MAXITEMS)
			}
			else if (value < RC_MINITEMS)
			{
				GuiControlSet("RC_CountUpDown",RC_MINITEMS)	
				SetRCItemsCount(RC_MINITEMS)
			}
			else
				SetRCItemsCount(value)
			return
		}
		else if (A_GuiControl = "LogWinRecent")
		{
			SetRecentWinLog(value)
			WindowsRecentTracker(value)
			if value
				CheckWindowsRecent(1)
		}
		else if (A_GuiControl = "LogRecentShortcuts")
		{
			SetRecentLogShortcuts(value)
		}
		return

	ChangeMD:
		GuiControlGet, MiltiDelayEd,, MiltiDelayEd
		If (MiltiDelayEd > 10000)
			GuiControl,,MiltiDelayEd, 10000
		return

	menus_trans_change:
		GuiControlGet,menus_trans,,menus_trans
		GuiControl,,menus_trans_cnt,%menus_trans%
		SetMenusTrans(menus_trans)
		return

	ChangeGlobalGestureButton:
		GuiControlGet, set,,GlobalGestureButton
		If (set = "Right Mouse Button")
			OptSet("GlobalGestureButton","RButton")
		If (set = "Middle Mouse Button")
			OptSet("GlobalGestureButton","MButton")
		If (set = "Mouse 3")
			OptSet("GlobalGestureButton","XButton1")
		If (set = "Mouse 4")
			OptSet("GlobalGestureButton","XButton2")
		Return

	SMenusCB:
		GuiControlGet, smenu,,SMenus
		if (CheckSMenuRegs(smenu) = "Nope")
			{
				GuiControl,, SMenus, 0
				return
			}
		OptSet("smenu_on",smenu)
		Return

	AutoUpdatesCB:
		GuiControlGet,AutoUpdates,,AutoUpdates
		OptSet("AutoUpdates",AutoUpdates)
		return

	WH_fadechange:
		OptSet("WH_fade",GuiControlGet("WH_fade"))
		return

	transp_changed:
		GuiControlGet,transparent_level,,transp_slider
		GuiControl,,transparent_level,%transparent_level%
		OptSet("transparent_level",transparent_level)
		return

	MemosOptions:
	if (A_GuiControl = "Memos_On")
	{
		Memos_On := GuiControlGet("Memos_On",2)
		OptSet("Memos_On",Memos_On)
		GuiControlSet("MemosShowInMain|Gesture_Memos_enabled|OTM_bg_default_color|OTM_t_default_color|MemosDelConfirm|OTM_default_font"
						,"","Enable" Memos_On,2,0)
	}
	if (A_GuiControl = "MemosShowInMain")
	{
		GuiControlGet, MemosShowInMain,, MemosShowInMain
		OptSet("MemosShowInMain",MemosShowInMain)
	}
	if (A_GuiControl = "OTM_t_default_color" || A_GuiControl = "OTM_bg_default_color")
	{
		changing_color := OptGet(A_GuiControl)
		changing_color := "0x" . changing_color
		if changing_color is not Xdigit
			changing_color = 0
		if Dlg_Color(changing_color, options_gui_hwnd)
		{
			StringTrimLeft,changing_color,changing_color,2
			OptSet(A_GuiControl,changing_color)
		}
	}
	if (A_GuiControl = "OTM_default_font")
	{
		OTM_GetDefaultFont(OTMFontName,OTMStyles)
		if Dlg_Font(OTMFontName, OTMStyles, ChoosedColor,false, options_gui_hwnd)
			OTM_SaveFontAsDefault(OTMFontName,OTMStyles)
	}
	if (A_GuiControl = "MemosDelConfirm")
	{
		GuiControlGet, MemosDelConfirm,,MemosDelConfirm
		OptSet("MemosDelConfirm",MemosDelConfirm)
	}
		return
	
	GestureEnable:
		GuiControlGet, checkbox_state,,%A_GuiControl%
		Guicontrol, Enable%checkbox_state%, %A_GuiControl%_edit
		OptSet(A_GuiControl,checkbox_state)
		checkbox_state = 
	Return

	ChangeDefaultHotkeys:
		gui, 3:default
		gui, +owner2
		Gui, 2:+Disabled
		if global_NoGuiTheme
			Gui,-Theme
		Gui, Add, Checkbox, vctrl_rb gOnDefaultHotkeyChange, Ctrl + Right Mouse Button
		Gui, Add, Checkbox, vctrl_mb gOnDefaultHotkeyChange, Ctrl + Middle Mouse Button
		Gui, Add, Checkbox, vlb_rb gOnDefaultHotkeyChange, Left + Right Mouse Button
		;############### options checking
		ctrl_rb := OptGet("DefaultHotkey_ctrl_rb")
		if (ctrl_rb = 1)
			GuiControl,,ctrl_rb,1
		ctrl_mb := OptGet("DefaultHotkey_ctrl_mb")
		if (ctrl_mb = 1)
			GuiControl,,ctrl_mb,1
		lb_rb := OptGet("DefaultHotkey_lb_rb")
		if (lb_rb = 1)
			GuiControl,,lb_rb,1
		;################################
		Gui, -0x10000 -0x20000 ;removing maximize,minimize buttons
		Gui, Show,,Default Hotkeys
		return
		
	3GuiClose:
		Gui, 2:-Disabled
		Gui, 3:Destroy
		return
	
	GestureChange:
		GuiControlGet, Edit_Content,,%A_GuiControl%
		GuiControlGet, controlCNN, Focus
		Loop, Parse, Edit_Content
			{
				if A_LoopField not in L,R,U,D
					{
						ControlSend, %controlCNN%, {BS}
						Test_Letter = 
						Return
					}
				If Test_Letter
					{
						If A_LoopField = %Test_Letter%
							{
								ControlSend, %controlCNN%, {BS}
								Test_Letter = 
								Return
							}
					}
				Test_Letter := A_LoopField
			}
		Test_Letter = 
		if (A_GuiControl = "MainGestureEdit")
			OptSet("MainGesture",edit_content)
		else if (A_GuiControl = "ClipsGestureEdit")
			OptSet("ClipXGesture",edit_content)
		else if (A_GuiControl = "WinGestureEdit")
			OptSet("Win_Hide_Gesture",edit_content)
		else if (A_GuiControl = "MemoGestureEdit")
			OptSet("Memos_Gesture",edit_content)
		else if (A_GuiControl = "Recent_Gesture")
			SetRecentGesture(edit_content)
		Return

	WinHide_SetHotkey:
		GuiControlSet("WH_UseOptHK",1,"",2)
		gosub,WH_UseCSpace_CB
		return

	WH_UseCSpace_CB:
		GuiControlGet, WH_UseCSpace,,WH_UseCSpace
		
		if (WH_UseCSpace = 1)
		{
			Hotkey(GetHideAWindowHotkey(),0,"Win_Hotkey_Ex")
			Hotkey("^Space",1,"Win_Hotkey_Ex")
		}
		else
		{
			Hotkey("^Space",0,"Win_Hotkey_Ex")
			Hotkey(GetHideAWindowHotkey(),1,"Win_Hotkey_Ex")
		}
		OptSet("WH_UseCSpace",WH_UseCSpace)
		Return

	Win_Hide_Toggle:
		GuiControlGet, Win_Hide_Enabled, , Win_Hide_Enabled
		GuiControlSet("Win_Hide_Show|Gesture_WH_enabled|transp_slider|WH_fade"
				,"","Enable" Win_Hide_Enabled,2,0)
		OptSet("Win_Hide_Enabled",Win_Hide_Enabled)
		Return
		
	Win_Hide_Show_Toggle:
		GuiControlGet, Temp, , Win_Hide_Show
		OptSet("Win_Hide_Show",temp)
		Temp = 
		Return
	
	OnDefaultHotkeyChange:
		OptSet("DefaultHotkey_" . A_GuiControl, GuiControlGet( A_GuiControl, 3 ) )
		return
	
	ClipXFeatures:
		if (A_GuiControl = "ClipXSwitcher")
		{
			GuiControlGet, ClipXSwitcher,,ClipXSwitcher
			OptSet("ClipXEnabled",ClipXSwitcher)
			GuiControlSet("ClipXShowInMain|Gesture_Clipx_enabled|ClipsSaveOnExit"
				,"","Enable" ClipXSwitcher,2,0)
			if (ClipXSwitcher = 1 && GuiControlGet("ClipsSaveOnExit"))
				RestoreClips()
		}
		if (A_GuiControl = "ClipXShowInMain")
		{
			GuiControlGet, ClipXShowInMain,,ClipXShowInMain
			OptSet("ClipXShowInMain",ClipXShowInMain)
		}
		if (A_GuiControl = "Gesture_Clipx_enabled")
		{
			GuiControlGet, Gesture_Clipx_enabled,,Gesture_Clipx_enabled
			OptSet("Gesture_Clipx_enabled",Gesture_Clipx_enabled)		
		}
		if (A_GuiControl = "ClipsSaveOnExit")
			SetClipsSave(GuiControlGet("ClipsSaveOnExit",2))
		return
	
	OptionsTreeEvents:
		;~ Critical
		Gui, 2:Default
		if (A_GuiEvent == "S")
		{
			TV_Modify(TV_SelectedItemID,"-Bold")
			TV_SelectedItemID := A_EventInfo
			SendMessage( Options_TV_hwnd, 0x110B, 0x8, A_EventInfo )		; Show a focus independent selection over item; TVM_SELECTITEM := 0x110B,	TVGN_DROPHILITE := 0x8
			TV_Modify(TV_SelectedItemID,"+Bold")
			TV_GetText(SelectedItemName,TV_SelectedItemID)
			if (SelectedItemName != "Features")
			{
				GuiControl,% "Show" (SelectedItemName = "Gestures/Hotkeys" ? 1 : 0),HK_GS_TabControl
				sleep 1			;the sacral method to fix bugs
				GuiControl,% "Show" (SelectedItemName = "Main Menu" ? 1 : 0),MM_Tab
				GuiControl, ChooseString, TabControl, %SelectedItemName%
			}
			GuiControl,MoveDraw,Options_TV
			GuiControl,MoveDraw,TabControl
		}	
		return
	
	TabClicked:
		;~ Critical
		Gui, 2:Default
		GuiControlGet, TabControl,, TabControl
		GuiControl,% "Show" (TabControl = "Gestures/Hotkeys" ? 1 : 0),HK_GS_TabControl
		sleep 1			;the sacral method to fix bugs
		GuiControl,% "Show" (TabControl = "Main Menu" ? 1 : 0),MM_Tab
		SelectedItemID_opt := 0
		Loop
		{
			SelectedItemID_opt := TV_GetNext(SelectedItemID_opt,"F") ;rolling over tha entire tree looking for name of selected tab
			if !SelectedItemID_opt
				break
			TV_GetText(SelectedItemName,SelectedItemID_opt)
			if (SelectedItemName == TabControl)
			{
				TV_Modify(SelectedItemID_opt,"Select Vis") ;set selection on item in tree view	
				break
			}
		}
		free(SelectedItemID_opt)
		GuiControl,MoveDraw,Options_TV
		GuiControl,MoveDraw,TabControl
		return
	
	;############################### DONE SETTINGS
	AcceptSettings:
	Gui, submit, nohide
	Gui, 2:+OwnDialogs
	SetMultiDelay(MiltiDelayEd)

	if (Clips_HotkeysModified = 1)
		if (Clips_HotkeysError != 1)
		{
			Clips_CopyHotkey != 0 ? Clips_SetCopyHK(Clips_CopyHotkey) :
			Clips_AppendHotkey != 0 ? Clips_SetAppendHK(Clips_AppendHotkey) :
			Clips_PasteHotkey != 0 ? Clips_SetPasteHK(Clips_PasteHotkey) :
		}
		else
		{
			MsgBox, 308, Incorrect "Clips" hotkeys, Clips manupulating hotkeys cannot be the same.`n`nIf you press "Yes", the hotkeys will stay unchanged. Do you want to continue?
			IfMsgBox, No
				return			
		}
	
	is_hotkeys_errors := HotkeysCompare()
	if is_hotkeys_errors
	{
		MsgBox, 308, Using of similar hotkeys, Some of your hotkeys/mouse gestures are the same:`n%is_hotkeys_errors% `n`nDo you want to continue anyway?
		IfMsgBox, No
			return
	}
	GoTo,CloseOptionsGui
	return

	;###############################
	CloseOptionsGui:
	2GuiClose:
	2GuiEscape:
	Gui, 1:-Disabled
	Gui, Destroy
	Gui, 3:Destroy
	Gui 1:Default
	Gui 1:+LastFoundExist
	TV_SelectedItemID := SelectedItemName := ""
	IfWinExist
		WinActivate
	return

	;############################### HIDE TRAY BOX
	HideTrayBox:
	GuiControlGet, IsTrayHidden,,IsTrayHidden
	OptSet("HideTrayIcon",IsTrayHidden)
	If IsTrayHidden
		Menu, Tray, NoIcon
	else
		Menu, Tray, Icon
	return

	;############################### HIDE ADD/CHANGE
	AddChange:
	GuiControlGet, IsShowAdd,,IsShowAdd
	OptSet("HideAddChange",IsShowAdd)
	return
	;############################### START UP
	StartUpSet:
	val := GuiControlGet("RunOnStartup")
	SetStartup(val)
	SetStartupShortcut(val)
	return

	;############################### IconSize
	iconSizeChanged:
	GuiControlGet,sizeddl,,sizeddl
	SetIconSize(sizeddl)
	return
	;############################### ADD CONTX
	addContxChange:
	val := GuiControlGet("addcontx")
	GuiControlSet("addcontx",SetQCContext(Context_Reg(val)))
	return
	;############################### SAVEBACKUP
	saveBackup:
	Gui, 2:+OwnDialogs
	FileSelectFile, backuppath, S18, menu_items.ini, Choose where to save backup
	if backuppath
		FileCopy, %MENUITEMSINI%,%backuppath%, 1
	return

	restoreBackup:
	Gui, 2:+OwnDialogs
	FileSelectFile, backuppath, 1,, Choose %MB_NAME%'s backup file, *.ini
	if backuppath
	{
		FileCopy, %backuppath%,%MENUITEMSINI%, 1
		BuildTree(0,MAIN_SECTION_NAME,1)
	}
	return	
	
}

