﻿;######################## Adding context option to explorer
Context_Reg(Toggle="") {
	global CONTX_MENU
	if (Toggle="")
		Toggle := GetQCContext(),force := 0
	else
		force := 1
	;the force var indicate whether user took an action or it is just automatic check (on gui creation for example)
	;if second, then no warnings in case of errors will be shown
	if (Toggle = 1)
	{
		RegRead, ComName, HKEY_CLASSES_ROOT, Directory\shell\QC
		RegRead, ComName1, HKEY_CLASSES_ROOT, Directory\Background\shell\QC
		RegRead, ComName2, HKEY_CLASSES_ROOT, *\shell\QC
		RegRead, WayTo, HKEY_CLASSES_ROOT, Directory\shell\QC\command
		pa1 = `"%A_ScriptFullPath%`" `"-a`" `"`%1`"
		RegRead, WayTo1, HKEY_CLASSES_ROOT, Directory\Background\shell\QC\command
		pa2 = `"%A_ScriptFullPath%`" `"-a`" `"`%V`"
		RegRead, WayTo2, HKEY_CLASSES_ROOT, *\shell\QC\command
		if (ErrorLevel OR WayTo != pa1 OR WayTo1 != pa2 OR WayTo2 != pa1 OR ComName != CONTX_MENU OR ComName1 != CONTX_MENU OR ComName2 != CONTX_MENU)
		{
			if (!A_IsAdmin && A_IsCompiled)
			{
				if !force
					return 0
				MsgBox, 52, Run As Admin?, Quick Cliq requires admin privileges for this action.`nDo you want to proceed?
				IfMsgBox, No
					Return 0
				API_ShellExecute(A_ScriptFullPath,"ResetAsAdmin_On", A_ScriptDir,"RUNAS")
				Return 1
			}
			RegDelete, HKEY_CLASSES_ROOT, Directory\shell\QC
			RegDelete, HKEY_CLASSES_ROOT, Directory\Background\shell\QC
			RegDelete, HKEY_CLASSES_ROOT, *\shell\QC
			
			RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\shell\QC,,%CONTX_MENU%
			RegWrite, REG_EXPAND_SZ, HKEY_CLASSES_ROOT, Directory\shell\QC,Icon,`"%A_ScriptFullPath%`"
			RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\shell\QC\command,, `"%A_ScriptFullPath%`" `"-a`" `"`%1`"
			RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\Background\shell\QC,,%CONTX_MENU%
			RegWrite, REG_EXPAND_SZ, HKEY_CLASSES_ROOT, Directory\Background\shell\QC,Icon,`"%A_ScriptFullPath%`"
			RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Directory\Background\shell\QC\command,, `"%A_ScriptFullPath%`" `"-a`" `"`%V`"
			RegWrite, REG_SZ, HKEY_CLASSES_ROOT, *\shell\QC,,%CONTX_MENU%
			RegWrite, REG_EXPAND_SZ, HKEY_CLASSES_ROOT, *\shell\QC,Icon,`"%A_ScriptFullPath%`"
			RegWrite, REG_SZ, HKEY_CLASSES_ROOT, *\shell\QC\command,, `"%A_ScriptFullPath%`" `"-a`" `"`%1`"		
		}
	}
	else
	{
		RegRead, ComName, HKEY_CLASSES_ROOT, Directory\shell\QC
		RegRead, ComName1, HKEY_CLASSES_ROOT, Directory\Background\shell\QC
		RegRead, ComName2, HKEY_CLASSES_ROOT, *\shell\QC
		if (ComName != "" || ComName1 != "" || ComName2 != "")
		{
			if (!A_IsAdmin && A_IsCompiled)
			{
				if !force
					return 1
				MsgBox, 52, Run As Admin?, Quick Cliq requires admin privileges for this action.`nDo you want to proceed?
				IfMsgBox, No
					Return 1
				API_ShellExecute(A_ScriptFullPath,"ResetAsAdmin_Off", A_ScriptDir,"RUNAS")
				Return 0
			}
			RegDelete, HKEY_CLASSES_ROOT, Directory\shell\QC
			RegDelete, HKEY_CLASSES_ROOT, Directory\Background\shell\QC
			RegDelete, HKEY_CLASSES_ROOT, *\shell\QC
		}
	}
	return Toggle
}

SetStartupShortcut(mode = "") ;mode 1 to set, 0 to delete
{
	global MB_NAME
	IfExist,%A_Startup%\%MB_NAME%.lnk
		FileDelete, %A_Startup%\%MB_NAME%.lnk
	if (mode = "")
		mode := GetStartup()
	if (mode = 1)
		RegWrite,REG_SZ,HKCU,Software\Microsoft\Windows\CurrentVersion\Run,Quick Cliq,"%A_ScriptFullPath%"
	else
		RegDelete,HKCU,Software\Microsoft\Windows\CurrentVersion\Run,Quick Cliq
	return
}