﻿IsWindowVisible(Window_Handle)
{
    return DllCall("IsWindowVisible", "Ptr", Window_Handle)
}

IsWindowEnabled(Window_Handle)
{
    return DllCall("IsWindowEnabled", "Ptr", Window_Handle)
}

IsWindow(Window_Handle)
{
    return DllCall("IsWindow", "Ptr", Window_Handle)
}

ShowWindow(Window_Handle)
{
    return DllCall("ShowWindow", "Ptr", Window_Handle, "Uint", 5)
}

HideWindow(Window_Handle)
{
	return DllCall("ShowWindow", "Ptr", Window_Handle, "Uint", 0)
}

WinGetPos( handle )
{
	DetectHiddenWindows, On
	WinGetPos, X, Y, W, H, ahk_id %handle%
	DetectHiddenWindows, OFF
	return  "x" X " y" Y " w" W " h" H
}

;############################### GET ICON HANDLE OF WINDOW
WinGetIcon( hWindow, size ) 
{	
	Winget, WinPID, PID, AHK_ID %hWindow%
	IconHandle := SendMessage( hWindow, 0x7F, 0, 0 )
	;~ SendMessage, 0x7F, 0,0,,AHK_ID %hWindow% ;WM_GETICON = 0x7F
	;~ if (ErrorLevel = "FAIL")
		;~ return
	;~ IconHandle := ErrorLevel
	if (IconHandle == 0)
		IconHandle := GetModuleFileNameEx( WinPID ) . ":0"
	else
		IconHandle := IconCopy( IconHandle, size, 1, 0 )
	if ( StrLen( IconHandle ) < 4 )
		return "shell32.dll:34"
	else
		return IconHandle
}