﻿TV_GetIconIndex( hTV, itemID )
{
    TV_FIRST := 0x1100
	TVM_GETITEMW := (TV_FIRST + 62)

	TVIF_IMAGE			:= 0x0002
	TVIF_HANDLE			:= 0x0010
	
	;~ typedef struct tagTVITEMEX {
  ;~ UINT      mask;					uint		0
  ;~ HTREEITEM hItem;					ptr			ptr
  ;~ UINT      state;					uint		2ptr
  ;~ UINT      stateMask;				uint		4+2ptr
  ;~ LPTSTR    pszText;					ptr			8+2ptr
  ;~ int       cchTextMax;				uint		8+3ptr
  ;~ int       iImage;					uint		12+3ptr
  ;~ int       iSelectedImage;			uint		16+3ptr
  ;~ int       cChildren;				uint		20+3ptr
  ;~ LPARAM    lParam;					ptr(uint)	24+3ptr
  ;~ int       iIntegral;				uint		24+4ptr
;~ #if (_WIN32_IE >= 0x0600)		
  ;~ UINT      uStateEx;				uint		28+4ptr
  ;~ HWND      hwnd;					ptr			32+4ptr
  ;~ int       iExpandedImage;			uint		32+5ptr
;~ #endif 
;~ #if (NTDDI_VERSION >= NTDDI_WIN7)
  ;~ int       iReserved;				uint		36+5ptr
;~ #endif 
;~ } TVITEMEX, *LPTVITEMEX;
	
	size := 36 + 5*A_PtrSize
	VarSetCapacity(TVITEMEX,size,0)
	numput(TVIF_IMAGE | TVIF_HANDLE, TVITEMEX, 0, "UInt")
	numput(itemID,TVITEMEX,A_PtrSize,"UPtr")
	SendMessage(hTV,TVM_GETITEMW,0,&TVITEMEX)
	icoIndex := numget(TVITEMEX,12+3*A_PtrSize,"Uint")
	free(TVITEMEX)
	return icoIndex
}

;############################### GET PRE ID
GetPreID( ID,Direction, ByRef PID ) {
	if (Direction == "U")
	{
		ID1 := TV_GetPrev(ID)
		ID2 := TV_GetPrev(TV_GetPrev(ID))
		ID1t := TV_GetTruePrev(ID)
		ID2t := TV_GetTruePrev(TV_GetTruePrev(ID))
		if (ID1 = 0 && ID1t = 0)
			return "ERROR"
		if (ID1 != 0 && ID1==ID1t && ID2 == 0)
		{
			PreID := 0
			PID := TV_GetParent(ID)
		}
		else if (ID1 != 0 && ID1==ID1t && ID2 != 0)
		{
			PreID := ID2
			PID := TV_GetParent(ID2)
		}
		else if (ID1 != 0 && ID1!=ID1t)
		{
			PreID := ID1t
			PID := TV_GetParent(ID1t)
		}
		else if (ID1 == 0 && ID2t == 0)
		{
			PreID := 0
			PID := TV_GetParent(ID1t)
		}
		else if (ID1 == 0 && ID2t != 0)
		{
			PreID := TV_GetPrev(ID1t)
			PID := TV_GetParent(ID1t)
		}
	}
	if (Direction == "D")
	{
		ID1 := TV_GetNext(ID)
		ID1t := TV_GetTrueNext(ID)
		if (ID1 = 0 AND TV_GetParent(ID) == 0)
			return "ERROR"
		else if (TV_GetParent(ID1t) == ID && ID1 != 0 && TV_GetChild(ID1))
		{
			PreID := 0
			PID := ID1
		}
		else if (TV_GetParent(ID1t) == ID && ID1 != 0 && !TV_GetChild(ID1))
		{
			PreID := ID1
			PID := TV_GetParent(ID1)
		}	
		else if (ID1 != 0 && ID1==ID1t && TV_Get(ID1,"Expand")==0)
		{
			PreID := ID1
			PID := TV_GetParent(ID1)
		}
		else if (ID1 != 0 && ID1==ID1t && TV_Get(ID1,"Expand")!=0)
		{
			PreID := 0
			PID := ID1
		}
		else if (ID1 == 0 && TV_Get(ID1t,"Expand")!=0)
		{
			PreID := 0
			PID := ID1t
		}
		else if (ID1 == 0 && TV_Get(ID1t,"Expand")==0)
		{
			PreID := TV_GetParent(ID)
			PID := TV_GetParent(TV_GetParent(ID))
		}
	}
	return PreID
}

;############################### TRUE NEXT ID
TV_GetTrueNext( ID ) {
	if (TV_Get(ID,"E") && TV_GetChild(ID))
		ID := TV_GetNext(ID,"F")
	else if (!TV_Get(ID,"E") && TV_GetChild(ID) && TV_GetNext(ID)!=0)
		ID := TV_GetNext(ID)
	else if (!TV_Get(ID,"E") && TV_GetChild(ID) && TV_GetNext(ID)==0)
		loop
		{
			NextID := TV_GetNext(ID,"F")
			if (ID != TV_GetParent(NextID) && TV_GetParent(ID)!=TV_GetParent(NextID))
			{
				ID := NextID
				break
			}
			else
			{
				ID := NextID
				continue
			}
		}
	else if !TV_GetChild(ID)
		ID := TV_GetNext(ID,"F")
	Return ID
}

;############################### TRUE PREV ID
TV_GetTruePrev(ID) {
	InitialID := ID
	ID := TV_GetPrev(ID)
	if !ID
		ID := TV_GetParent(InitialID)
	else if TV_GetChild(ID)
		if TV_Get(ID,"E")
		{
			IDC := TV_GetChild(ID)
			Loop
			{
				if (IDC == InitialID)
				{
					ID := PrevIDC
					break
				}
				PrevIDC := IDC
				IDC := TV_GetTrueNext(IDC)
			}
		}
	return ID
}