﻿;############################## Empty Memory into Page File
EmptyMem(PID="AHK Rocks") {
    pid:=(pid="AHK Rocks") ? DllCall("GetCurrentProcessId") : pid
    h:=DllCall("OpenProcess", "UInt", 0x001F0FFF, "Int", 0, "Int", pid)
    DllCall("SetProcessWorkingSetSize", "Ptr", h, "Int", -1, "Int", -1)
    DllCall("CloseHandle", "Ptr", h)
	return
}

;convert name like Name23 to Name24
NameGetNext(Name,Count = 3) {
	Num := SubStr(Name, 1-Count)
	if Num is Digit
	{
		StringTrimRight, Name, Name, Count
		Name := Name . ++Num
		Return Name	
	}
	else if (Count == 1)
	{
		Name := Name . "1"
		Return Name	
	}
	Else
	{
		Return NameGetNext(Name,Count-1)
	}
}

GetTimeFormat(pStandard,pFormat)
{
	FormatTime, fTime,% pStandard,% pFormat
	return fTime
}

SplashWait( mode, text = "",nGui = 1, OnTop = 1, SplashIndex = 7, DisableAfter=0 ) 
{
	static static_index,static_gui
	static_index := SplashIndex, static_gui := nGui
	if nGui
	{
		Gui, %nGui%:Default
		Gui, +OwnDialogs
		Gui, +Disabled
		Gui, +LastFoundExist
		WinGetPos, X, Y, W, H,% "AHK_ID " WinExist()
		si_pos := (x ? (" x" . (x+w/2-w/4)) : "") . (Y ? (" y" . (y+h/2-15)) : "") . " w" . (w ? w/2 : 250) . " h40"
	}
	if (mode = 1)
	{
		if !text
			text := "Please Wait..."
		if nGui
		{
			
		}
		SplashImage,%SplashIndex%:,% "FS10 B CW405871 CTffffff " (OnTop ? "" : "A") . si_pos,% text
	}
	else if (mode = 0)
		SetTimer,DSI,-5
	else if (mode = -1)	{
		SplashImage, %static_index%: Off
		if static_gui
			Gui, %static_gui%:-Disabled
	}
	if DisableAfter
		SetTimer,DSI,% "-" DisableAfter
	return
	
	DSI:
		SplashImage, %static_index%: Off
		if static_gui
			Gui, %static_gui%:-Disabled
		return
}

DTP(tlp="",to=1500)
{
	if tlp
	{
		Tooltip % tlp
		SetTimer,DTP,% "-" to
	}
	else
		SetTimer,DTP,% "-" to
	return
	
	DTP:
		ToolTip
		return
}

StrSplit(str,delim,omit="")
{
	if (strlen(delim) > 1)
	{
		StringReplace,str,str,% delim,ƒ,1 		;■¶╬
		delim = ƒ
	}
	ra := Array()
	loop, parse,str,% delim,% omit
		if (A_LoopField != "")
			ra.Insert(A_LoopField)
	return ra
}

Free(byRef var)
{
	VarSetCapacity(var,0)
	return
}

RandColor()
{
	sleep 2
	loop 6
	{
		Random, nb, 0, 15
		nb:=ChHex(nb)
		Colr := Colr . nb
	}
	return %Colr%
}

StrRemoveChars( str, chr)
{
	smb := strsplit(chr,"|",A_TAB A_Space)
	for i,char in smb
		StringReplace, str, str,% char,,1
	return str
}

/*
HLControl - function allow you to highlight specific ocntrols in window using graphical lines
	w_hwnd - HWND of the window where you like to draw lines
	hwnds - "|" delimeted list of controls hwnds which you like to highlight
	clr,clr2 - two colors for hoghlight

*/
HLControl(w_hwnd,hwnds,clr=0x0000FF,clr2=0xB73443)
{
	WinActivate,ahk_id %w_hwnd%
	Gui, +Disabled
	DC := DllCall("GetWindowDC","Ptr",w_hwnd,"UPtr") ;User32
	Pen := DllCall("CreatePen","Int",0,"Int",3,"UInt",clr,"UPtr")
	Pen2 := DllCall("CreatePen","Int",0,"Int",3,"UInt",clr2,"UPtr")
	obj_orig := DllCall("SelectObject","Ptr",DC,"Ptr",Pen,"UPtr")
	
    if !hModule := DllCall( "GetModuleHandleW", "Wstr", "Gdi32.dll", "UPtr" )
        hModule := DllCall( "LoadLibraryW", "Wstr", "Gdi32.dll", "UPtr" )
	MoveToP := DllCall("GetProcAddress", "Ptr", hModule, "Astr", "MoveToEx","UPtr")
	LineToP := DllCall("GetProcAddress", "Ptr", hModule, "Astr", "LineTo","UPtr")
	VarSetCapacity(pp,16,0)
	hwnd := StrSplit(hwnds,"|",A_Tab A_Space)
	loop, 12
	{
		sleep 10
		for i,hw in hwnd
		{
			ControlGetPos, X, Y, W, H,,% "ahk_id " hw
			DllCall(MoveToP,"Ptr",DC,"Int",X,"Int",Y,"Ptr",&pp)
			DllCall(LineToP,"Ptr",DC,"Int",X+W,"Int",Y)
			DllCall(LineToP,"Ptr",DC,"Int",X+W,"Int",Y+H)
			DllCall(LineToP,"Ptr",DC,"Int",X,"Int",Y+H)
			DllCall(LineToP,"Ptr",DC,"Int",X,"Int",Y)
		}
		sleep 100
		DllCall("SelectObject","Ptr",DC,"UInt",Mod(A_Index,2)=0 ? Pen2 : Pen)
	}
	WinSet,ReDraw,,ahk_id %w_hwnd%		;removing lines at this point
	DllCall("SelectObject","Ptr",DC,"Ptr",obj_orig)
	DllCall("DeleteObject","Ptr",Pen)
	DllCall("DeleteObject","Ptr",Pen2)
	DllCall("ReleaseDC","Ptr",w_hwnd,"Ptr",DC) ;User32

	Gui, -Disabled
	return
}

GetProcessList()
{
	d = `n  ; string separator
	s := 4096  ; size of buffers and arrays (4 KB)

	Process, Exist  ; sets ErrorLevel to the PID of this running script
	; Get the handle of this script with PROCESS_QUERY_INFORMATION (0x0400)
	h := DllCall("OpenProcess", "UInt", 0x0400, "Int", false, "UInt", ErrorLevel, "Ptr")
	; Open an adjustable access token with this process (TOKEN_ADJUST_PRIVILEGES = 32)
	DllCall("Advapi32.dll\OpenProcessToken", "Ptr", h, "UInt", 32, "PtrP", t)
	VarSetCapacity(ti, 16, 0)  ; structure of privileges
	NumPut(1, ti, 0, "UInt")  ; one entry in the privileges array...
	; Retrieves the locally unique identifier of the debug privilege:
	DllCall("Advapi32.dll\LookupPrivilegeValue", "Ptr", 0, "Str", "SeDebugPrivilege", "Int64P", luid)
	NumPut(luid, ti, 4, "Int64")
	NumPut(2, ti, 12, "UInt")  ; enable this privilege: SE_PRIVILEGE_ENABLED = 2
	; Update the privileges of this process with the new access token:
	r := DllCall("Advapi32.dll\AdjustTokenPrivileges", "Ptr", t, "Int", false, "Ptr", &ti, "UInt", 0, "Ptr", 0, "Ptr", 0)
	DllCall("CloseHandle", "Ptr", t)  ; close this access token handle to save memory
	DllCall("CloseHandle", "Ptr", h)  ; close this process handle to save memory

	hModule := DllCall("LoadLibraryW", "WStr", "Psapi.dll","UPtr")  ; increase performance by preloading the library
	s := VarSetCapacity(a, s)  ; an array that receives the list of process identifiers:
	c := 0  ; counter for process idendifiers
	DllCall("Psapi.dll\EnumProcesses", "Ptr", &a, "UInt", s, "UIntP", r)
	Loop, % r // 4  ; parse array for identifiers as DWORDs (32 bits):
	{
	   id := NumGet(a, A_Index * 4, "UInt")
	   ; Open process with: PROCESS_VM_READ (0x0010) | PROCESS_QUERY_INFORMATION (0x0400)
	   h := DllCall("OpenProcess", "UInt", 0x0010 | 0x0400, "Int", false, "UInt", id, "Ptr")
	   if !h
		  continue
	   VarSetCapacity(n, s, 0)  ; a buffer that receives the base name of the module:
	   e := DllCall("Psapi.dll\GetModuleBaseName", "Ptr", h, "Ptr", 0, "Str", n, "UInt", A_IsUnicode ? s//2 : s)
	   if !e    ; fall-back method for 64-bit processes when in 32-bit mode:
		  if e := DllCall("Psapi.dll\GetProcessImageFileName", "Ptr", h, "Str", n, "UInt", A_IsUnicode ? s//2 : s)
			 SplitPath n, n
	   DllCall("CloseHandle", "Ptr", h)  ; close process handle to save memory
	   if (n && e)  ; if image is not null add to list:
		  l .= n . d, c++
	}
	DllCall("FreeLibrary", "Ptr", hModule)  ; unload the library to free memory
	;Sort, l, C  ; uncomment this line to sort the list alphabetically
;~ 	MsgBox, 0, %c% Processes, %l%
	return, c . " Processes:`n`n" . l
}

IsUAC()
{
	RegRead,value,HKLM,Software\Microsoft\Windows\CurrentVersion\Policies\System,EnableLUA
	if ErrorLevel
		value := ErrorLevel
	return value
}

EvalMetaData(ByRef str)
{
	plain_str := GetPlainText(str)
	FormatTime, date_long,,LongDate							; Friday, February 18, 2011
	FormatTime, date_short,,ShortDate						; 2/18/2011
	FormatTime, _time,,Time									; 5:26 PM
	FormatTime, Year_Month,,YearMonth						; February, 2004 
	
	StringReplace,plain_str,plain_str,`%dl`%,%date_long%,1
		e .= errorlevel
	StringReplace,plain_str,plain_str,`%d`%,%date_short%,1
		e .= errorlevel
	StringReplace,plain_str,plain_str,`%t`%,%_time%,1
		e .= errorlevel
	StringReplace,plain_str,plain_str,`%ym`%,%Year_Month%,1
		e .= errorlevel
	StringReplace,plain_str,plain_str,`%clip`%,%Clipboard%,1
		e .= ErrorLevel
		
	if !RegExMatch(e,"^1+$")		;if e contains "1" only
		str := plain_str
	return
}

SyntaxHelp()
{
	if A_Gui
		Gui, %A_Gui%:+OwnDialogs
	MsgBox,,Syntax Help,
	(
You can use following syntax to get dynamic date, time or clipboard values when clip or memo pasted.

`%d`%	  - Short date representation, such as 02/29/04
`%dl`%	  - Long date representation, such as Friday, April 23, 2004
`%t`%	  - Current time representation, such as 5:26 PM
`%ym`%	  - Year and month format, such as February, 2004
`%clip`%	  - The contents of the system clipboard
	)
}

GetPlainText(cliptext)
{
	Clip_Hold := Clipboardall
	clipboard := cliptext
	cliptext = %clipboard%
	Clipboard := Clip_Hold
	Clip_Hold =
	return cliptext
}