﻿ClipX(MenuHandl,MColor,TColor,IconsSize=16)
{
	global
	local div
	MMenu_Destroy(clipXhandl)

	CLIP_ICON := "shell32.dll:166"
	VIEW_ICON := "shell32.dll:22"
	if A_OSVersion in WIN_XP,WIN_2003,WIN_2000
		TO_FILE_ICON := "SHELL32.dll:66"
	else
		TO_FILE_ICON := "SHELL32.dll:68"
	CLEAR_ICON := "shell32.dll:131"
	CLEAR_ALL_ICON := "shell32.dll:31"

	clipXhandl := MMenu_Create("S" . IconsSize . " O" . ICON_OFFSET . " c" . MColor . " t" . TColor,global_LightMenu)
	Loop, 9
	{
		clip_%A_Index%_handl := MMenu_Create("S" . IconsSize . " O" . ICON_OFFSET . " c" . MColor . " t" . TColor,global_LightMenu)
		MMenu_Add(clip_%A_Index%_handl, "View", VIEW_ICON, "", "iClipX_View_Clip" . A_Index)
		MMenu_Add(clip_%A_Index%_handl, "To File", TO_FILE_ICON, "", "iClipX_Save_Clip" . A_Index . " b|")
		MMenu_Add(clip_%A_Index%_handl, "Run Links", URL_ICO, "", "iClipX_Run_Links" . A_Index)
		MMenu_Add(clip_%A_Index%_handl, "Clear", CLEAR_ICON, "", "iClipX_Clear_Clip" . A_Index)
	
		MMenu_Add(clipXhandl, "Clip " . A_Index, "", "","iClipX_Clip" . A_Index . " m" . clip_%A_Index%_handl)
	}

	clipXhandl_MainClipboard := Mmenu_Create("S" . IconsSize . " O" . ICON_OFFSET . " c" . MColor . " t" . TColor,global_LightMenu)
		MMenu_Add(clipXhandl_MainClipboard, "View", VIEW_ICON, "", "iClipX_View_Clip0")
		MMenu_Add(clipXhandl_MainClipboard, "To Plain Text", "", "", "iClipX_MainClipboard_Text")
		MMenu_Add(clipXhandl_MainClipboard, "To File", TO_FILE_ICON, "", "iClipX_Save_Clip0 b|")
		MMenu_Add(clipXhandl_MainClipboard, "Run Links", URL_ICO, "", "iClipX_Run_Links0")
		MMenu_Add(clipXhandl_MainClipboard, "Clear", CLEAR_ICON, "", "iClipX_Clear_Clip0")		
		
		MMenu_Add(clipXhandl)
		MMenu_Add(clipXhandl, "System Clipboard", "", "", " m" . clipXhandl_MainClipboard)
		MMenu_Add(clipXhandl)
		MMenu_Add(clipXhandl, "Clear All", CLEAR_ALL_ICON, "", "iClipX_Clear_All")


	if (ClipXShowInMain = 1)
	{
		div := ColDiv(global_itemNum)
		MMenu_Add(MenuHandl, "Clips", CLIPX_ICO, "","i" . CLIP_X_MENU_NAME . " m" . clipXhandl . div,global_IconsOnly)
		global_itemNum++
	}
	return
}


Clip_X_CheckMenus2() {
	global
	Loop, 9
	{
		if (clip_%A_Index% != "")
			{
				MMenu_Set(clipXhandl,"ClipX_Clip" . A_Index,"",CLIP_ICON) ;add icon if clipboard not empty
				MMenu_Set(clip_%A_Index%_handl,"ClipX_Save_Clip" . A_Index,"","","-g")	;ungray menu item if clipboard not empty
				MMenu_Set(clip_%A_Index%_handl,"ClipX_Run_Links" . A_Index,"","","-g")	;ungray menu item if clipboard not empty
				MMenu_Set(clip_%A_Index%_handl,"ClipX_Clear_Clip" . A_Index,"","","-g")	;ungray menu item if clipboard not empty
			}
		else
			{
				MMenu_Set(clipXhandl,"ClipX_Clip" . A_Index,"",A_SPACE) ;remove icon if clipboard empty
				MMenu_Set(clip_%A_Index%_handl,"ClipX_Save_Clip" . A_Index,"","","g")   ;grayed menu item if clipboard empty
				MMenu_Set(clip_%A_Index%_handl,"ClipX_Run_Links" . A_Index,"","","g")   ;grayed menu item if clipboard empty
				MMenu_Set(clip_%A_Index%_handl,"ClipX_Clear_Clip" . A_Index,"","","g")	;grayed menu item if clipboard empty
			}
	}
}

Clip_X_Func(M_ID)
{
	global
	if (M_ID = "U")
	{
		If IsWindow(hClipsGUI)
		{
			WinGet, w_st, MinMax,% "ahk_id " hClipsGUI
			if (w_st != "-1")
				GoSub, Switch_Clip
		}
		return
	}
	if (M_ID = "ClipX_Clear_All")
		Gosub Clear_All
	if (M_ID = "ClipX_MainClipboard_Text")
		Gosub MainToText
	CurrentClip := SubStr(M_ID,0)
	if RegExMatch(M_ID,"ClipX_View_Clip[0-9]")
		Gosub View_Clip
	else if RegExMatch(M_ID,"ClipX_Save_Clip[0-9]")
		Gosub Save_Clip_To_File
	else if RegExMatch(M_ID,"ClipX_Clear_Clip[0-9]")
		Gosub Clear_Clip
	else if RegExMatch(M_ID,"ClipX_Run_Links[0-9]")
		Gosub Run_Links_From_Menu
	

	return
	
	MainToText:
		clipboard = %clipboard%
		DTP("The main clipboard has been converted to plain text")
		Return
	
	Clear_All:
		Loop, 9
				free(Clip_%a_index%)
		DTP("The extra clipboards have been cleared")
		Return
		
	Clear_Clip:
		if (CurrentClip = 0)
			Clipboard =
		else
			Clip_%CurrentClip% = 
		DTP(CurrentClip = 0 ? "System clipboard has been cleared" : "Clip # " . CurrentClip . " has been cleared")
		Gui, 22:+LastFoundExist
		IfWinExist
		{
			GuiControl,,Clip_Text
			GuiControl,,Clip_Text2		
		}
		Return

	Save_Clip_To_File: ;Using Save to File command while holding Ctrl will save text in original format, else as a plain text
		GuiControlGet, IsEnabled, Enabled, SaveButtonClipX
		if IsEnabled
			GoSub, Save_Clip
		ontopState := GuiControlGet("ontopControl",22)
		if ontopState
		{
			GuiControlSet("ontopControl",0,"",22)
			GoSub, ontopChange
		}
		
		if GetKeyState("Control","P")
			orig := 1
		else
			orig := 0
		
		if orig
			Save_Clip_Temp := CurrentClip = 0 ? Clipboard : clip_%CurrentClip%
		else
		{
			Save_Clip_Temp := GetPlainText(CurrentClip = 0 ? Clipboard : clip_%CurrentClip%)
			EvalMetaData(Save_Clip_Temp)
		}
		if GetKeyState("Control","P")
			FileSelectFile, OUT_FILE, s16, clip_%CurrentClip%_Original.txt
		else
			FileSelectFile, OUT_FILE, s16, clip_%CurrentClip%_Plain.txt
		If Errorlevel
			{
				Save_Clip_Temp = 
				OUT_FILE = 
				if ontopState
				{
					GuiControlSet("ontopControl",1,"",22)
					GoSub, ontopChange
				}
				Return
			}
		FileDelete, %OUT_FILE%
		if orig
			f := FileOpen(OUT_FILE,5,"CP0")
		else
			f := FileOpen(OUT_FILE,5)
		if IsObject(f)
		{
			if orig
				f.RawWrite(Save_Clip_Temp,VarSetCapacity(Save_Clip_Temp))
			else
				f.Write(Save_Clip_Temp)
		}
		else
		{
			Save_Clip_Temp = 
			OUT_FILE = 
			DTP("An error occured when saving the file.")
			if ontopState
			{
				GuiControlSet("ontopControl",1,"",22)
				GoSub, ontopChange
			}
			Return
		}
		f.Close()
		DTP((CurrentClip = 0 ? "System clipboard" : "Clip # " . CurrentClip) . " has bee saved to " . OUT_FILE,2000)
		Save_Clip_Temp = x
		OUT_FILE = 
		if ontopState
		{
			GuiControlSet("ontopControl",1,"",22)
			GoSub, ontopChange
		}		
		Return
		
	View_Clip:
		Gui, 22:Default
		ClipsGuiRunning := 1
		If IsWindow(hClipsGUI)
		{
			WinActivate, ahk_id %hClipsGUI%
			Gosub, Switch_Clip
			return
		}
		if global_NoGuiTheme
			Gui,-Theme
		Gui, 22:+LastFound
		hClipsGUI := WinExist() + 0
		OnMessage(0x200,"ShowHyperlink")
		
		Loop, 9
		{
			Gui, Add, Button, x5 w30 h30 vclip%A_Index% gSwitch_Clip, %A_Index%
		}
		Gui, Add, Button, x5 w30 h30 vclip0 gSwitch_Clip, S
		Gui, Add, Edit, x40 y5 +wrap +HScroll vClip_Text +WantReturn WantTab Multi gOnEditControlChange,% GetPlainText(CurrentClip = 0 ? Clipboard : clip_%CurrentClip%)
		Gui, Add, Edit, x40 y5 -wrap +Hidden +HScroll vClip_Text2 +WantReturn WantTab Multi gOnEditControlChange,% GetPlainText(CurrentClip = 0 ? Clipboard : clip_%CurrentClip%)
		GuiControlGet, Clip_Text_hwnd, HWND, Clip_Text
		GuiControlGet, Clip_Text2_hwnd, HWND, Clip_Text2

		;Menus
		Menu,Clips_Edit_Case,Delete
		Menu,Clips_Edit_Case,Add,Upper,Case_Up
		Menu,Clips_Edit_Case,Add,Lower,Case_Lo
		Menu,Clips_Edit_Case,Add,Sentence,Case_Sent
		Menu,Clips_Edit_Case,Add,Title,Case_Tit
		
		Menu,Clips_Edit_OtherOpts,Delete
		Menu,Clips_Edit_OtherOpts,Add,Convert to list,ConvertClip_ToList
		Menu,Clips_Edit_OtherOpts,Add,Convert to enumeration,ConvertClip_ToEnum
		Menu,Clips_Edit_OtherOpts,Add,Remove extra lines,Clip_RemLines
		Menu,Clips_Edit_OtherOpts,Add
		Menu,Clips_Edit_OtherOpts,Add,Extract Links,Get_links
		Menu,Clips_Edit_OtherOpts,Add,Run Links,Run_links
		
		Gui, Add, Button, x40 w80 h20 vChange_Case gOpenCaseMenu, Change Case
		Gui, Add, Button, x+5 w80 h20 vEdit_Opts gOpenEditMenu, Quick Edit
		
		Gui, Add, Text,x40 vFormatLabel, Format:
		Gui, Add, Radio,x+5 vPlain Group Checked gFormatChange -Wrap, Plain
		Gui, Add, Radio,x+5 vwoNulls gFormatChange -Wrap, No Nulls
		
		Gui, Add, Button, x40 h30 w100 gSave_Clip vSaveButtonClipX +Disabled, Apply Changes
		Gui, Add, Button, w40 h30 gSave_Clip_To_File vToFileButtonClipX,To File
		Gui, Add, Button, w40 h30 gClear_Clip vClearButtonClipX, Clear
		Gui, Add, Button, w50 h30 vNotepadOpen gOpenInNotepad, To Notepad
		Gui, Add, Checkbox, gwrapChange Checked vwrapControl, Word Wrap
		Gui, Add, Checkbox, gontopChange Checked vontopControl, On Top
		Gui, Add, Text, w70 h18 vURL_MetaDataHelp gOpenMetaDataHelp cBlue, Syntax Help
		Gui, +LastFoundExist
		WinSet,AlwaysOnTop,On
		Gui,Font,bold s18
		GuiControl,Font,clip%CurrentClip%
		Gui,Font,norm s8
		Gui, +Resize MinSize400x480 +LabelViewClipGUI
		Gui, Show, h480 w400,% CurrentClip = 0 ? "Viewing system clipboard" : "Viewing clip # " . CurrentClip
		
		WinActivate, Viewing clip # %CurrentClip%
		Allow_Edits_check := 1
		Return		

	Run_Links_From_Menu:
		Gui, 22:Default
		Run_Links(clip_%CurrentClip%)
		return

	Get_Links:
	Run_links:
		Gui, 22:Default
		if (A_ThisLabel = "Get_Links")
		{
			links_list := Run_Links(clip_%CurrentClip%,0)
			GuiControlSet("Clip_Text",links_list,"",22)
			GuiControlSet("Clip_Text2",links_list,"",22)
			if links_list
				GuiControl, Enable, SaveButtonClipX
			links_list =
		}
		if (A_ThisLabel = "Run_Links")
			Run_Links(clip_%CurrentClip%)
		return

	ViewClipGUISize: ;changing size of controls on resizong
		EditWidth := A_GuiWidth - 50
		EditHeight := A_GuiHeight - 120
		OtherButtonsWidth := A_GuiWidth/8 + 10
		wo_nullsX := A_GuiWidth - 4.2*OtherButtonsWidth - 15
		ToFileX := wo_nullsX + OtherButtonsWidth + 5
		ClearX := ToFileX + OtherButtonsWidth + 5
		OpenNPx := ClearX + OtherButtonsWidth + 5
		buttonsY := A_GuiHeight - 35
		Line1 := A_GuiHeight - 108
		WrapCheckBoxX := A_GuiWidth - 80
		Line2 := Line1 + 20
		Line3 := Line2 + 20
		; moving control according new gui size
		GuiControl, MoveDraw, Clip_Text, w%EditWidth% h%EditHeight%
		GuiControl, MoveDraw, Clip_Text2, w%EditWidth% h%EditHeight%
		GuiControl, MoveDraw, SaveButtonClipX, y%buttonsY%
		GuiControl, MoveDraw, ToFileButtonClipX, w%OtherButtonsWidth% x%ToFileX% y%buttonsY%
		GuiControl, MoveDraw, ClearButtonClipX, w%OtherButtonsWidth% x%ClearX% y%buttonsY%
		GuiControl, MoveDraw, wrapControl, y%Line1% x%WrapCheckBoxX%
		GuiControl, MoveDraw, NotepadOpen, y%buttonsY% x%OpenNPx% w%OtherButtonsWidth%
		GuiControl, MoveDraw, ontopControl, y%Line2% x%WrapCheckBoxX%
		GuiControl, MoveDraw, URL_MetaDataHelp, % "y" . Line3 . " x" . WrapCheckBoxX
		
		GuiControl, MoveDraw, FormatLabel,% "Y" Line1
		GuiControl, MoveDraw, Plain,% "Y" Line1
		GuiControl, MoveDraw, woNulls,% "Y" Line1
		
		GuiControl, MoveDraw, Change_Case, % "Y" Line2
		GuiControl, MoveDraw, Edit_Opts, % "Y" Line2
		
		; free memory
		EditWidth := EditHeight := OtherButtonsWidth := ToFileX := ClearX := buttonsY := WrapCheckBoxX := Line1 := Line2 := Line3 := ""
		return

	OpenMetaDataHelp:
		SyntaxHelp()
		return

	ConvertClip_ToEnum:
	ConvertClip_ToList:
	Clip_RemLines:
		Gui, 22:Default
		if (A_ThisLabel == "ConvertClip_ToList")
		{
			GuiControlSet("Clip_Text",RegExReplace(GuiControlGet("Clip_Text",22),",","`n"),"",22)
			GuiControlSet("Clip_Text2",RegExReplace(GuiControlGet("Clip_Text2",22),",","`n"),"",22)
		}
		else if (A_ThisLabel == "ConvertClip_ToEnum")
		{
			GuiControlSet("Clip_Text",RegExReplace(GuiControlGet("Clip_Text",22),"`a)`n",","),"",22)
			GuiControlSet("Clip_Text2",RegExReplace(GuiControlGet("Clip_Text2",22),"`a)`n",","),"",22)
		}
		else if (A_ThisLabel == "Clip_RemLines")
		{
			GuiControlSet("Clip_Text",RegExReplace(GuiControlGet("Clip_Text",22),"`a)`n`n+","`n"),"",22)
			GuiControlSet("Clip_Text2",RegExReplace(GuiControlGet("Clip_Text2",22),"`a)`n`n+","`n"),"",22)
		}		
		GuiControl, Enable, SaveButtonClipX		
		return

	Switch_Clip: ;used in GUI to view other clips
		Gui, 22:Default
		GuiControlGet, nClButton,, %A_GuiControl% ;getting clip number from pressed button name
		if (nClButton != "")
			CurrentClip := nClButton = "S" ? 0 : nClButton
		nClButton =
		GuiControl, Disable, SaveButtonClipX
		loop, 9
		{
			Gui,Font,norm s8
			GuiControl,Font,clip%A_Index%	
		}
		GuiControl,Font,clip0
		Gui,Font,bold s18
		GuiControl,Font,clip%CurrentClip%
		GuiControl,MoveDraw, clip%CurrentClip%
		Gui,Font,norm s8
		if GuiControlGet("Plain",22)
			ed_text := GetPlainText(CurrentClip = 0 ? Clipboard : clip_%CurrentClip%)
		else if GuiControlGet("woNulls",22)
			ed_text := RemoveNulls(CurrentClip = 0 ? Clipboard : clip_%CurrentClip%)
		Allow_Edits_check := 0
			GuiControl,,Clip_Text
			GuiControl,,Clip_Text2
			GuiControlSet("Clip_Text",ed_text,"",22)
			GuiControlSet("Clip_Text2",ed_text,"",22)
		Allow_Edits_check := 1
		ed_text := ""
		Gui, Show,,% CurrentClip = 0 ? "Viewing system clipboard" : "Viewing clip # " . CurrentClip ;changing title
		return

	OpenCaseMenu:
	OpenEditMenu:
		CoordMode, Menu, Relative
		GuiControlGet, contr_hwnd, Hwnd, %A_GuiControl%
		ControlGetPos, X, Y, W, H,, ahk_id %contr_hwnd%
		Menu,% A_ThisLabel = "OpenCaseMenu" ? "Clips_Edit_Case" : "Clips_Edit_OtherOpts",Show,% X,% (Y + H)
		CoordMode, Menu
		return
	
	Case_Up:
	Case_Lo:
	Case_Sent:
	Case_Tit:
		Gui, 22:Default
		GuiControlGet, Clip_Text,,Clip_Text
		GuiControlGet, Clip_Text2,,Clip_Text2
		if (A_ThisLabel == "Case_Up")
		{
			StringUpper, Clip_Text, Clip_Text
			StringUpper, Clip_Text2, Clip_Text2
		}
		if (A_ThisLabel == "Case_Lo")
		{
			StringLower, Clip_Text, Clip_Text
			StringLower, Clip_Text2, Clip_Text2
		}	
		if (A_ThisLabel == "Case_Tit")
		{
			StringUpper Clip_Text, Clip_Text, T
			StringUpper Clip_Text2, Clip_Text2, T
		}	
		if (A_ThisLabel == "Case_Sent")
		{
			StringLower, Clip_Text, Clip_Text
			StringLower, Clip_Text2, Clip_Text2			
			Clip_Text := RegExReplace(Clip_Text, "`a)(\.\s*.|^\s*.|`n\s*.)", "$U0")
			Clip_Text2 := RegExReplace(Clip_Text2, "`a)(\.\s*.|^\s*.|`n\s*.)", "$U0")	
		}
		GuiControl,,Clip_Text,%Clip_Text%
		GuiControl,,Clip_Text2,%Clip_Text2%
		GuiControl, Enable, SaveButtonClipX
		return
	
	OpenInNotepad:
		GuiControlGet, IsEnabled, Enabled, SaveButtonClipX
		if IsEnabled
			GoSub, Save_Clip
			
		GuiControlSet("ontopControl",0,"",22)
		GoSub, ontopChange
		
		FileDelete, %A_Temp%\clip%CurrentClip%
		
		GuiControlGet, IsVisible, Visible, Clip_Text
		if IsVisible
			GuiControlGet, Clip_Text,,Clip_Text
			
		GuiControlGet, IsVisible, Visible, Clip_Text2
		if IsVisible
			GuiControlGet, Clip_Text,,Clip_Text2

		EvalMetaData(Clip_Text)
		f := FileOpen(A_Temp . "\clip" . CurrentClip,5) ;w + 4
		if IsObject(f)
			f.Write(Clip_Text)
		f.Close()
		Run, notepad.exe %A_Temp%\clip%CurrentClip%,,UseErrorLevel
		Clip_Text =
		return
	
	OnEditControlChange:
		if !Allow_Edits_check
			return
		GuiControlGet, Clip_Text,,Clip_Text
		GuiControlGet, Clip_Text2,,Clip_Text2		
		if (A_GuiControl == "Clip_Text" && Clip_Text2!=Clip_Text)
			GuiControl,,Clip_Text2,%Clip_Text%

		if (A_GuiControl == "Clip_Text2" && Clip_Text2!=Clip_Text)
			GuiControl,,Clip_Text,%Clip_Text2%
		GuiControl, Enable, SaveButtonClipX
		return
	
	FormatChange:
		GuiControl, Disable, SaveButtonClipX
		if ( CurrentClip = 0 )
			tempClip := ClipboardAll
		else
			tempClip := clip_%CurrentClip%
		if GuiControlGet("Plain")
			ed_text := GetPlainText( tempClip )
		if GuiControlGet("woNulls")
			ed_text := RemoveNulls( tempClip )
		Allow_Edits_check := 0
		GuiControl,,Clip_Text
		GuiControl,,Clip_Text2
		GuiControlSet("Clip_Text",ed_text)
		GuiControlSet("Clip_Text2",ed_text)
		Allow_Edits_check := 1
		ed_text := ""
		free( tempClip )
		return

	ontopChange:
		Gui, 22:+LastFoundExist
		if GuiControlGet("ontopControl")
			WinSet,AlwaysOnTop,On
		else
			WinSet,AlwaysOnTop,Off			
		return

	wrapChange:
		GuiControlGet, wrapControl,, wrapControl
		if wrapControl
		{
			GuiControl, Show, Clip_Text
			GuiControl, Hide, Clip_Text2
		}
		else
		{
			GuiControl, Show, Clip_Text2
			GuiControl, Hide, Clip_Text
		}
		if ErrorLevel
			msgbox Error on changing edit controls!
		return

	ViewClipGUIEscape:
	ViewClipGUIClose:
		gui, destroy
		Clip_Text_hwnd =
		Clip_Text2_hwnd =
		SetTimer,DisMess,5000
		ClipsGuiRunning := 0
		Return

	Save_Clip:
		Gui, 22:Default
		gui, submit, nohide
		GuiControlGet, IsVisible, Visible, Clip_Text
		if IsVisible
		{
			if CurrentClip
				clip_%CurrentClip% := GuiControlGet("Clip_Text")
			else
				Clipboard := GuiControlGet("Clip_Text")
		}
		GuiControlGet, IsVisible, Visible, Clip_Text2
		if IsVisible
		{
			if CurrentClip
				clip_%CurrentClip% := GuiControlGet("Clip_Text2")
			else
				Clipboard := GuiControlGet("Clip_Text2")
		}
		GuiControl, Disable, SaveButtonClipX
		Return
}

RemoveNulls(byref string)
{
	temp := string
	Loop,% VarSetCapacity(string)/2	
	{
		dec := NumGet(temp, (A_Index-1)*2, "UShort")
		if (dec = 0)
			NumPut(32,temp, (A_Index-1)*2, "UShort") 
	}
	return temp
}

Clip_Catch(byRef clipbd) 
{
	global CurrentClip
	cliphold = %clipboardall%
	Clipboard = 
	SendInput, ^{vk43sc02E} ;ctrl+c
	ClipWait, 5, 1
	if errorlevel
	{
		DTP("No data!")
		Clipboard := cliphold
		return
	}
	free(clipbd)
	clipbd := clipboardall
	Clipboard := cliphold
	cliphold = 
	DTP("Copied to Clip " . CurrentClip,1000)
	Clip_X_Func("U")
	return
}

Clip_Send(var) 
{
	if var
	{
		EvalMetaData(var)
		cliphold = %clipboardall%
		Clipboard = %var%
		ClipWait, 2, 1
		if errorlevel
		{
			DTP("No data!",1000)
			Clipboard := cliphold
			return
		}
		SendInput,	^{vk56sc02F} ;ctrl+v
		sleep, 200
		Clipboard = %Cliphold%
		cliphold = 
	}
	Else
		DTP("Clip Empty!",1000)
	return
}

Clip_Append(byRef clipbd) 
{

	global CurrentClip
	cliphold = %clipboardall%
	Clipboard = %clipbd%
	clipbd = %Clipboard%
	Clipboard = 
	SendInput, ^{vk43sc02E} ;ctrl+c
	ClipWait, 2, 1
	if errorlevel
	{
		DTP("No data!",1000)
		Clipboard := cliphold
		return
	}
	clipbd .= "`r`n"
	clipbd .= Clipboard
	Clipboard = %Cliphold%
	cliphold =
	DTP("Text appended to Clip " . CurrentClip,1000)
	Clip_X_Func("U")
	return
}

ProcessClipsCommand( hkey )
{
	global
	CurrentClip := SubStr(hkey,0)
	if (RegExMatch(hkey,"^\Q" . cur_clips_copy_hk . "\E[1-9]$") && cur_clips_copy_hk != "")
		Clip_Catch(Clip_%CurrentClip%)
	else if (RegExMatch(hkey,"^\Q" . cur_clips_append_hk . "\E[1-9]$") && cur_clips_append_hk != "")
		Clip_Append(Clip_%CurrentClip%)
	else if (RegExMatch(hkey,"^\Q" . cur_clips_paste_hk . "\E[1-9]$") && cur_clips_paste_hk != "")
		Clip_Send(Clip_%CurrentClip%)
	return
}