﻿On_Show_All_Windows()
{
    Show_All_Hidden_Windows()
}

Get_Window_Fade_Setting()
{
    global
	fade_setting := OptGet("WH_fade")
    if fade_setting not in 0, 1
    {
        fade_setting := DEFAULT_FADE
    }
    return fade_setting
}

Show_Window(Window_Handle)
{
    WinShow, ahk_id %Window_Handle%
}

Window_Get_Class(Window_Handle) {
	WinGetClass, WinClass, AHK_ID %Window_Handle%
	Return WinClass
}

Remove_Window_From_Hidden_Windows_List(Window_Handle)
{
    global Windows_menu
    MMenu_Remove(Windows_menu, "Win_Hide_" . Window_Handle)
}


Remove_Window_From_Windows_Ini(Window_Handle)
{
    global WINDOWS_INI
    IniDelete, %WINDOWS_INI%, windows, %Window_Handle%
}


Make_Window_Opaque(Window_Handle)
{
    Set_Window_Transparency(Window_Handle, 255)
}


Make_Window_Transparent(Window_Handle)
{
    Set_Window_Transparency(Window_Handle, 0)
}


Set_Window_Transparency(Window_Handle, transparency_value)
{
    WinSet, Transparent, %transparency_value%, ahk_id %WIndow_Handle%
}


Activate_Window(Window_Handle)
{
    WinActivate, ahk_id %Window_Handle%
}