﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.

FileSelectFile,somefile,,,Choose menu_items.ini from "QuickCliq\Data\" folder,menu_items.ini
if somefile
	MENUITEMSINI := somefile
else 
	return
fix_ini("Main")
msgbox Done!

fix_ini(mName)
{
	global
	order := 0
	Loop
	{
		IniRead, IName, %MENUITEMSINI%, %MName%, %order%
		if (IName == "ERROR")
			break
		IfInString, IName, #B#
			StringReplace, IName, IName, #B#
		IfInString, IName, #M#
		{
			StringReplace, IName, IName, #M#
			sub := 1
		}
		else
			sub := 0
		If RegExMatch(IName,"^#[0-9]*$")
		{
			order++
			continue
		}
		if (sub == 1)
			fix_ini(MName . "#" . GetItemID(IName))
		else
		{
			old_id := MName . "#" . GetItemID(IName)
			new_id := MName . "#" . GetItemID_new(IName)
			IniRead, tg, %MENUITEMSINI%, Targets,% old_id
			if (tg != "" and tg != "ERROR")
			{
				IniWrite,% tg, %MENUITEMSINI%, Targets, % new_id
				IniDelete, %MENUITEMSINI%, Targets, % old_id
			}
		}
		order++
	}
	return
}

GetItemId_new(InputID)	{
	InputID := RegExReplace(InputID, "[ =]","")
	return InputID
}

GetItemId(InputID)	{

	InputID := RegExReplace(InputID, "[^a-zA-Z0-9#_@$?\[\]]*")
	return InputID
}