﻿ClEnable(ctrl_hwnd,state=1)
{
	Control,% state=1 ? "Enable" : "Disable",,, ahk_id %ctrl_hwnd%
	return state
}

ClCheck(ctrl_hwnd,state=1)
{
	Control,% state=1 ? "Check" : "UnCheck",,, ahk_id %ctrl_hwnd%
	return state
}

ClHide(ctrl_hwnd,state=1)
{
	Control,% state=1 ? "Hide" : "Show",,, ahk_id %ctrl_hwnd%
	return state
}

ClIsVisible(ctrl_hwnd)
{
	ControlGet, f, Visible,,, ahk_id %ctrl_hwnd%
	return f
}

ClIsEnabled(ctrl_hwnd)
{
	ControlGet, f, Enabled,,, ahk_id %ctrl_hwnd%
	return f
}

ClIsChecked(ctrl_hwnd)
{
	ControlGet, f, Checked,,, ahk_id %ctrl_hwnd%
	return f
}

HideFocus(guiNum)
{
	Gui,%guiNum%:+LastFound
	hwnd := WinExist()
	return SendMessage(hwnd,0x0127,0x10003,0)	;WM_CHANGEUISTATE with UIS_INITIALIZE + UISF_HIDEFOCUS
}

GuiSetFont(Control_Name,FontOptions="",FontName="",Gui="")
{
	if (Gui = "")
		Gui := A_Gui
	Gui,%Gui%:Default
	Gui, Font,% FontOptions,% FontName
	Loop, Parse, Control_Name, |, %A_Tab%%A_Space%
		GuiControl, Font,% A_Loopfield
	Gui, Font, norm
	return
}

GuiControlSet(Control_Name,Value="",Options="",Gui="",CanBeEmptyValue=1)	{	;if few control, separate them with |
	if (Gui = "")
		Gui := A_Gui
	Loop, Parse, Control_Name, |, %A_Tab%%A_Space%
	{
		if (Value != "" || CanBeEmptyValue)
			GuiControl,%GUI%:,%A_Loopfield%,%Value%
		if Options
		{
			GuiControl,% GUI ": " Options, %A_Loopfield%
			GuiControl,% GUI ": MoveDraw", %A_Loopfield%
		}
	}
	return
}

WinGetTitle( pHWND )
{
	WinGetTitle, win_title,ahk_id %pHWND%
	return win_title
}

ControlGet( c_hwnd )
{
	ControlGetText, value,,ahk_id %c_hwnd%
	return value
}

GuiControlGet(Control_Name,Gui="")	{
	if (Gui = "")
		Gui := A_Gui
	GuiControlGet,value,%Gui%:,%Control_Name%
	return value
}