﻿CustomHotkeysGui_Show()
{
	global CustomHotkeysList, MAIN_SECTION_NAME
	global CustomHK_LV, But1, But2, But3, But4, But5
	global custom_hotkey_edited, global_NoGuiTheme
	Gui, 9:Default
	Gui, +LastFoundExist
	if WinExist()
	{
		WinActivate
		return
	}
	if global_NoGuiTheme
		Gui,-Theme
	Gui,Add,ListView,xm ym w300 h500 Section vCustomHK_LV -Multi gCustomHotkeys_LV_Events,Hotkey|Target|Item_Order|Item_Section|Hotkey_orig|#
	LV_ModifyCol(1, 100)
;###### Adding hotkeys to list
	CustomHotkeys_AddtoLV()
	LV_ModifyCol(3,0)
	LV_ModifyCol(4,0)
	LV_ModifyCol(5,0)
;######################################

	Gui,Add,Button,xm y+10 w80 h20 vBut1 gCustHKGuiExit, Done
	
	Gui,Add,Button,ym xs+310 w80 h20 vBut2 gCustomHotkey_Delete,Delete
	Gui,Add,Button,y+25 xp w80 h20 vBut3 gCustomHotkey_Edit,Edit
	Gui,Add,Button,y+5 xp w80 h20 vBut4 gCustomHotkey_View,View
	Gui,Add,Button,y+25 xp w80 h20 vBut5 gCustomHotkey_Refresh,Refresh
	Gui, +Resize MinSize300x300
	Gui,Show,w400 h400,Custom Hotkeys List
	custom_hotkey_edited := 0
	return
	
	9GuiSize:
		GW := A_GuiWidth
		GH := A_GuiHeight
		LV_W := GW-100
		LF_H := GH-40
		Buts_X := LV_W + 15
		Buts_Y := LF_H + 15
		GuiControl,MoveDraw,CustomHK_LV,w%LV_W% h%LF_H%
		GuiControl,MoveDraw,But1,y%Buts_Y%
		GuiControl,MoveDraw,But2,x%Buts_X%
		GuiControl,MoveDraw,But3,x%Buts_X%
		GuiControl,MoveDraw,But4,x%Buts_X%
		GuiControl,MoveDraw,But5,x%Buts_X%
		return
	
	CustHKGuiExit:
	9GuiEscape:
	9GuiClose:
		Gui,+OwnDialogs
		is_hotkeys_errors := HotkeysCompare()
		if is_hotkeys_errors
		{
			MsgBox, 308, Using of similar hotkeys, Some of your hotkeys/mouse gestures are the same:`n%is_hotkeys_errors% `n`nDo you want to continue anyway?
			IfMsgBox, No
				return
		}
		Gui, 9:Destroy
		if custom_hotkey_edited
			MenuRebuild(MAIN_SECTION_NAME)
		return
		
	CustomHotkeys_LV_Events:
		if (A_GuiEvent = "DoubleClick")
			goSub,CustomHotkey_Edit
		return
		
	;col 3 - order, col 4 - section, col 5 - original hotkey string
	CustomHotkey_Delete:
		Gui,+OwnDialogs
		GuiControl,Focus,CustomHK_LV
		row_num := Get_LV_HiddenData(item_order,item_section,orig_hotkey)
		if row_num
		{
			ItemDel(item_order . "#HOTKEY",item_section)
			CustomHotkeys_DelEntry(orig_hotkey)
			err := Hotkey(orig_hotkey,0)
			if err
				MsgBox,,Error,Could not disable the hotkey.`nError:`n%Err%
			lines_count := LV_GetCount()
			LV_Delete(row_num)
			if (row_num = lines_count)
				LV_Modify(row_num-1,"Select")
			else
				LV_Modify(row_num,"Select")
		}
		return
		
	CustomHotkey_Edit:
		Gui,9:Default
		GuiControl,Focus,CustomHK_LV
		row_num := Get_LV_HiddenData(item_order,item_section,orig_hotkey)
		if !row_num
			return
		LV_GetText(orig_hotkey, row_num, 5)
		new_hotkey := CustomHotkey_EditGUI(orig_hotkey,9)
		if (new_hotkey == orig_hotkey || new_hotkey = "#" || new_hotkey = "")
			return
		ItemSet(item_order . "#HOTKEY",item_section,new_hotkey)
		CustomHotkeys_ChangeEntry(orig_hotkey,new_hotkey)
		Gui,9:Default
		LV_Modify(row_num,"Col1",HotkeyToString(new_hotkey))
		LV_Modify(row_num,"Col5",new_hotkey)
		;hotkeys resetting
		err := Hotkey(orig_hotkey,0)
		if err
			MsgBox,,Error,Could not disable the hotkey.`nError:`n%err%
		#UseHook ON
		err := Hotkey(new_hotkey,1,"CustomHotkeys_RunSub")
		if err
			MsgBox,,Error,Could not enable the new hotkey.`nError:`n%err%		
		#UseHook OFF
		custom_hotkey_edited := 1
		return
		
	CustomHotkey_View:
		Gui,9:Default
		row_num := Get_LV_HiddenData(item_order,item_section,orig_hotkey)
		if !row_num
			return
		item_name := ItemGet(item_order,item_section)
		EditShortcut(GetItemID(item_section . "#" . item_name),item_name)
		return
		
	CustomHotkey_Refresh:
		LV_Delete()
		CustomHotkeys_AddtoLV()
		return
}

CustomHotkey_EditGUI(hk,AGui,title="Edit Hotkey")
{
	global global_NoGuiTheme
	static New_custom_hk,New_hk_win,new_hk
	static hk_orig, static_Gui
	Gui,10:+LastFoundExist
	IfWinExist 
	{
		WinActivate
		DTP("Hotkey changing window is already opened!",2000)
		return
	}
	hk_orig := hk
	Gui, 10:Default
	parent_guis := StrSplit(AGui,"|",A_Tab A_Space)
	for i,v in parent_guis
		Gui,%v%:+Disabled
	Gui,% "+Owner" parent_guis[1]
	if global_NoGuiTheme
		Gui,-Theme
	
	Gui,Add,Hotkey,w130 h20 xm ym vNew_custom_hk,% HotkeyGetVK( RemWINhk(hk) )[1]
	Gui,add,Checkbox,% "w50 h20 yp+1 x+5 vNew_hk_win Checked" . IsWINhk(hk),+WIN
	Gui,add,button,w50 h20 xm y+10 gSave_Edited_Hotkey,OK
	Gui,add,button,w50 h20 y20 x+85 yp gClose_Edit_GUI,Cancel
	gui, +ToolWindow
	Gui,% parent_guis[1] ":+LastFoundExist"
	WinGetPos, X, Y, W, H,% "AHK_ID " WinExist()
	Gui, show,% "x" . round(x+w/2-100) . " y" . round(y+h/2-90) . " h65 w210",% title
	while !go_on
		sleep 200
	return (instr(new_hk,"vk00") ? "" : new_hk)
	
	Save_Edited_Hotkey:
	Close_Edit_GUI:
	10GuiClose:
	10GuiEscape:
		if (A_ThisLabel = "Save_Edited_Hotkey")
		{
			Gui,Submit,NoHide
			if (New_custom_hk != "")
				new_hk := (New_hk_win ? "#" : "") . New_custom_hk
		}
		else
			new_hk := hk_orig
		for i,v in parent_guis
			Gui,%v%:-Disabled
		Gui,10:Destroy
		go_on := 1
		return
}

CustomHotkeys_AddtoLV()
{
	global CustomHotkeysList
	Gui,9:Default
	Gui,+OwnDialogs
	num := 1
	Loop,parse,CustomHotkeysList,`n,`r%A_Tab%%A_Space%
	{
		if (A_LoopField = "")
			continue
		Get_CustomHotkeysParams(A_LoopField, hk, itemTarget, menu_num, menu_name, item_order, item_section)
		target := itemTarget ? itemTarget : (menu_name ? ("Open Menu: " . menu_name) : "N/A")
		Gui,9:Default
		LV_Add("", HotkeyToString(hk),target,item_order,item_section,hk,num)
		num++
	}
	LV_ModifyCol(2, "AutoHDR") 
}

CustomHotkeys_DelEntry(hk)
{
	global CustomHotkeysList, CustomHotkeys_ActivateList
	CustomHotkeysList := RegExReplace(CustomHotkeysList,"`ai)(^|`n)\s*\Q" . hk . "\E\s*#HK#.*($|`n)","`n")
	CustomHotkeys_ActivateList := RegExReplace(CustomHotkeys_ActivateList,"`ai)(^|`n)\s*\Q" . hk . "\E\s*($|`n)","`n")
	return
}

CustomHotkeys_ChangeEntry(hk,new_hk)
{
	global CustomHotkeysList, CustomHotkeys_ActivateList
	CustomHotkeysList := RegExReplace(CustomHotkeysList,"`ai)(^|`n)\s*\Q" . hk . "\E\s*#HK#","`n" . new_hk . "#HK#")
	CustomHotkeys_ActivateList := RegExReplace(CustomHotkeys_ActivateList,"`ai)(^|`n)\s*\Q" . hk . "\E\s*($|`n)","`n" . new_hk . "`n")
	return
}


Get_LV_HiddenData(byref item_order,byref item_section,byref orig_hotkey)
{
	item_order := item_section := orig_hotkey := ""
	Gui,9:Default
	Gui,+OwnDialogs
	row_num := LV_GetNext()
	if !row_num
		return 0
	LV_GetText(item_order, row_num, 3)
	LV_GetText(item_section, row_num, 4)
	LV_GetText(orig_hotkey, row_num, 5)
	hk := ItemGet(item_order . "#HOTKEY",item_section)
	if (hk = "ERROR" || hk != orig_hotkey)
	{
		MsgBox,,Could not access hotkey,Choosen hotkey has been changed.`nIt may happen if you moved the shortcut it belongs to. Close all Quick Cliq windows then try again.
		return 0
	}
	return row_num
}

Get_CustomHotkeysParams(hotkey_line,ByRef out_Hotkey,ByRef out_Target,ByRef out_m_num,ByRef out_m_name,ByRef out_order="",ByRef out_menu_section="")
{
	out_Hotkey := out_Target := out_m_num := out_m_name := out_order := out_menu_section := ""
	
	;getting item's hotkey
	StringReplace,hotkey_line,hotkey_line,#HK#,¶
	StringSplit,fld,hotkey_line,¶,`n`r%A_Tab%%A_Space%
	if fld1
		out_Hotkey := fld1
	hotkey_line := fld2
	
	;getting item order inside menu section
	StringReplace,hotkey_line,hotkey_line,#ORD#,¶
	StringSplit,fld,hotkey_line,¶,`n`r%A_Tab%%A_Space%
	if (fld1 != "")
		out_order := fld1
	hotkey_line := fld2	
	
	;getting menu section
	StringReplace,hotkey_line,hotkey_line,#ST#,¶
	StringSplit,fld,hotkey_line,¶,`n`r%A_Tab%%A_Space%
	if fld1
		out_menu_section := fld1
	
	;getting menu number or shortcut's target
	if instr(fld2,"#NM#")
	{
		StringReplace,fld2,fld2,#NM#,¶
		StringSplit,m_fld,fld2,¶,`n`r%A_Tab%%A_Space%
		out_m_name := m_fld2
		out_m_num := m_fld1
	}
	else
	{
		target := ItemGet(fld2,"Targets")
		if (target != "ERROR")
			out_Target := target
	}	
	return
}

ProcessCustomHotkey(hotk)
{
	global CustomHotkeysList,window
	for i,hk in HotkeyFromVK(hotk)
		If RegExMatch(CustomHotkeysList,"`aim)^\s*\Q" . hk . "\E\s*#HK#.*?$",hotkey_line)	;getting specified line from the list
		{
			Get_CustomHotkeysParams(hotkey_line,v,itemTarget,menu_num,menu_name)
			WinGet, window, ID, A
			GetDesktopSelection(window)
			if (menu_num != "" && menu_name != "")
				ShowMenu_CustHK(menu_num)
			else if (itemTarget != "")
				RunTarget(itemTarget ,0,"Custom Hotkey","",0,1)	;running without considering CTRL state
			break
		}
	return
}

ShowMenu_CustHK(menu_id)	;showing menu called by custom hotkey
{
	global MM_TRANSPARENCY,window
	MouseGetPos,X,Y
	WinGet, window, ID, A
	GetDesktopSelection(window)
	MMenu_Show(menu_id, X, Y, "RunTarget","SSelectHandle UMenuCloseHandle RRBHandle IMenuOpenHandle MMBHandle",MM_TRANSPARENCY)	
	return
}


SetCustomHotkeys(hotkeys_list,state)	;list of new-line delimited hotkeys, state = 1 or 0
{
	if hotkeys_list
	{
		#UseHook ON
		loop,parse,hotkeys_list,`n,`r%A_tab%%A_Space%
		{
			hk := A_LoopField
			if (hk == "")
				continue
			err := Hotkey(hk,state,"CustomHotkeys_RunSub")
			if err
			{
				hk_error := 1
				hk_error_descr .= "`n" err
			}
		}
		#UseHook OFF
	}
	if hk_error
		MsgBox,4096,Some of the custom hotkeys were not set,% "The following hotkeys were not set due the error:`n" . hk_error_descr . "`n`nIf you don't know what the problem may be, please copy the content of this message and send to us as a bug on support@apathysoftworks.com"
	return
}