﻿AddMenuGui()
{
	global
	static mg_static_var
	Gui, 1:Default
	MainGuiRunning := 1
	If (hMGGui && IsWindow(hMGGui))
	{
		if !IsWindowVisible( hMGGui )
			GoSub,ReEnableMainGui
		ShowWindow(hMGGui)
		while !WinActive( "ahk_id " hMGGui )
		{
			ShowWindow( hMGGui )
			WinActivate,ahk_id %hMGGui% ;the window won't activate sometimes
			sleep 50
		}
		return
	}
	OnMessage(0x200,"ShowHyperlink")
	OnMessage(0x20,"ShowHyperlink")
	
	Gui, +OwnDialogs +LabelMainGui
	if global_NoGuiTheme
		Gui,-Theme
	Gui,Font, s8 Q5, Arial
	
	Menu, Help, Delete
	Menu, GuiMenuBar, Delete
	Menu, AddNewItem, Delete
	Menu, MoveItem, Delete
	Menu, Sort, Delete
	Menu, QuickLinks, Delete
	Menu, AfoMenu, Delete
	Menu, Settings, Delete
	
	Menu, Settings, Add, &Options..., OptionsGui
	Menu, Settings, Add, List Custom &Hotkeys..., CustomHotkey_OpenGui
	Menu, Settings, Add
	Menu, Settings, Add, Use &Default List Colors, ToggleTreeColors
	Menu, Settings, Add, Target &Autosave, ToggleTargetAutosave
	
	Menu, AfoMenu, Add, Copy, AfoCopy
	Menu, AfoMenu, Add, Send New, AfoSend
	
	Menu, QuickLinks, Add, &Homepage, GoHomepage
	Menu, QuickLinks, Add, Check the &News, CheckTheNews
	Menu, QuickLinks, Add
	Menu, QuickLinks, Add, Join our Fa&cebook page, ApathyFacebook
	Menu, QuickLinks, Add, Follow us on T&witter, ApathyTwitter
	Menu, QuickLinks, Add
	Menu, QuickLinks, Add, Change &Log, ShowChangeLog
	Menu, QuickLinks, Add
	Menu, QuickLinks, Add, Donate, DonateLNK
		
	Menu, Help, Add, Web &Help, Help
	Menu, Help, Add
	Menu, Help, Add, &About, About
	Menu, GuiMenuBar, Add, &Settings, :Settings
	Menu, GuiMenuBar, Add, Check for &Updates, Update
	Menu, GuiMenuBar, Add, &Feedback, FeedbackSub
	Menu, GuiMenuBar, Add, &Quick Links, :QuickLinks
	Menu, GuiMenuBar, Add, &Help, :Help
	Gui, Menu, GuiMenuBar
	
	Menu, AddNewItem, add, Menu, AddMenu
	Menu, AddNewItem, add,Shortcut, AddItem
	Menu, AddNewItem, add, Separator, AddSepar
	
	Menu, Sort, add, Alpha, SortAlpha
	Menu, Sort, add, Alpha Menus Top, SortMenusTop
	Menu, Sort, add, Alpha Menus Bot, SortMenusBot
	Menu, Sort, add, Random, SortRandom

	Menu, Target_List_Menu, add, File, TG_File
	Menu, Target_List_Menu, add, Folder, TG_Folder
	Menu, Target_List_Menu, add, Folder Menu, TG_FMenu
	Menu, Target_List_Menu, add, Folder Switcher, TG_FSwitch
	Menu, Target_List_Menu, add, URL, TG_Url
	Menu, Target_List_Menu, add, EMail, TG_Email
	Menu, Target_List_Menu, add, System, TG_System
	Menu, Target_List_Menu, add, Special, TG_Spc
	
	Gui,+Lastfound +HWNDhMGGui
	hMainTbImageList := IL_CreateNew(16,7,1)
	loop,% MG_ICO_CNT
	{
		ico := QC_ICL . MG_ICO_IND+(A_Index-1)
		IL_AddIcon(hMainTbImageList,IconExtract( IconGetPath(ico), IconGetIndex(ico),16))
	}
	hMainGuiToolbar := Toolbar_Add(hMGGui, "MainGuiToolbarHandler","LIST FLAT NODIVIDER TOOLTIPS",hMainTbImageList, "x10 y5")
	;DO NOT change IDs since they are hardly linked with events
	btns = 
	(LTrim
	Add Shortcut,1,,,1
	Add Menu,2,,,2
	Add Separator,3,,,3
	--
	Expand/Collapse All Menus,4,,,4
	Move Item Down,6,,,5
	Move Item Up,7,,,7
	--
	Delete Selected Item,8,,,6
	--
	Hints,9,,,8
	Save changes and rebuild Menu,10,,,9
	)
	Toolbar_Insert(hMainGuiToolbar, btns)
	Toolbar_AutoSize(hMainGuiToolbar)

	Gui, Add, TreeView, vAnTreeView AltSubmit Section x10 y30 w470 h290 -ReadOnly gTreeEvent HWNDTV_hwnd -0x2 +0x1 ;+0x200	;+TVS_TRACKSELECT -TVS_HASLINES +TVS_HASBUTTONS
	BuildTree(0,MAIN_SECTION_NAME,1)

	Gui, Add, Text, x10 y+30 w520 vgbTarget
	Gui, Add, Edit,-Background -WantReturn xs y+5 w470 h40 vSTarget HwndTargetHWND gOnTargetChange

	Gui, Font,S8,Arial
	Gui, Add, StatusBar,vAfoSB gSB_afo_change -Tabstop +0x100,% GetRandomAphorism()
	Gui, Font
	
	;Options ###########
	MG_AddEditLV() 
	TargetAutoSave(0)
	;############################
	Gui, +Resize +MinSize360x430
	GuiControl,Focus,AnTreeView
	Gui, Show,% MGGetSize(), %MB_NAME%
	SendMessage( TV_hwnd, 0x1100 + 44, 0x0004, 0x0004 )			; TVM_SETEXTENDEDSTYLE to TVS_EX_DOUBLEBUFFER
	SetTimer, Change_SB_Afo, %AFO_DELAY%
	MG_ItemPropsGUI(1)
	IE_CmdView(0)
	return
	
	MainGuiSize:
		MG_Resize(A_GuiWidth,A_GuiHeight)
		return
	
	CustomHotkey_OpenGui:
		CustomHotkeysGui_Show()
		return
	
	ReEnableMainGui:
		Gui, 1:Default
		BuildTree(0,MAIN_SECTION_NAME,1)
		TV_Modify(TV_GetNext(0,"F"),"Select")
		GuiControl,Focus,AnTreeView
		SetTimer, Change_SB_Afo, %AFO_DELAY%
		return

	OnTargetChange:
		if !TG_ASaveStop()
			SetTimer,TargetAutosaveSub,-200
		return
	
	TargetAutosaveSub:
		if !TG_ASaveStop()
			TV_SyncTargetFields(1)
		return
	;############################### TREE EVENTS
	TreeEvent:
		CheckTreeEvent(A_EventInfo,A_GuiEvent)
		return

	ToggleTreeColors:
		SetTreeColors(-1)
		return
	
	ToggleTargetAutosave:
		TargetAutoSave(1)
		return
	
	DonateLNK:
		Run, %DONATE_URL%,,UseErrorLevel
		return
	
	CheckTheNews:
		Run, %NEWS_URL%,,UseErrorLevel
		return
	
	GoHomepage:
		Run, %REDIRECT_URL%,,UseErrorLevel
		return
	
	ApathyFacebook:
		Run, %FACEBOOK_URL%,,UseErrorLevel
		return
	
	ApathyTwitter:
		Run, %TWITTER_URL%,,UseErrorLevel
		return
	
	FeedbackSub:
		SendFeedback()
		return
		
	fakesub:
		return
	
	SortAlpha:
		SortMenu(SelectedItemID,"A")
		return
		
	SortMenusTop:
		SortMenu(SelectedItemID,"ATop")
		return
		
	SortMenusBot:
		SortMenu(SelectedItemID,"ABot")
		return

	SortRandom:
		SortMenu(SelectedItemID,"R")
		return

	ShowChangeLog:
		SplashWait(1,"",1,0)
		Sleep 50

		ChUn = 0
		URLDownloadToFile, %CHANGELOG_URL%, %CHANGELOG_TEMP_PATH% ;downloading latest changelog
			if ErrorLevel
				ChUn=1
			chLog := FileOpen(CHANGELOG_TEMP_PATH,"r","CP0")
			if !IsObject(chLog)
				msgbox,,Error opening file,Couldn't open file, please try again.
			change_log := chLog.Read()
			chLog.Close()
			if ErrorLevel
				ChUn=1
			if RegExMatch(change_log,"404|403|401|400|500|502|503|Bad file request|Connection refused by host|Failed DNS lookup|Host unavailable|Host unknown|Network connection was refused by the Server|Permission denied|Too many connections|Too many users") ;if file was failed to download	
				ChUn=1
		
		if ChUn
		{
			SplashWait(-1)
			Gui, 1:+OwnDialogs
			MsgBox, 16, Error, Sorry`,the changelog is currently unavailable.`n Please try later or when you have an internet connection.
			return
		}
		SplashWait(-1)
		Gui, 29:Default
		Gui, 1:+Disabled
		Gui, +owner1
		if global_NoGuiTheme
			Gui,-Theme
		Gui,Add,Edit, vchange_log_ed w400 h300 +Multi +ReadOnly, %change_log%
		GuiControl, Focus, change_log_ed
		Gui, +ToolWindow
		
		Gui, 1:+LastFoundExist
		WinGetPos, X, Y, W, H,% "AHK_ID " WinExist()
		Gui,Show,% "x" . round(x+(w/2)-200) . " y" . round(y+(h/2)-200), Change log
		X:=Y:=W:=H:=""
		return

	29GuiClose:
		Gui, 1:+OwnDialogs
		Gui, 1:-Disabled
		Gui, -owner1
		Gui, 29:Destroy
		Gui, 1:Default
		return

	run_target:
		Gui, 1:+OwnDialogs
		GuiControlGet, STarget,,STarget
		RunTarget(STarget)
		STarget =
		return

	;#################################################
	MainGuiDropFiles:
		MG_DropFiles(A_GuiControl,A_GuiEvent)
		Return
	;#################################################	
	OptionsGui:
		OptionsGUI()
		return

	BugFound:
		Run, %BUGTRACKER_URL%,,UseErrorLevel
		if (ErrorLevel = ERROR)
			MsgBox,16,Another bug,Can't open bugtracker url`. Please open it manually`.`n%BUGTRACKER_URL%
		return

	Update:
	SetTimer, SilentUpdateCheck, OFF
	Gui +OwnDialogs
    Program_Update(A_GUI)
    return

	Help:
		Run, %HELP_URL%,,UseErrorLevel
		if (ErrorLevel = ERROR)
			MsgBox,16,Another bug,Can't open help url`. Please open it manually`.`n%HELP_URL%		
		return
	;#################################################
	MainGuiClose:
		Gui,+OwnDialogs
		HideWindow(hMGGui)
		MGSaveSize()
		;MG_ItemPropsGUI hiding
		SetTimer,IsPropsGUIActive,OFF
		gui,12:hide
		SetTimer,DisMess,5000
		SetTimer, Change_SB_Afo, Off
		MenuRebuild(MAIN_SECTION_NAME)
		sleep 50
		is_hotkeys_errors := HotkeysCompare()
		if is_hotkeys_errors
			MsgBox,, Using of similar hotkeys, Some of your hotkeys/mouse gestures are the same:`n%is_hotkeys_errors%

		MainGuiRunning := 0
	return
	;############################### SET TARGETS
	
	TG_Spc:
		Special_Target_GUI_Show(1)
		return
	
	TG_File:
	TG_Folder:
	TG_FSwitch:
	TG_FMenu:
	TG_Url:
	TG_Email:
	TG_System:
		mg_static_var := A_ThisLabel
		SetTimer,MG_ChangeTargetTimer,-1
		return
	MG_ChangeTargetTimer:
		TG_ASaveStop(1)
		;### Getting current values
		Current_ItemID := TV_GetSelection()
		GuiControlGet, current_target,, STarget
		TV_GetText(current_name, Current_ItemID)
		current_item_target := GetTarget(Current_ItemID)
		
		;### Getting new target & name & ico
		new_target := new_name := new_ico := ""
		TG_GetUserTarget( mg_static_var, new_target, new_name, new_ico, current_target )
		
		Gui,1:Default
		Gui,+OwnDialogs

		;### Set New Target
		if ( new_target != "" && new_target != "ERROR" && new_target != current_target )
		{
			if (new_target = "empty" && current_target != "")
				new_target := ""		
			SaveTarget(new_target,current_item_target)
		}

		;### Set New Icon
		if new_ico
		{
			nIndex := IconGetIndex(new_ico)
			sIconPath := IconGetPath(new_ico)
			if ItemIcon := TV_IL.Add(sIconPath,nIndex+1)
			{
				TV_Modify(Current_ItemID,"Icon" . ItemIcon)
				TV_Modify(Current_ItemID)
				SetIcon(Current_ItemID,sIconPath . ":" . nIndex)
				GuiControl, MoveDraw, AnTreeView
			}
		}

		;### Set New Name
		If (new_name != "" && new_name != "*" && new_name != "^" && !(new_name == current_name)) 
		{
			new_name := TVCheckName( new_name, TV_GetParent(Current_ItemID) )
			TV_Modify(Current_ItemID,"", new_name)
			if !ChangeName(Current_ItemID,new_name,current_name,current_item_target)
				TV_Modify(Current_ItemID,"", current_name)
		}
		TVMG_SetControls(Current_ItemID)
		ControlSend,, {End}, ahk_id %TargetHWND%
		GuiControl,Focus,AnTreeView
		TG_ASaveStop(0)
		return

	;############################### CHANGE MENU BG T COLOR
	ChangeMenuTextColor:
	MenuChangeColor("t")
	return
	
	ChangeMenuBGColor:
	MenuChangeColor("bg")
	return
	
	AddItem:
		Tree_AddItem()
		return
		
	AddMenu:
		Tree_AddMenu()
		return
		
	AddSepar:
		Tree_AddSepar()
		return
	
	DeleteItem:
	MG_TV_DeleteItem()
	return
	
	Change_SB_Afo:
	Gui, 1:Default
	if (AfoChangeAllowed != 0)
		SB_SetText(GetRandomAphorism())
	return

	SB_afo_change:
		Gui, 1:Default
		if (A_GuiEvent = "Normal")
		{
			SB_SetText(GetRandomAphorism())
			SetTimer, Change_SB_Afo, %AFO_DELAY%
		}
		else if (A_GuiEvent = "RightClick")
			SetTimer,ShowAfoMenu,-50
		return
	
	ShowAfoMenu:
		Menu, AfoMenu,Show
		return
		
	AfoCopy:
		full_afo := RegExReplace(GuiControlGet("AfoSB",1),"^\s*|\s*$") . "`n" . afo_english						;afo_english is a tooltip part of afo
		clipboard := full_afo
		DTP()
		full_afo =
		return
		
	AfoSend:
		SendAfoForm()
		return
}