﻿DeleteByID(ItemID,IsFirst=1,DeleteTargets=1) {
	if (ItemID = 0 || ItemID = "")
		return
	Gui, 1:Default
	Gui, +OwnDialogs
	global SEPARATOR_STRING
	TV_GetText(ItemName,ItemID)
	IfInString, ItemName, %SEPARATOR_STRING%
		StringReplace, ItemName, ItemName, %SEPARATOR_STRING%, #
	PID := TV_GetParent(ItemID)
	MenuSection := GetTarget(PID)
	ItemTarget := GetTarget(ItemID)
	Order := 0
	Loop
	{
		NextItemName := ItemGet(Order,MenuSection)
		if (NextItemName == "ERROR")
			break
		StringReplace, NextItemName, NextItemName, #M#
		StringReplace, NextItemName, NextItemName, #B#
		if (NextItemName == ItemName)
		{
			ItemDel(Order,MenuSection)
			ItemDel(Order . "#ICON",MenuSection)
			ItemDel(Order . "#HOTKEY",MenuSection)
			
			NextNextItemName := ItemGet(Order++,MenuSection)
			if (Order==0 AND NextNextItemName=="ERROR")
				ItemSet(0,MenuSection,"-empty-")
			break
		}
		Order++
	}
	if TV_GetChild(ItemID)
	{
		Loop
		{
			CID := TV_GetChild(ItemID)
			if DeleteTargets
				DeleteByID(CID,0)
			else
				DeleteByID(CID,0,0)
			if !TV_GetChild(ItemID)
				break
		}
		ItemSecDel(ItemTarget)
	}
	Else if (!TV_GetChild(ItemID) && DeleteTargets)
		ItemDel(ItemTarget,"Targets")
	ParentID := TV_GetParent(ItemID)
	TV_Delete(ItemID)
	if IsFirst
		if !TV_GetChild(ParentID)
			TV_Modify(TV_Add("-empty-",ParentID,"Icon Select Vis"))
	OrderRecheck(PID)
	TVMG_SetControls(TV_GetSelection())
	Return
}
;############################### ORDER RECHECK
OrderRecheck(ParentID) {
	Gui, 1:Default
	MenuSection := GetTarget(ParentID)
	Order := 0
	Loop
	{
		Name := ItemGet(Order,MenuSection)
		if (Name == "ERROR")
		{
			NextOrder := Order + 1
			NextName := ItemGet(NextOrder,MenuSection)
			NextNameIcon := ItemGet(NextOrder . "#ICON",MenuSection)
			NextNameHotkey := ItemGet(NextOrder . "#HOTKEY",MenuSection)
			if (NextName == "ERROR")
				break
			ItemSet(Order,MenuSection,NextName)
			if (NextNameIcon != "ERROR")
				ItemSet(Order . "#ICON",MenuSection,NextNameIcon)
			if (NextNameHotkey != "ERROR")
				ItemSet(Order . "#HOTKEY",MenuSection,NextNameHotkey)
			
			ItemDel(NextOrder,MenuSection)
			ItemDel(NextOrder . "#ICON",MenuSection)
			ItemDel(NextOrder . "#HOTKEY",MenuSection)
		}
		Order++
	}
	Return
}
;############################### MAKE A PLACE
MakePlace(AfterName,PID,First=0,MenuSection=0) {
	Gui, 1:Default
	if !MenuSection
		MenuSection := GetTarget(PID)
	Order := 0
	Loop
	{
		NextName := ItemGet(Order,MenuSection)
		if (NextName == "ERROR")
		{
			if (Order = 0)
				return
			Loop
			{
				If (TargetOrder == Order && First!=1)
					break
				sOrder := Order - 1
				Name1 := ItemGet(sOrder,MenuSection)
				Name1Icon := ItemGet(sOrder . "#ICON",MenuSection)
				Name1Hotkey := ItemGet(sOrder . "#HOTKEY",MenuSection)
				ItemSet(Order,MenuSection,Name1)
				if (Name1Icon != "ERROR")
					ItemSet(Order . "#ICON",MenuSection,Name1Icon)
				if (Name1Hotkey != "ERROR")
					ItemSet(Order . "#HOTKEY",MenuSection,Name1Hotkey)
				ItemDel(sOrder,MenuSection)
				ItemDel(sOrder . "#ICON",MenuSection)
				ItemDel(sOrder . "#HOTKEY",MenuSection)
				if (Order == 1)
					break
				Order--
			}
			break
		}
		StringReplace, NextName, NextName, #B#,,1
		StringReplace, NextName, NextName, #M#,,1
		if (NextName == AfterName)
			TargetOrder := Order + 1
		Order++
	}
	return
}
;############################### ADD NEW
AddNew(Name,PID,PreName=0,First=0,icon=0,MenuSection=0,target=0,hotkey="") {
	Gui, 1:Default
	if !MenuSection
		MenuSection := GetTarget(PID)
	Order := 0
	if (PreName != 0 && First != 1)
		MakePlace(PreName,PID,0,MenuSection)
	else if (First == 1)
		MakePlace(PreName,PID,1,MenuSection)
	Loop
	{
		NextName := ItemGet(Order,MenuSection)
		if (NextName == "ERROR")
		{
			ItemSet(Order,MenuSection,Name)
			if target
				ItemSet(MenuSection . "#" . GetItemID(Name),"Targets",target)
			if icon
				ItemSet(Order . "#ICON",MenuSection,icon)
			if hotkey
				ItemSet(Order . "#HOTKEY",MenuSection,hotkey)
			return
		}
		Order++
	}
}
;############################### CHECK NAME
TVCheckName( Name, MenuSection ) 
{
	Gui, 1:Default
	Loop
	{
		if TVNameExist( Name, MenuSection )
			Name := NameGetNext( Name )
		else
			break
	}
	return Name
}

TVNameExist( Name, MenuSection )
{
	if MenuSection is Integer
		MenuSection := GetTarget( MenuSection )
	Order := 0
	Loop
	{
		NextName := ItemGet( Order, MenuSection )
		if (NextName == "ERROR")
			break
		StringReplace, NextName, NextName, #B#,,1
		StringReplace, NextName, NextName, #M#,,1
		if ( StrRemoveChars(NextName,"&") = StrRemoveChars(Name,"&") )
			return 1
		Order++
	}
	return 0
}
;############################### MOVE ITEM
MoveItem(Direction="",ID="",def_PID="",def_PreID="") { ;dir = "U" or "D", def_PID & def_PreID used by drag&drop function
	global SEPARATOR_STRING,STarget,TV_hwnd
	if !ID
		return
	Gui, 1:Default
	SplashWait(1)
	GuiControl, -Redraw, AnTreeView
	if (def_PID != "" && def_PreID != "")
	{
		PreID := def_PreID
		PID := def_PID
	}
	else
		PreID := GetPreID(ID,Direction,PID)

	if (PreID == "ERROR")
	{
		GuiControl, +Redraw, AnTreeView
		SplashWait(0)
		return
	}
; deep magic starts here...
	ItemTarget := GetTarget(ID)
	ItemIcon := GetIcon(ID)
	ItemHotkey := GetCustomHotkey(ID)
	TV_GetText(ItemName,ID)
	ifInString, ItemName, %SEPARATOR_STRING%
		StringReplace, ItemName, ItemName, %SEPARATOR_STRING%, #	
	TV_GetText(PreName,PreID)
	ifInString, PreName, %SEPARATOR_STRING%
		StringReplace, PreName, PreName, %SEPARATOR_STRING%, #
	if TV_Get(ID,"Bold")
	{
		isBold := "#B#"
		isB := " Bold "
	}
	else
	{
		isBold := ""
		isB := ""
	}
	IconNum := TV_GetIconIndex(TV_hwnd,ID)+1	;getting index of icon in ImageList used by current item to avoid adding new icon
	if TV_GetChild(ID)
	{
		iName := TVCheckName( "iName", PID )
		if (PreID == 0)
			AddNew(iName . "#M#" . isBold,PID,0,1,ItemIcon,0,0,ItemHotkey)
		else
			AddNew(iName . "#M#" . isBold,PID,PreName,0,ItemIcon,0,0,ItemHotkey)
		if (PreID == 0)
			PID2 := TV_Add(iName, PID, "First Select Vis Icon" . IconNum . isB)	
		else
			PID2 := TV_Add(iName, PID, PreID . " Select" . " Vis" . " Icon" . IconNum . isB)
		CopySublings(ID,PID2)
		ChangeMenuTarget(PID2,ItemTarget)
		NewTarget := GetTarget(PID2)
		DeleteByID(ID,1,0)
		ItemName := TVCheckName( ItemName, PID )
		TV_Modify(PID2,"", ItemName)
		ChangeName( PID2, ItemName, iName, NewTarget )
	}
	else
	{
		iName := TVCheckName( "iName", PID )
		if (PreID == 0)
			AddNew(iName . isBold,PID,0,1,ItemIcon,0,0,ItemHotkey)
		else
			AddNew(iName . isBold,PID,PreName,0,ItemIcon,0,0,ItemHotkey)
		if (PreID == 0)
			PID2 := TV_Add(iName, PID, "First Select Vis Icon" . IconNum . isB)	
		else
			PID2 := TV_Add(iName, PID, PreID . " Select" . " Vis" . " Icon" . IconNum . isB)
		NewTarget := GetTarget(PID2)
		
		ItemOldTarget := ItemGet(ItemTarget,"Targets")
		ItemDel(ItemTarget,"Targets")
		if (ItemOldTarget != "ERROR" && ItemOldTarget)
		{
			def = ^"\s*(?!").*(?<!")\s*"$
			if RegExMatch(ItemOldTarget,def)
			{
				t = "%ItemOldTarget%"
				ItemSet(NewTarget,"Targets",t)
			}
			else
				ItemSet(NewTarget,"Targets",ItemOldTarget)
		}

		DeleteByID(ID,1,0)
		ItemName := TVCheckName( ItemName, TV_GetParent(PID2) )
		TV_Modify(PID2,"", ItemName)
		ChangeName(PID2,ItemName,iName,NewTarget)
		ifInString, ItemName, #
		{
			StringReplace, ItemName, ItemName, #, %SEPARATOR_STRING%
			TV_Modify(PID2,"", ItemName)
		}
	}
	TVMG_SetControls(PID2)
	SplashWait(0)
	GuiControl, +Redraw, AnTreeView
	TV_ArrangeColors(PID2,1)
	TV_Modify(PID2,"Vis Select")
	SendMessage( TV_hwnd, 0x110B, 0x8, PID2 )	; Show a focus independent selection over item; TVM_SELECTITEM := 0x110B,	TVGN_DROPHILITE := 0x8
	return
}

;############################### GET TARGET
GetTarget( ItemID )	{
	global SEPARATOR_STRING, MAIN_SECTION_NAME
	Gui, 1:Default
	TV_GetText(iName, ItemID)
	if (ItemID == 0)
		RetTarget := MAIN_SECTION_NAME
	else IfInString, iName, %SEPARATOR_STRING%
		RetTarget := "Separator"
	else 
	{
		PID := TV_GetParent(ItemID)
		if (PID == 0)
			RetTarget := GetItemId(MAIN_SECTION_NAME . "#" . iName)
		else
			RetTarget := GetItemId(GetTarget(PID) . "#" . iName)
	}
	return RetTarget
}

;############################### CHANGE NAME

ChangeName(ItemID,NewName,OldName,OldTarget) {
	Gui, 1:Default
	
	NewTarget := GetTarget(ItemID)
	PID := TV_GetParent(ItemID)
	ParentMenu := GetTarget(PID)
	if (NewTarget = OldTarget)
		if (NewName == OldName)
			return 0
		else
			ChangeOnlyName = 1
	Order := 0
	IsBold := ""
	IsMenu := ""
	;~ msgbox % NewName "`n" OldName "`n" OldTarget "`n" NewTarget "`n" ParentMenu
	Loop
	{
		Name := ItemGet(Order,ParentMenu)
		If (Name = "ERROR")
			return 0
		ifInString, Name, #M#
		{
			StringReplace, Name, Name, #M#
			IsMenu := "#M#"
		}
		else
			IsMenu := ""
		ifInString, Name, #B#
		{
			StringReplace, Name, Name, #B#
			IsBold := "#B#"
		}
		else
			IsBold := ""
		if (Name == OldName)
		{
			ItemSet(Order,ParentMenu,NewName . IsBold . IsMenu)
			break
		}
		Order++
	}
	;~ msgbox
	if (TV_GetChild(ItemID) && !ChangeOnlyName)
	{
		IsItem := ItemGet(0,NewTarget)
		if (IsItem == "ERROR")
			ChangeMenuTarget(ItemID,OldTarget)
		else
			Return 0
	}
	else if !ChangeOnlyName
	{
		ItemOldTarget := ItemGet(OldTarget,"Targets")
		if (ItemOldTarget != "ERROR")
		{
			def = ^"\s*(?!").*(?<!")\s*"$
			if RegExMatch(ItemOldTarget,def)
			{
				t = "%ItemOldTarget%"
				ItemSet(NewTarget,"Targets",t)
			}
			else
				ItemSet(NewTarget,"Targets",ItemOldTarget)
			ItemDel(OldTarget,"Targets")
		}
	}
	return 1
}

;############################### CHANGE MENU TARGET
ChangeMenuTarget(ID,OldTarget,DeleteSection=1) {
	Gui, 1:Default
	NewTarget := GetTarget(ID)
	
	ItemSecDel(NewTarget)
	MenuColor := ItemGet("MenuColor",OldTarget)
	TextColor := ItemGet("TextColor",OldTarget)
	if (MenuColor != "ERROR")
		ItemSet("MenuColor",NewTarget,MenuColor)
	if (TextColor != "ERROR")
		ItemSet("TextColor",NewTarget,TextColor)
	Order := 0
	CID := TV_GetChild(ID)
	Loop
	{
		Name := ItemGet(Order,OldTarget)
		if (Name == "ERROR")
			break
		ChildTarget := GetTarget(CID)
		StringReplace, ChildOldTarget, ChildTarget, %NewTarget%, %OldTarget%
		ifInString, Name, #M#
		{
			ChangeMenuTarget(CID,ChildOldTarget)
		}
		else
		{
			ItemOldTarget := ItemGet(ChildOldTarget,"Targets")
			ItemTarget := ItemGet(ChildTarget,"Targets")
			if (ItemTarget == "ERROR")
			{
				if (ItemOldTarget != "ERROR")
					ItemSet(ChildTarget,"Targets",ItemOldTarget)
				ItemDel(ChildOldTarget,"Targets")
			}			
		}
		Icon := ItemGet(Order . "#ICON",OldTarget)
		Hotkey := ItemGet(Order . "#HOTKEY",OldTarget)
		ItemSet(Order,NewTarget,Name)
		if (Icon != "ERROR")
			ItemSet(Order . "#ICON",NewTarget,Icon)
		if (Hotkey != "ERROR")
			ItemSet(Order . "#HOTKEY",NewTarget,Hotkey)
		Order++
		CID := TV_GetNext(CID)
		if (TV_GetParent(CID) != ID)
			break
	}
	if DeleteSection
		ItemSecDel(OldTarget)
	return
}

;############################### COPY SUBLINGS
CopySublings(FromID, ToID) {
	global TV_hwnd
	Gui, 1:Default
	TV_GetText(ToName, ToID)
	TV_GetText(FromName, FromID)
	if TV_GetChild(FromID)
	{
		CID := TV_GetChild(FromID)
		Loop
		{
			if TV_Get(CID,"Bold")
				isBold := " Bold "
			else
				isBold := ""
			IconNum := TV_GetIconIndex( TV_hwnd, CID )+1	;getting index of icon in ImageList used by current item to avoid adding new icon
			TV_GetText(ChildName, CID)
			PID := TV_Add(ChildName, ToID, "Icon" . IconNum . isBold)
			if TV_GetChild(CID)
				CopySublings(CID, PID)
			else
			{
				PIDTarget := GetTarget(PID)
				CIDTarget := GetTarget(CID)
				Target := ItemGet(CIDTarget,"Targets")
				ItemDel(CIDTarget,"Targets")
				if (Target!="ERROR")
					ItemSet(PIDTarget,"Targets",Target)
			}
			CID := TV_GetNext(CID)
			if (TV_GetParent(CID) != FromID)
				break
		}
	}
	return
}

DeleteItemByTarget( M_ID, M_TITLE, M_MENU=0 )
{
	ItemName := M_TITLE
	MenuSection := RegExReplace(M_ID,"#[^#]*$")
	ItemTarget := M_ID
	Order := 0
	Loop
	{
		NextItemName := ItemGet(Order,MenuSection)
		if (NextItemName == "ERROR")
			break
		StringReplace, NextItemName, NextItemName, #B#
		If (InStr(NextItemName, "#M#") && RegExReplace(NextItemName,"#M#") == ItemName)
		{
			StringReplace, NextItemName, NextItemName, #M#
			DeleteMenu(ItemTarget,MenuSection,Order)
		}
		else if (NextItemName == ItemName)
			DeleteExactItem(MenuSection, Order, ItemTarget,1)
		Order++
	}
	if M_MENU
		MMenu_Remove(M_MENU,M_ID)
		;~ MMenu_Set(M_MENU,M_ID,"","","g")
	return
}

DeleteExactItem( MenuSection, key, target, isrecheck=0 )
{
	ItemDel(key,MenuSection)
	ItemDel(key . "#ICON",MenuSection)
	ItemDel(key . "#HOTKEY",MenuSection)
	ItemDel(target,"Targets")
	if isrecheck
		OrderRecheck_by_target(MenuSection)
	return
}

DeleteMenu( MenuTarget, Section, key )
{
	order := 0
	Loop
	{
		NName := ItemGet(Order,MenuTarget)
		if (NName == "ERROR")
			break
		StringReplace, NName, NName, #B#
		if instr(NName,"#M#")
		{
			StringReplace, NName, NName, #M#
			DeleteMenu(MenuTarget . "#" . GetItemID(NName),MenuTarget,Order)
		}
		DeleteExactItem(MenuTarget, Order, MenuTarget . "#" . GetItemID(NName))
		Order++
	}
	ItemSecDel(MenuTarget)
	ItemDel(key,Section)
	OrderRecheck_by_target(Section)
	return
}

OrderRecheck_by_target(MenuSection) {
	Order := 0
	Loop
	{
		Name := ItemGet(Order,MenuSection)
		if (Name == "ERROR")
		{
			NextOrder := Order + 1
			NextName := ItemGet(NextOrder,MenuSection)
			NextNameIcon := ItemGet(NextOrder . "#ICON",MenuSection)
			NextNameHotkey := ItemGet(NextOrder . "#HOTKEY",MenuSection)
			if (NextName == "ERROR")
			{
				if (Order = 0)
					ItemSet(0,MenuSection,"-empty-")
				break
			}
			ItemSet(Order,MenuSection,NextName)
			if (NextNameIcon != "ERROR")
				ItemSet(Order . "#ICON",MenuSection,NextNameIcon)
			if (NextNameHotkey != "ERROR")
				ItemSet(Order . "#HOTKEY",MenuSection,NextNameHotkey)
			ItemDel(NextOrder,MenuSection)
			ItemDel(NextOrder . "#ICON",MenuSection)
			ItemDel(NextOrder . "#HOTKEY",MenuSection)
		}
		Order++
	}
	Return
}

IsValidItemName( name, ol_name, ismenu, ByRef ErrorMsg, item_parent )
{
	global SEPARATOR_STRING, MAIN_SECTION_NAME
	Gui,1:Default
	IfInString, ol_name, %SEPARATOR_STRING%				;Separator check
	{
		ErrorMsg := "Cannot edit separators!"
		return 0
	}
	else if (ismenu && RegExMatch(name, "i)^\s*" . MAIN_SECTION_NAME . "\s*$"))
	{
		ErrorMsg := "Menu name cannot be """ . MAIN_SECTION_NAME . """!"
		return 0
	}
	else if RegExMatch(name, "i)#|^$|ERROR|=|" . SEPARATOR_STRING)
	{
		ErrorMsg := "Invalid name!"
		return 0
	}
	else if (ismenu && RegExMatch(name, "i)(\[|\])") )
	{
		ErrorMsg := "Menu name cannot contain this symbols: '[]'!"
		return 0
	}
	else if ( TVNameExist( name, item_parent ) && !( StrRemoveChars( name, "&" ) = StrRemoveChars( ol_name, "&" ) ) )
	{
		ErrorMsg := "Name already exist!"
		return 0
	}	
	return 1
}