﻿MG_ItemPropsGUI(dontShow=0)
{
	global hPropsTbImageList, hMainGuiPropToolbar, global_NoGuiTheme
	global somechbx, hPropsGui, PropsGui_IsKeepActive
	global QC_ICL, PROP_ICO_IND, PROP_ICO_CNT, PROPS_GUI_TITLE
	gui, 12:Default
	If !IsWindow(hPropsGui)
	{
		Gui,+owner1
		Gui,+Lastfound
		hPropsGui := WinExist()+0
		if global_NoGuiTheme
			Gui,-Theme
		hPropsTbImageList := IL_CreateNew(24,7,1)
		loop,% PROP_ICO_CNT
		{
			ico := QC_ICL . PROP_ICO_IND+(A_Index-1)
			IL_AddIcon(hPropsTbImageList,IconExtract( IconGetPath(ico), IconGetIndex(ico), 24))
		}
		hMainGuiPropToolbar := Toolbar_Add(hPropsGui, "MainGuiPropTlbHandler","FLAT LIST TOOLTIPS",hPropsTbImageList, "x0 y0")
		;DO NOT change IDs since they are hardly linked with events
		btns = 
		(LTrim
		Change Icon,1,,WHOLEDROPDOWN ,1
		-,,,,10
		Change Item Boldness,2,,CHECK ,2
		-,,,,11
		Hotkey: None,3,WRAP,SHOWTEXT,3
		Change Menu's Text Color,4,,WHOLEDROPDOWN ,4
		Change Menu's Background Color,5,,WHOLEDROPDOWN ,5
		Random Menu's Colors,6,,,6
		Sort Items in Menu,7,,WHOLEDROPDOWN ,7
		-,,,,9
		Create Separate Menu,8,,,8
		)
		Toolbar_Insert(hMainGuiPropToolbar, btns)
		Toolbar_AutoSize(hMainGuiPropToolbar,2)
		Gui,Add,Checkbox,x5 y80 w40 h25 vsomechbx +0x1000 gChangePropsGUIStyle,H	;PUSHLIKE
		PropsGuiChangeStyle()
	}
	if dontShow
		return
	MouseGetPos,X,Y
	GuiControl,Focus,somechbx
	if (PropsGuiChangeStyle(0) = 0)
		Gui,Show,w280 h110,% PROPS_GUI_TITLE
	else
		Gui,Show,x%x% y%y% w280 h110,% PROPS_GUI_TITLE
	SetTimer,IsPropsGUIActive,20
	return
	
	ChangePropsGUIStyle:
		PropsGuiChangeStyle(-1)
		Gui,Show,w280 h110
		return
	
	12GuiClose:
	PropsGuiHide:
		gui,12:default
		SetTimer,IsPropsGUIActive,OFF
		HideWindow(hPropsGui)
		return
		
	IsPropsGUIActive:
		Gui,1:+LastFoundExist
		IfWinActive
			if (PropsGuiChangeStyle(0) && !PropsGui_IsKeepActive)
				GoSub, PropsGuiHide
			else if PropsGui_IsKeepActive
				WinActivate,% "ahk_id " hPropsGui
		return
}

/*
function PropsGuiChangeStyle
 - changes props GUI style
in_param: mode, possible values:
"" - gets option from ini and save it to static PropsHide var
-1 - invert current value of PropsHide and save it to ini
0 - just return PropsHide value
*/
PropsGuiChangeStyle(mode="")
{
	static PropsHide
	if (mode="")
		PropsHide := GetPropsStyle(), GuiControlSet("somechbx",PropsHide,"",12)
	else if ( mode = -1 )
		PropsHide := !PropsHide, SetPropsStyle(PropsHide)
	else
		return PropsHide
	gui,12:default
	Gui,% (PropsHide ? "-" : "+") "Caption +ToolWindow +0x400000" ; +AlwaysOnTop"
	return
}

MG_ChangeIcon(x="",y="")
{
	global NO_ICO_NUM, TV_IL
	TG_ASaveStop(1)
	Gui, 1:Default
	Gui, +Disabled
	Gui, 12:+LastFoundExist
	WinGet, hWnd, ID
	ItemID := TV_GetSelection()
	CurIco := GetIcon( ItemID )
	NewIco := ShowIconsMenu( hWnd, CurIco, x, y )

	if (NewIco = "-1")
	{
		SetIcon(ItemID,"del")
		TV_Modify(ItemID,"Icon" . NO_ICO_NUM)
		TV_Modify(ItemID)
	}
	else if (NewIco != 0)
	{
		sIconPath := IconGetPath(NewIco)
		nIndex := IconGetIndex(NewIco)
		if ItemIcon := TV_IL.Add(sIconPath,nIndex+1)
		{
			TV_Modify(ItemID,"Icon" . ItemIcon)
			TV_Modify(ItemID)
			SetIcon(ItemID,sIconPath . ":" . nIndex)
		}
	}
	Gui, -Disabled
	TVMG_SetControls(ItemID)
	TG_ASaveStop(0)
	return
}

Tree_AddSepar()
{
	global
	Gui,1:Default
	ItemID := TV_GetSelection()
	if ItemID
	{
		TV_GetText(PreItemName,ItemID)
		StringReplace, PreItemName, PreItemName, %SEPARATOR_STRING%, #
		PID := TV_GetParent(ItemID)
		SeparNum := TVCheckName( "#", PID )
		AddNew(SeparNum,PID,PreItemName)
		StringReplace, SeparNum, SeparNum, #, %SEPARATOR_STRING%
		TV_Add(SeparNum, PID, ItemID . " Select" . " Vis" . " Icon" . NO_ICO_NUM)	
	}
	else
	{
		SeparNum:= TVCheckName( "#", 0 )
		AddNew(SeparNum,0,0,1)
		StringReplace, SeparNum, SeparNum, #, %SEPARATOR_STRING%
		TV_Add(SeparNum, 0, "First Select Vis Icon" . NO_ICO_NUM)	
	}
	GuiControl,Focus,AnTreeView	
	return
}

Tree_AddItem()
{
	global
	Critical, Off
	Gui,1:Default
	ItemID := TV_GetSelection()
	if ItemID
	{
		TV_GetText(PreItemName,ItemID)
		StringReplace, PreItemName, PreItemName, %SEPARATOR_STRING%, #
		PID := TV_GetParent(ItemID)
		NewItemName := TVCheckName( "NewShortcut", PID )
		AddNew( NewItemName, PID, PreItemName )
		u_id := TV_Add(NewItemName, PID, ItemID . " Select" . " Vis" . " Icon" . NO_ICO_NUM)
	}
	else
	{
		NewItemName := TVCheckName( "NewShortcut", 0 )
		AddNew(NewItemName,0,0,1)
		u_id := TV_Add(NewItemName, 0, "First Select Vis Icon" . NO_ICO_NUM)	
	}
	TV_Modify(u_id)
	GuiControl,Focus,AnTreeView
	return
}

Tree_AddMenu()
{
	global SEPARATOR_STRING, NO_ICO_NUM
	Critical, Off
	Gui,1:Default
	ItemID := TV_GetSelection()
	if ItemID
	{
		TV_GetText(PreItemName,ItemID)
		StringReplace, PreItemName, PreItemName, %SEPARATOR_STRING%, #
		PID := TV_GetParent(ItemID)
		NewSubName := TVCheckName( "Menu", PID )
		AddNew(NewSubName . "#M#",PID,PreItemName)
		PID := TV_Add(NewSubName, PID, ItemID . " Select Icon" . NO_ICO_NUM)	
		AddNew("NewShortcut",PID)
		TV_Add("NewShortcut", PID, "Vis Icon" . NO_ICO_NUM)
	}
	else
	{
		NewSubName := TVCheckName( "Menu", 0 )
		AddNew(NewSubName . "#M#",0,0,1)
		PID := TV_Add(NewSubName, 0, "Select First Icon" . NO_ICO_NUM)	
		AddNew("NewShortcut",PID)
		TV_Add("NewShortcut", PID, "Vis Icon" . NO_ICO_NUM)
	}
	TV_ArrangeColors(PID)
	GuiControl,Focus,AnTreeView
	return
}

Tree_Expand(Byref mode) ;0-expand,1-collapse
{
	Gui, 1:Default
	ItemID := 0
	GuiControl, -Redraw, AnTreeView
	Loop
	{
		ItemID := TV_GetNext(ItemID, "Full")
		if !ItemID
			break
		if !mode
			TV_Modify(ItemID, "Expand")
		else
			TV_Modify(ItemID, "-Expand")
	}
	GuiControl, +Redraw, AnTreeView
	GuiControl,Focus,AnTreeView
	mode := !mode
	return
}

MG_TV_DeleteItem(id="")
{
	Gui,1:Default
	Gui,+OwnDialogs
	if (id != "")
		ItemID := id
	else
		ItemID := TV_GetSelection()
	if ItemID
	{
		if TV_GetChild(ItemID)
		{
			MsgBox,36,Delete Confirmation,Are you sure you want to delete selected menu?
			IfMsgBox,No
				return
		}
		TG_ASaveStop(1)
		DeleteByID(ItemID)
		TVMG_SetControls(TV_GetSelection())
		GuiControl,Focus,AnTreeView
		TG_ASaveStop(0)
	}
	return
}

CheckTreeEvent( eventInfo, guiEvent )
{
	global TV_hwnd
	static ItemOldName, OldTarget
	Gui,1:Default
	TG_ASaveStop(1)
	if (guiEvent == "D")
		TVDragDrop(eventInfo)
	else if (guiEvent == "K")
	{
		GetKeyState, CtrlH, Ctrl, P
		GetKeyState, UpH, Up, P
		GetKeyState, DownH, Down, P
		GetKeyState, SH, S, P
		GetKeyState, ZH, Z, P
		GetKeyState, XH, X, P
		GetKeyState, DelH, Del, P
		if (CtrlH == "D" && UpH == "D")
			MoveItem("U",TV_GetSelection())
		if (CtrlH == "D" && DownH == "D")
			MoveItem("D",TV_GetSelection())
		if (CtrlH = "D" && SH == "D")
			Tree_AddSepar()
		if (CtrlH = "D" && ZH == "D")
			Tree_AddItem()
		if (CtrlH = "D" && XH == "D")
			Tree_AddMenu()
		if (CtrlH != "D" && DelH == "D")
			MG_TV_DeleteItem()
		CtrlH := UpH := DownH := SH := ZH := XH := DelH := ""
	}
	else if guiEvent in Normal,S,RightClick
	{
		IE_SaveCmd( 3 )		;this saves shortcut target in case user switch item while command still being edited
		TV_Modify(eventInfo)
		SendMessage( TV_hwnd, 0x110B, 0x8, eventInfo )		; Show a focus independent selection over item; TVM_SELECTITEM := 0x110B,	TVGN_DROPHILITE := 0x8
		if ( guiEvent = "RightClick" )
			SetTimer, MG_ShowProps, -5
		HideFocus(1)						;removes focus border from selected item so it could look pretty
		TVMG_SetControls(eventInfo)
	}
	else if (guiEvent=="E")
		OldTarget := GetTarget(eventInfo), TV_GetText( ItemOldName, eventInfo )
	else if (guiEvent=="e")
	{
		TV_GetText(ItemNewName, eventInfo)
		if !(ItemNewName == ItemOldName)
		{
			if !IsValidItemName(ItemNewName, ItemOldName, TV_GetChild(eventInfo), ErrorMsg,TV_GetParent(eventInfo))
			{
				DTP(ErrorMsg,2500)
				TV_Modify(eventInfo,"",ItemOldName)
			}
			else if !ChangeName(eventInfo,ItemNewName,ItemOldName,OldTarget)
			{
				DTP("Invalid name CN")
				TV_Modify(eventInfo,"Select",ItemOldName)
			}
			else
			{
				TVMG_SetControls(eventInfo)
				TV_Modify(eventInfo,"Select Vis")
			}
		}
		free( ItemOldName ), free( OldTarget )
	}
	else if (guiEvent=="DoubleClick")
		if !TV_GetChild( eventInfo )
		{
			SendMessage( TV_hwnd, TVM_EDITLABELW := 0x1100 + 65, 0, eventInfo )
			OldTarget := GetTarget(eventInfo), TV_GetText( ItemOldName, eventInfo )
		}
	TG_ASaveStop(0)
	return
}

TV_SyncTargetFields( mode, itemID = "" ) ;1 - Edit to LV, 2 - LV to Edit
{
	global hMG_TB_Cmd
	if (mode = 1)
		MG_EditToList(GuiControlGet("STarget",1))
	else if (mode = 2)
		MG_ListToEdit()
	IE_TBSaveEnable()
	if (TargetAutoSave() == 1)
		SyncTargetSave( itemID )
	return
}

SyncTargetSave( itemID = "" )
{
	global SEPARATOR_STRING,hMG_TB_Cmd, opt
	Gui, 1:Default
	ItemID := itemID = "" ? TV_GetSelection() : itemID
	TV_GetText(itemname,ItemID)
	if (TV_GetChild(ItemID) || ItemID=0 || itemname==SEPARATOR_STRING)
		return
	tg := GuiControlGet("STarget",1)
	if (tg != "ERROR")
	{
		SelectionTarget := GetTarget(ItemID)
		SaveTarget(tg,SelectionTarget)
		IE_TBSaveEnable( 0 )
	}
	Else
		DTP("Invalid target!")
	return
}

TargetAutoSave(mode="")	;1 - toggle, blank - return current value
{
	global hMG_TB_Cmd
	static isAutosave
	if isAutosave not in 0,1
		isAutosave := GetTargetAutosaveState()
	if (mode == "")
		return isAutosave
	else if mode
		isAutosave := !isAutosave
		,SetTargetAutosaveState(isAutosave)
	Menu, Settings, % isAutosave ? "Check" : "Uncheck", Target &Autosave
	saveButtonName := "Save" . (isAutosave ? " (Auto)" : "")
	Toolbar_SetButtonText(hMG_TB_Cmd,2,saveButtonName)
	return isAutosave
}

;target autosave switch
TG_ASaveStop(mode="")	;if mode = 1, then disable autosave, otherwise reenable
{
	static disablecount, stop_autosave
	if (mode = 2)
		stop_autosave := 0
	else if (mode = 1)
	{
		disablecount++
		stop_autosave := 1
		SetTimer,ReEnable_TargAS,OFF
	}
	else if (mode = 0 && (--disablecount <= 0))
	{
		SetTimer,ReEnable_TargAS,-10
		disablecount := 0
	}
	return stop_autosave
	
	ReEnable_TargAS:
		TG_ASaveStop(2)
		return	
}

SaveTarget( target, key )
{
	def = ^"\s*[^"].*?[^"]\s*"$
	repl = ""
	repl_s = ^\s*"|"\s*$
	if RegExMatch( target, def )	;if target is enclosed in quotes once from the both sides
		target := RegExReplace( target, repl_s, repl )		;then we make em double quotes because one from each side will be removed on ini reading
	ItemSet( key, "Targets", target )
	return
}

SetTreeColors(mode=1)	;if -1 then toggle, otherwise just use current state of this option
{
	global AnTreeView,TV_hwnd,MENU_COLOR_DEFAULT,TEXT_COLOR_DEFAULT,MAIN_SECTION_NAME
	global global_tvDefColors
	;1 - default colors, 0 - colorful tree
	global_tvDefColors := global_tvDefColors="" ? GetTVDefColors() : global_tvDefColors
	if ( mode = -1 )
		global_tvDefColors := SetTVDefColors( !global_tvDefColors )	;toggle
	TV_Bg_Color := "0x" . (global_tvDefColors ? RGBtoBGR(MENU_COLOR_DEFAULT) : GetMenuColor(MAIN_SECTION_NAME,"MenuColor"))
	TV_T_Color := "0x" . (global_tvDefColors ? RGBtoBGR(TEXT_COLOR_DEFAULT) : GetMenuColor(MAIN_SECTION_NAME,"TextColor"))
	Menu, Settings, % global_tvDefColors ? "Check" : "Uncheck", Use &Default List Colors
	SendMessage( TV_hwnd, 0x1100 + 29, 0, TV_Bg_Color )			;Private Const TVM_SETBKCOLOR As Long = (TV_FIRST + 29)
	SendMessage( TV_hwnd, 0x1100 + 30, 0, TV_T_Color )			;Private Const TVM_SETTEXTCOLOR As Long = (TV_FIRST + 30)
	SendMessage( TV_hwnd, TVM_SETINSERTMARKCOLOR := 0x1100 + 37, 0, TV_T_Color )		;color of insert mark when dragging = color of text
	;~ TV_Redraw()
	return
}

;############################### MENU GET BG T COLOR
;which = "t" or "bg"
MenuSetColor(which,ItemID,Color)
{
	Gui, 1:Default
	if which not in t,bg
		return
	p := which = "t" ? "TextColor" : which = "bg" ? "MenuColor" : ""
	MenuSection := GetTarget(ItemID)
	if (Color == "del")
		ItemDel(p,MenuSection)
	else
		ItemSet(p,MenuSection,Color)
	return Color
}
;############################### SET HOTKEY
SaveCustomHotkey(ID,hotkey)
{
	Gui,1:Default
	MenuSection := GetTarget(TV_GetParent(ID))
	TV_GetText(ItemName,ID)
	order := 0
	Loop
	{
		name := ItemGet(order,MenuSection)
		if (name == "ERROR")
			break
		StringReplace, name, name, #B#
		StringReplace, name, name, #M#
		if (name == ItemName)
		{
			ItemDel(order . "#HOTKEY",MenuSection)
			if (hotkey != "" && hotkey != "#")
				ItemSet(order . "#HOTKEY",MenuSection,hotkey)
			else
				ItemDel(order . "#HOTKEY",MenuSection)
			break
		}
		order++
	}
	return
}

GetCustomHotkey(ID) {
	MenuSection := GetTarget(TV_GetParent(ID))
	TV_GetText(ItemName,ID)
	order := 0
	Loop
	{
		name := ItemGet(order,MenuSection)
		if (name == "ERROR")
			return ""
		StringReplace, name, name, #B#
		StringReplace, name, name, #M#
		if (name == ItemName)
		{
			hotkey := ItemGet(order . "#HOTKEY",MenuSection)
			if (hotkey != "ERROR")
				Return hotkey
			else 
				return ""
		}
		order++
	}
}

;############################### SET ICON
SetIcon( ID,Icon )
{
	global SEPARATOR_STRING
	MenuSection := GetTarget(TV_GetParent(ID))
	TV_GetText(ItemName,ID)
	order := 0
	Loop
	{
		name := ItemGet(order,MenuSection)
		if (name == "ERROR")
			break
		StringReplace, name, name, #B#
		StringReplace, name, name, #M#
		if (name == ItemName)
		{
			ItemDel(order . "#ICON",MenuSection)
			if (icon != "del")
				ItemSet(order . "#ICON",MenuSection,Icon)
			break
		}
		order++
	}
	return
}

MenuChangeColorChoose(which,buttonPos)
{
	global hMainGuiPropToolbar
	static menu_created, s_which
	s_which := which
	if !menu_created
	{
		Menu, MG_MenuColorsOpt, add, Change..., MColorChangeTimer
		Menu, MG_MenuColorsOpt, add, Set to Default, MColorResetToDefault
		Menu, MG_MenuColorsOpt, add, Set to Parent's, MColorResetToParent
		menu_created := 1
	}
	ControlGetPos,x,y,w,h,,ahk_id %hMainGuiPropToolbar%
	p := StrSplit(Toolbar_GetRect(hMainGuiPropToolbar,buttonPos)," ")
	x += p[1], y += p[2]
	CoordMode,Menu,Relative
	Menu,MG_MenuColorsOpt,Show,% X,% y+p[4]
	return
	
	MColorChangeTimer:
		SetTimer,MColorChange,-1
		return
	MColorChange:
		MenuChangeColor(s_which)
		return
	MColorResetToDefault:
		MenuChangeColor(s_which,1)
		return
	MColorResetToParent:
		MenuChangeColor(s_which,2)
		return
}

; which = "t" or "bg"
; flag, 0 - change color, 1 - to default, 2 - get parent menu's color
MenuChangeColor(which,flag = 0)
{
	global MENU_COLOR_DEFAULT, TEXT_COLOR_DEFAULT, global_tvDefColors, PropsGui_IsKeepActive
	Gui, 1:Default
	if which not in t,bg
		return
	ItemID := TV_GetSelection()
	if !TV_GetChild(ItemID)
		return
	if (flag = 1)					;set color to default
		Color := MenuSetColor(which,ItemID,which = "t" ? TEXT_COLOR_DEFAULT : MENU_COLOR_DEFAULT)
	else if (flag = 2)				;set colors to parent menu's
	{
		MenuSetColor(which,ItemID,"del")
		Color := MenuGetColor(which,ItemID)
	}
	else							;show choose color dlg
	{
		Color := MenuGetColor(which,ItemID)
		Color := "0x" . Color
		Gui, 1:+Disabled
		PropsGui_IsKeepActive := 1
		Gui, 12:+LastFoundExist
		if Dlg_Color(Color,WinExist())
		{
			StringReplace, Color, Color, 0x
			MenuSetColor(which,ItemID,Color)
		}
		else
			goto,chlmg_end
	}	
	if (!ItemID && !global_tvDefColors)			;if changing colors of topmost menu - change color of TV bg
		MG_ChangeTVBG(Color,which)
	TV_ArrangeColors(ItemID,1)
chlmg_end:
	Gui, 1:-Disabled
	PropsGui_IsKeepActive := 0
	sleep 50
	TV_Modify(ItemID)
	return
}

MG_ChangeTVBG(clr,which)
{
	global TV_hwnd
	if which not in t,bg
		return
	Color := "0x" . RGBtoBGR(clr)
	if (which = "bg")
		SendMessage( TV_hwnd, 0x1100 + 29, 0, Color )			;Private Const TVM_SETBKCOLOR As Long = (TV_FIRST + 29)	
	else
		SendMessage( TV_hwnd, 0x1100 + 30, 0, Color )			;Private Const TVM_SETTEXTCOLOR As Long = (TV_FIRST + 30)		
		,SendMessage( TV_hwnd, 0x1100 + 37, 0, Color )		;TVM_SETINSERTMARKCOLOR, color of insert mark when dragging = color of text
	return
}

;############################### SET ITEM BOLD
SetItemBold(ItemID,mode=1)
{
	Gui, 1:Default
	TV_GetText(ItemName, ItemID)
	MenuSection := GetTarget(TV_GetParent(ItemID))
	order := 0
	Loop
	{
		name := ItemGet(order,MenuSection)
		if (name == "ERROR")
			break
		StringReplace, name, name, #M#
		StringReplace, name, name, #B#
		if (name == ItemName)
		{
			name := ItemGet(order,MenuSection)
			if mode
				ItemSet(order,MenuSection,name . "#B#")
			else
			{
				StringReplace, name, name, #B#
				ItemSet(order,MenuSection,name)
			}
			break
		}
		order++
	}
	return
}
;############################### MENU GET BG T COLOR
;which = "t" or "bg"
MenuGetColor(which,ItemID,OnlyFirst=0)
{
	Gui, 1:Default
	global MAIN_SECTION_NAME, MENU_COLOR_DEFAULT, TEXT_COLOR_DEFAULT
	if which not in t,bg
		return
	if !TV_GetChild(ItemID)
		ItemID := TV_GetParent(ItemID)
	MenuSection := GetTarget(ItemID)
	Loop
	{
		color := ItemGet(which = "t" ? "TextColor" : "MenuColor",MenuSection)
		if (color != "ERROR" && color != "")
			break
		if (MenuSection == MAIN_SECTION_NAME)
		{
			color := which = "t" ? TEXT_COLOR_DEFAULT : MENU_COLOR_DEFAULT
			break
		}
		if OnlyFirst
			return ""
		ItemID := TV_GetParent(ItemID)
		MenuSection := GetTarget(ItemID)
	}
	return color
}
;############################################################
; Sorting Functions
/*
SortMenu - main function, that determine sorting type
GetMenuList - getting list of items from menu for sorting
SetMenuList - putting sorted list of items back to menu
RebuildTVMenu - Rebuilding specified menu
SortMenusTop - custom sort function to place submenus at the top
SortMenusBot - custom sort function to place submenus at the bottom
*/
;############################################################
SortMenu(MenuID,SortType)
{
	GUI,1:Default
	TV_Modify(MenuID,"Expand Select")
	menu_target := GetTarget(MenuID)
	ItemsList := GetMenuList(menu_target,SeparList,IconsList,HotkeysList)
	if (SortType == "A")
		Sort, ItemsList
	if (SortType == "ATop")
		Sort, ItemsList, F SortMenusTop
	if (SortType == "ABot")
		Sort, ItemsList, F SortMenusBot
	if (SortType == "R")
		Sort, ItemsList, Random
	SetMenuList(menu_target,ItemsList,SeparList,IconsList,HotkeysList)
	RebuildTVMenu(MenuID,menu_target)
	TV_ArrangeColors(MenuID,1)
	return	
}

GetMenuList(MenuTarget,ByRef SeparList,ByRef IconsList,ByRef HotkeysList)
{
	order = 0
	SeparList =
	IconsList =
	Loop
	{
		Menu_Item := ItemGet(order,MenuTarget)
		if	(Menu_Item = "ERROR")
			break
		if (SubStr(Menu_Item,1,1) = "#")
		{
			if RegExMatch(Menu_Item,"^#[0-9]*$")
			{
				StringReplace, Menu_Item, Menu_Item, #,,All
				SeparList := SeparList . order . "-"
				order++
				continue
			}
			loop, 2
			{
				flag = SubStr(Menu_Item,1,3)
				if (flag = "#B#" || flag = "#M#")
				{
					StringReplace, Menu_Item, Menu_Item,%flag%
					Menu_Item := Menu_Item . flag
				}
				Else
					break
			}
		}
		ItemsList .= Menu_Item . "`n"
		ItemIcon := ItemGet(order . "#ICON",MenuTarget)
		if (ItemIcon != "ERROR")
			IconsList := IconsList . Menu_Item . "#ICON#" . ItemIcon . "`n"
		ItemHotkey := ItemGet(order . "#HOTKEY",MenuTarget)
		if (ItemHotkey != "ERROR")
			HotkeysList := HotkeysList . Menu_Item . "#HOTKEY#" . ItemHotkey . "`n"
		order++
	}
	Return ItemsList
}

SetMenuList(MenuTarget,ItemsList,SeparList,IconsList,HotkeysList)
{
	order = 0
	Loop
	{
		NextItem := ItemGet(order,MenuTarget)
		if (NextItem = "ERROR")
			break
		ItemDel(order,MenuTarget)
		ItemDel(order . "#ICON",MenuTarget)
		ItemDel(order . "#HOTKEY",MenuTarget)
		order++
	}
	spr_cnt = 0
	Loop, parse, SeparList, -	;putting separators first
	{
		if (A_LoopField = "")
			continue
		ItemSet(A_LoopField,MenuTarget,"#" . num := spr_cnt = 0 ? "" : spr_cnt)
		spr_cnt++
		num =			
	}
	order = 0
	Loop, Parse, ItemsList, `n,`r
	{
		if (A_LoopField = "")
			continue

		Loop
			if RegExMatch(SeparList,"(^|-)" . order . "-")
				order++
			Else
				break
		ItemSet(order,MenuTarget,A_LoopField)
		if RegExMatch(IconsList,"`a)(^|`n)" . A_LoopField . "#ICON#.+($|`n)",IconStr)
		{
			StringReplace, IconStr, IconStr, #ICON#, ¶, All
			StringSplit,Field,IconStr,¶
			ItemSet(order . "#ICON",MenuTarget,Field2)
		}
		if RegExMatch(HotkeysList,"`a)(^|`n)" . A_LoopField . "#HOTKEY#.+($|`n)",HotkeyStr)
		{
			StringReplace, HotkeyStr, HotkeyStr, #HOTKEY#, ¶, All
			StringSplit,Field,HotkeyStr,¶
			ItemSet(order . "#HOTKEY",MenuTarget,Field2)
		}
		order++
	}
	return 1
}

RebuildTVMenu(PID,MenuTarget)
{
	Gui, 1:Default
	Loop
	{
		PCID := TV_GetChild(PID)
		if !PCID
			break
		TV_Delete(PCID)
	}
	BuildTree(PID,MenuTarget)
	if TV_Get(PID,"Expand")
		TV_Modify(PID,"Select VisFirst")
	else
		TV_Modify(PID,"Select Vis")
	return
}

SortMenusTop(item1,item2)
{
	resl1 := InStr(item1,"#M#")
	resl2 := InStr(item2,"#M#")
	if (resl1 && !resl2)
		return -1
	if (!resl1 && resl2)
		return 1
	if ((resl1 && resl2) || (!resl1 && !resl2))
	{
		if (item1 > item2)
			return 1
		else if (item1 = item2)
			return 0
		else
			return -1
	}
}

SortMenusBot(item1,item2)
{
	resl1 := InStr(item1,"#M#")
	resl2 := InStr(item2,"#M#")
	if (resl1 && !resl2)
		return 1
	if (!resl1 && resl2)
		return -1
	if ((resl1 && resl2) || (!resl1 && !resl2))
	{
		if (item1 > item2)
			return 1
		else if (item1 = item2)
			return 0
		else
			return -1
	}
}

MG_CreateSMenu()
{
	global PropsGui_IsKeepActive
	Gui, 12:+OwnDialogs
	PropsGui_IsKeepActive := 1
	Gui, 1:+Disabled
	smenu := OptGet("smenu_on")
	if (smenu!=1)
	{
		MsgBox,36,S-Menu disabled,It seems that S-Menu has not be enabled yet`. You can do this now or later in "Settings". Enabling this feature will require some writing to the registry.`n`nWould you like to go ahead an enable S-Menu now?
		IfMsgBox,No
		{
			Gui, 1:-Disabled
			return
		}
		CheckSMenuRegs()
		OptSet("smenu_on",1)
	}
	Gui, 1:Default
	MID := TV_GetSelection()
	if MID
		TV_GetText(menuname, MID)
	else
		menuname := "Main Menu"
	FileSelectFile, dest_file, S18,% PathCleanup( menuname . ".qcm" ),Choose where to save menu,Quick Click Menu (*.qcm)
	if dest_file
	{
		SplitPath, dest_file,,,dest_Ext
		if (dest_Ext = "")
			dest_file .= ".qcm"
		CopySMenu(MID,dest_file)
	}
	Gui, 1:-Disabled
	PropsGui_IsKeepActive := 0
	return
}

MG_DropFiles(ctrl_name,dropped_files)
{
	global TV_hwnd,TargetHWND,IE_LV_hwnd,MULTI_TARGET_DIVIDER,MAIN_SECTION_NAME,SEPARATOR_STRING
	global TV_IL,REMOTE_ICO,FOLDER_ICO,NO_ICO_NUM
	Gui,1:Default
	SelectedItemID := TV_GetSelection()
	if (ctrl_name = "STarget")
	{
		if !ClIsEnabled(TargetHWND)
			DTP("Fail to add commands!")
		else
		{
			SplashWait(1)
			Loop, parse, dropped_files, `n
			{
				SplitPath, A_LoopField,,,FileExt
				if (FileExt = "lnk")
				{
					FileGetShortcut, %A_LoopField%, Target,, Args
					tg = "%Target%" %Args%
				}
				else
					tg = "%A_LoopField%"
				tt .= (A_Index = 1 ? (GuiControlGet("STarget") ? " " MULTI_TARGET_DIVIDER " " : "") : " " MULTI_TARGET_DIVIDER " ") . tg
			}
			GuiControlSet("STarget",GuiControlGet("STarget") . tt)
			tt =
			ControlSend,, {End}, ahk_id %TargetHWND%
			TV_SyncTargetFields(1)
		}
	}
	else if (ctrl_name = "Item_Edit_LV")
	{
		if !ClIsEnabled(IE_LV_hwnd)
			DTP("Fail to add commands!")
		else
		{
			SplashWait(1)
			Loop, parse, dropped_files, `n
			{
				tg := A_LoopField
				SplitPath, tg,,,FileExt
				if (FileExt = "lnk")
				{
					FileGetShortcut, %A_LoopField%, Target,, Args
					tg = "%Target%" %Args%
				}
				else
					tg = "%tg%"
				LV_Add("", tg)
			}
			TV_SyncTargetFields(2)
		}
	}
	else if (ctrl_name = "AnTreeView")
	{
		SplashWait(1)
		Loop, parse, dropped_files, `n
		{
			DroppedFile = %A_LoopField%
			SplitPath, DroppedFile,,FileDir,FileExt,DroppedFileName
			DroppedFileName := RegExReplace(DroppedFileName, "i)^" . MAIN_SECTION_NAME . "$|#|" . SEPARATOR_STRING . "|^$|ERROR", "_")
			if (FileExt = "lnk")
			{
				FileGetShortcut, %DroppedFile%, Target,, Args,, IconPath, IconNum
				IfNotExist, %Target%
					Continue
				DroppedFile := Target . A_Space . Args
				SplitPath, Target,,,t_Ext
				FileGetAttrib, af_attribs, %Target%
				if instr(af_attribs,"D")
				{
					if RegExMatch(Target,"^\\.*")
						ico_d := REMOTE_ICO
					else
						ico_d := FOLDER_ICO
				}
				else if (t_Ext = "exe")
				{
					if (IconPath == "")
						IconPath := Target
					if (IconNum == "")
						IconNum := 0					
					ico_d = %IconPath%:%IconNum%
				}
				else if (t_Ext = "ico")
					ico_d = %Target%
				else
					ico_d := IconFromExt(t_Ext)
				if (ico_d = 0)
					ico_d := ""
			}
			else
			{
				FileGetAttrib, af_attribs, %DroppedFile%
				if instr(af_attribs,"D")
				{
					if RegExMatch(DroppedFile,"^\\.*")
						ico_d := REMOTE_ICO
					else
						ico_d := FOLDER_ICO
				}
				else if (FileExt = "exe")
					ico_d = %DroppedFile%:0
				else if (FileExt = "ico")
					ico_d = %DroppedFile%
				else
					ico_d := IconFromExt(FileExt)
				if (ico_d = 0)
					ico_d := ""
			}
			if (DroppedFileName = "" || DroppedFileName = "_")
				DroppedFileName := FileDir
			if TV_GetChild(SelectedItemID)
				PID := SelectedItemID
			else
				PID := TV_GetParent(SelectedItemID)
			NewItemName := TVCheckName( DroppedFileName, PID )
			TV_GetText( pre_name, SelectedItemID )
			DroppedFile = ""%DroppedFile%""
			AddNew(NewItemName, PID, pre_name, 0, ico_d, 0, DroppedFile)
			iIcon := TV_IL.Add( IconGetPath(ico_d), IconGetIndex(ico_d)+1)
			if (iIcon==0) ;if no icons found in the file
				iIcon := NO_ICO_NUM
			SelectedItemID := TV_Add(NewItemName, PID,"Select Vis Icon" . iIcon . " " . (PID == SelectedItemID ? "First" : SelectedItemID))
		}
	}
	else
	{
		DTP("Drag files to the menu to add them as shortcuts`nor to the commands list to add their paths",5000)
		Gui, 1:+LastFoundExist
		HLControl(WinExist(),TV_hwnd . (ClIsVisible(TargetHWND) ? "|" . TargetHWND : "") . (ClIsVisible(IE_LV_hwnd) ? "|" . IE_LV_hwnd : ""))
	}
	GuiControl, MoveDraw, AnTreeView
	SplashWait(0)
	return	
}

MG_Resize(guiNewWidth,guiNewHeight)
{
	critical	;fixes problem when controls wont resize on window resizing
	global hMG_TB_Cmd, TV_hwnd
	Gui,1:Default
	gui_width := guiNewWidth - 20
	;~ TV_height := guiNewHeight-250
	TV_height := guiNewHeight*0.6
	tg_edit_h := lv_h := guiNewHeight - TV_height - 120
	sw_but_y := TV_height + 35
	sw_but_x := guiNewWidth - 40
	label_y := sw_but_y + 30
	tg_edit_y := lv_y := label_y + 20
	GuiControl,MoveDraw,AnTreeView,% "w" gui_width " h" TV_height
	GuiControl,MoveDraw,STarget,% "w" gui_width " y" tg_edit_y " h" tg_edit_h
	GuiControl,MoveDraw,gbTarget,% "w" gui_width " y" label_y
	GuiControl,MoveDraw,Item_Edit_LV,% "w" gui_width " y" lv_y " h" lv_h
	GuiControl,MoveDraw,SwitchCmdViewVar,% "x" sw_but_x " y" sw_but_y
	GuiControl,MoveDraw,AfoSB
	;x,y coords used by ControlMove different from GuiControl,MoveDraw, but the same as given us by ControlGetPos
	ControlGetPos,x,y,w,h,,ahk_id %TV_hwnd%
	TB_y := y + h + 5
	ControlMove,,,% TB_y,,,ahk_id %hMG_TB_Cmd%
	LV_ModifyCol(1,gui_width-30)
	return
}