﻿
System_Shortcut_Gui(Parent_Gui = 1,ByRef out_target = "",ByRef out_name = "") {
	Global Shortcuts_Listbox, Shortcuts_Listview, MULTI_TARGET_DIVIDER, The_Infinite_Source_of_money	;GUI controls must be global
	global butt_add,butt_runas,butt_run,butt_send_new_shcut,SYS_GUI_TITLE, global_NoGuiTheme

	out_target := out_name := ""

	Menu, ShortcutGuiMenu, Delete						;need to destroy this menu each time gui opens to avoid same items appears -Whoops my bad!

	Menu, ShortcutGuiMenu, Add, Add Selected, Add_SHcuts_list

	Gui, %Parent_Gui%:+Disabled
	Gui, 23:Default
	Gui, +owner%Parent_Gui%
	Gui, +ToolWindow +LastFound
	if global_NoGuiTheme
		Gui,-Theme
	Gui,Add,Text,,Category
	Gui,Add,Text,x+60,Shortcuts
	Gui, add, Listbox,xm w100 h300 vShortcuts_Listbox gLoad_List Multi, Control Panel|System Folders|Utilities|IE|System Commands|Window Commands
	PostMessage, 0x185, 1, -1, ListBox1  ; Select all categories. 0x185 is LB_SETSEL.
	Gui, add, listview, w450 hp yp x+5 vShortcuts_Listview gLV_list_Events AltSubmit Sort, Description|Command		;i've made the height = hp which means it will be equal to previous control's height
	LV_ModifyCol(1, 250)
	Gui,Add,Text,xm+60,Search
	Gui,Add,Edit,R1 x115 yp-3 w450 vThe_Infinite_Source_Of_Money gSearch +0x800000
	Gui, add, Button, w110 h30 xm vbutt_add gAdd_SHcuts_list, Add Selected
	Gui, add, Button, w70 h30 x+295 vbutt_run gTestSHcuts, Test
	Gui, add, Button, w70 h30 x+5 vbutt_runas gTestSHcuts, Test As Admin
	Gui %Parent_Gui%:+LastFoundExist
	parent_hwnd := WinExist()
	WinGetPos, X, Y, W, H, AHK_ID %parent_hwnd%
	Gui, show,% "x" . round(x+w/2-285) . " y" . round(y+h/2-200), %SYS_GUI_TITLE%
	SetTimer,Load_List,-100				;getting items from selected categories

	GuiControl,Focus,The_Infinite_Source_Of_Money
	SetTimer,Check_Buttons_State,100
	sleep, 500
		Loop
		{
			GuiControlGet, Shortcuts_Listbox ,, Shortcuts_Listbox
			if ErrorLevel
				break
			sleep 100
		}
Return

Check_Buttons_State:					;main buttons will be disabled if no any item selected in LV
	Gui, 23:Default
	if LV_GetNext()
		state := 1
	else
		state := 0
	GuiControl,Enable%state%,butt_add
	GuiControl,Enable%state%,butt_run
	GuiControl,Enable%state%,butt_runas
	return

CloseSGui:
23GuiClose:
23GuiEscape:
	Gui, %Parent_Gui%:-Disabled
	Gui, 23:Destroy
	SetTimer,Check_Buttons_State,OFF
	ToolTip
	Gui, %Parent_Gui%:Default
	return

Search:
	SetTimer,Search_Start,-250
	return

Search_Start:
	Critical
	Query := GuiControlGet("The_Infinite_Source_Of_Money",23)
	if (Query = "")
		search_list := shortcuts_list
	else
	{
		
		Loop,parse,shortcuts_list,`n,%A_Space%%A_Tab%
		{
			Current_Shortcut := A_LoopField
			token_count =
			token_found =
			loop,parse,Query,%A_Space%,%A_Tab%			; Parsing query string by SPACE
			{
				if (A_LoopField = "")
					return
				token_count++								; Count of words user entered
				if instr( Current_Shortcut, A_LoopField )
					token_found++							; Count of words found in current shortcut
			}
			if (token_count == token_found)					; If all words were found
				search_list .= Current_Shortcut . "`n"
		}
		Current_Shortcut = 
	}
	Build_List(search_list)
	search_list =
	return



LV_list_Events:
	Gui, 23:Default
	if (A_GuiEvent = "DoubleClick")
	{
		LV_GetText(RunString, A_EventInfo, 2)
		LV_GetText(RunName, A_EventInfo, 1)
		out_target := RunString
		out_name := RunName
		GoTo,CloseSGui
	}
	else if (A_GuiEvent = "RightClick")
		SetTimer,Show_SHcutsContextMenu,-100
	return

Show_SHcutsContextMenu:
	Menu, ShortcutGuiMenu, Show
	return

Add_SHcuts_list:
	Gui, 23:Default
	sel_count := LV_GetCount("Selected")
	if (sel_count = 0)
		return
	System_Shortcut =
	row := 0
	Loop
	{
		row := LV_GetNext(row)
		if !row
			break
		LV_GetText(cmd, row, 2)
		LV_GetText(name, row, 1)
		System_Shortcut .= (A_Index = 1) ? cmd : (MULTI_TARGET_DIVIDER . cmd)
	}
	if (sel_count = 1)
		out_name := name
	out_target := System_Shortcut
	GoTo, CloseSGui
	return

TestSHcuts:
	Gui, 23:Default
	Gui +OwnDialogs
	LV_GetText(RunString, LV_GetNext(), 2)
	LV_GetText(Name, LV_GetNext(), 1)
	err = 0
	if RegExMatch(RunString, "i)^\s*(win_casc|win_tasksw|win_tileh|win_min|win_unmin|win_togd|win_tilev)\s*$")
	{
		WinCmd(RunString)
		return
	}
	if (A_GuiControl = "butt_run")
	{
		Run,% RunString,,UseErrorLevel
		If errorlevel
			err := 1
	}
	else if (A_GuiControl = "butt_runas")
	{
		args := PathGetArgs(RunString)
		PathRemoveArgs(RunString)
		ret := API_ShellExecute(RunString,args, 0,"RUNAS")
		if (ret < 32)
			err := 1
	}
	If err
		MsgBox,16,Could not run target, It appears the command "%Name%" is not working.`nThis could be because of your account permissions`nor the command does not work in your current version of Windows.
	return

Load_List:
	Gui, 23:Default
	gui, submit, nohide
	shortcuts_list =
	Loop, parse,Shortcuts_Listbox, |,%A_Space%%A_Tab%
	{
		If (A_LoopField = "Control Panel")
			shortcuts_list .= System_Shortcut_Control() . "`n"
		If (A_LoopField = "System Folders")
			shortcuts_list .= System_Shortcut_Shell() . "`n"
		If (A_LoopField = "IE")
			shortcuts_list .= System_Shortcut_IE() . "`n"
		If (A_LoopField = "System Commands")
			shortcuts_list .= System_Commands() . "`n"
		If (A_LoopField = "Utilities")
			shortcuts_list .= System_Shortcut_Utilities() . "`n"
		If (A_LoopField = "Window Commands")
			shortcuts_list .= System_Shortcut_Win_Commands() . "`n"
	}
	goSub, Search_Start				;calling this label to ensure the only items matched to search string will be shown at new category selecting
	return

}

Build_List(list) { ;Takes a `n delimited list with Shortcutname . "@" . Shortcut_Command
	global Shortcuts_Listview
	
	Gui, 23:Default
	LV_Delete()
	Loop, parse, list, `n,%A_Space%%A_Tab%
	{
		if (A_LoopField = "")
			continue
		StringSplit, L_,  A_LoopField, @, %A_Tab%%A_Space%
		LV_Add("", L_1, L_2)
	}
	LV_ModifyCol(2, "AutoHdr")
}

System_Shortcut_Control() {
	
	Build_List = 
	(LTrim
		Add Hardware Wizard@hdwwiz.cpl
		Add/Remove Programs@appwiz.cpl
		Administrative Tools@control admintools
		Certificate Manager@certmgr.msc
		Character Map@charmap
		Check Disk Utility@cmd /k chkdsk
		Component Services@dcomcnfg
		Computer Management@compmgmt.msc
		Control Panel@control
		Date and Time Properties@timedate.cpl
		Device Manager@devmgmt.msc
		Direct X Troubleshooter@dxdiag
		Disk Cleanup Utility@cleanmgr
		Disk Management@diskmgmt.msc
		Display Properties@desk.cpl
		Event Viewer@eventvwr.msc
		Fonts@control fonts
		Fonts Folder@fonts
		Game Controllers@joy.cpl
		Group Policy Editor@gpedit.msc
		Internet Properties@inetcpl.cpl
		Keyboard Properties@control keyboard
		Local Users and Groups@lusrmgr.msc
		Mouse Properties@main.cpl
		Performance Monitor@perfmon.msc
		Power Configuration@powercfg.cpl
		Printers and Faxes@control printers
		Private Character Editor@eudcedit
		Regional Settings@intl.cpl
		Scheduled Tasks@control schedtasks
		Security Center@wscui.cpl
		Services@services.msc
		Shared Folders@fsmgmt.msc
		Sounds and Audio@mmsys.cpl
		SQL Client Configuration@cliconfg
		System Information@msinfo32
		System Properties@sysdm.cpl
		Utility Manager@utilman
		User Accounts@control userpasswords2
		Windows Firewall@firewall.cpl
		Windows Update@shell:::{36eef7db-88ad-4e81-ad49-0e313f0c35f8}
		Windows System Security Tool@syskey
		Safely Remove Hardware Dialog Box@Rundll32 Shell32.dll,Control_RunDLL HotPlug.dll
		Windows - About@RunDll32.exe SHELL32.DLL,ShellAboutW
	)
Return Build_List
}

System_Shortcut_Shell() {
	
	Build_List = 
	(LTrim
		Add New Programs Folder@Shell:AddNewProgramsFolder
		AppData@Shell:AppData
		Cache@Shell:Cache
		CD Burning@Shell:CD Burning
		My Computer@shell:MyComputerFolder
		Recycle Bin@shell:RecycleBinFolder
		Administrative Tools Folder@shell:Administrative Tools
		Change/Remove Programs@shell:ChangeRemoveProgramsFolder
		Network@shell:NetworkPlacesFolder
		User Profiles@shell:UserProfiles
		Profile Folder@shell:Profile
		Public Folder@shell:Public
		Common Administrative Tools@Shell:Common Administrative Tools
		Common AppData@Shell:Common AppData
		Common Desktop@Shell:Common Desktop
		Common Documents@Shell:Common Documents
		Common Programs@Shell:Common Programs
		Common Start Menu@Shell:Common Start Menu
		Common Startup@Shell:Common Startup
		Common Templates@Shell:Common Templates
		Common Downloads@Shell:CommonDownloads
		Common Music@Shell:CommonMusic
		Common Pictures@Shell:CommonPictures
		Common Video@Shell:CommonVideo
		Network Connections@Shell:ConnectionsFolder
		Contacts@Shell:Contacts
		Control Panel Folder@Shell:ControlPanelFolder
		Cookies@Shell:Cookies
		CredentialManager@Shell:CredentialManager
		CryptoKeys@Shell:CryptoKeys
		Default Gadgets@Shell:Default Gadgets
		Desktop@Shell:Desktop
		Downloads@Shell:Downloads
		DpapiKeys@Shell:DpapiKeys
		Favorites@Shell:Favorites
		Fonts@Shell:Fonts
		Gadgets@Shell:Gadgets
		Games@Shell:Games
		History@Shell:History
		Links@Shell:Links
		Local AppData@Shell:Local AppData
		Local AppDataLow@Shell:LocalAppDataLow
		My Music@Shell:My Music
		My Pictures@Shell:My Pictures
		My Video@Shell:My Video
		Printers and Faxes@control printers
		Quick Launch@shell:Quick Launch
	)
Return Build_List
}

System_Shortcut_IE() {
	
	Build_List = 
	(LTrim
		Delete Temporary Internet Files@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 8
		Delete Cookies@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 2
		Delete History@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 1
		Delete Form Data@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 16
		Delete Passwords@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 32
		Delete All@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 255
		Delete All + files and settings stored by Add-ons@RunDll32.exe InetCpl.cpl,ClearMyTracksByProcess 4351
		Display Organize Favorites Dialog@RUNDLL32.EXE shdocvw.dll,DoOrganizeFavDlg
	)
Return Build_List
}

System_Commands() {
	
	Build_List = 
	(LTrim
		Hibernate@RunDll32.exe powrprof.dll,SetSuspendState
		Lock Screen@RunDll32.exe user32.dll,LockWorkStation
		Map Network Drive Wizard@Rundll32 Shell32.dll,SHHelpShortcuts_RunDLL Connect
		Logs You Out Of Windows@logoff
		Shutdown Computer@shutdown /s /d p:0:0 /t 0
		Shutdown (Force)@shutdown /p /d p:0:0
		Restart Computer@shutdown /r /d p:0:0 /t 0
		Restart (Force)@shutdown /r /f /d p:0:0 /t 0
		Clear The Clipboard (Vista/7)@cmd /C "echo off | clip"
		Date to the clipboard (Vista/7)@cmd /C Date /t | Clip
		Time to the clipboard (Vista/7)@cmd /C Time /t | Clip
		Turn Aero Transparency Off@rundll32.exe dwmApi #104
		Turn Aero Transparency On@rundll32.exe dwmApi #102
		Troubleshoot Using System Maintenance@msdt.exe -id MaintenanceDiagnostic
	)
Return Build_List
}

System_Shortcut_Utilities() {
	
	Build_List =
	(LTrim
		Calculator@calc
		Command Prompt@cmd
		Internet Explorer@iexplore
		Notepad@notepad
		Remote Desktop@mstsc
		Task Manager@taskmgr
		Windows Magnifier@magnify
		Windows Media Player@wmplayer
		Wordpad@write
		Registry Editor@regedit
		On Screen Keyboard@osk
		Paint@mspaint
		Sound Recorder (Vista/7)@soundrecorder
		Snipping Tool@SnippingTool
	)
return Build_List
}

System_Shortcut_Win_Commands() {
	
	Build_List =
	(LTrim
		Tile Windows Horizontally@win_tileh
		Tile Windows Vertically@win_tilev
		Minimize: All Windows@win_min
		Minimize: Undo@win_unmin
		Toggle Desktop@win_togd
		Task Switcher (Vista+ only)@win_tasksw
		Cascade Windows@win_casc
	)
return Build_List
}