﻿TBMenuRebuild( butID )
{
	global hMainGuiToolbar, MAIN_SECTION_NAME
	TB_Enable(hMainGuiToolbar,butID,0)
	MenuRebuild( MAIN_SECTION_NAME )
	sleep 50
	is_hotkeys_errors := HotkeysCompare()
	if is_hotkeys_errors
		MsgBox,, Using of similar hotkeys, Some of your hotkeys/mouse gestures are the same:`n%is_hotkeys_errors%
	TB_Enable(hMainGuiToolbar,butID,1)
}

MainGuiToolbarHandler(Hwnd, Event, Txt, Pos, Id)
{
	global hMainGuiToolbar
	static expand_status, staticID, staticPos
	if Event not in click,menu
		return 0
	staticID := id,staticPos := Pos
	ret := id = 1 ? Tree_AddItem()
			: id = 2 ? Tree_AddMenu()
			: id = 3 ? Tree_AddSepar()
	if (id = 4)
	{
		Tree_Expand(expand_status)
		Toolbar_SetButtonImage(Hwnd,Id,expand_status ? 4 : 3)
	}
	else if (id = 5)
		SetTimer,MG_TVMoveItem_Down,-1
	else if (id = 7)
		SetTimer,MG_TVMoveItem_Up,-1
	else if (id = 6)
		MG_TV_DeleteItem()
	else if (id = 8)
		SetTimer,MG_ShowHints,-1
	else if (id = 9)
		SetTimer, MG_RebildMenu,-1
	return 1
	
	MG_RebildMenu:
		TBMenuRebuild( staticID )
		return
	
	MG_ShowHints:
		Gui, 1:+OwnDialogs
		TV_hints = 
		(LTrim
		-Drag and Drop files and folders to add them to the selected menu
		-Double click or F2 to rename item or menu
		
		Hotkeys:
		CTRL+UP or DOWN to move selected item up or down
		CTRL+Z - add new item
		CTRL+X - add menu
		CTRL+S - add separator
		DEL to delete selected item
		
		Commands Hints:
		-Use "Switch View" button at the right top of the list to switch between single and multiple commands view
		-Double click or F2 on command line to edit it
		-Del to delete line
		)
		Msgbox, 64, Hints, % TV_hints
		return
	
	MG_TVMoveItem_Down:
	MG_TVMoveItem_Up:
		Gui, 1:Default
		moveDir := (A_ThisLabel = "MG_TVMoveItem_Up" ? "U" : "D")
		MoveItem(moveDir,TV_GetSelection())
		GuiControl,Focus,AnTreeView
		return
}

MainGuiPropTlbHandler(Hwnd, Event, Txt, Pos, Id)
{
	global hMainGuiPropToolbar
	static staticID,staticPos,s_clr_type
	if Event not in menu,click
		return 0
	SetTimer, MG_RemStaticID, OFF
	if (Id = staticID && Event = "menu") {	;checking second press on the same menu
		staticID = 
		return
	}
	else if staticID
		TB_Press(hMainGuiPropToolbar,staticID,0)	;releasing previously pressed button
	staticID := id,staticPos := Pos
	if (id = 3)
		SetTimer,MG_ChangeCustHotkey,-1
	else if (id = 1)
		SetTimer,MG_TBChangeIcon,-1
	else if (id = 2)
		SetTimer,MG_ChangeBoldness,-1
	else if (id = 4)	{
		s_clr_type := "t"
		GoSub,MG_ChooseColor
	}
	else if (id = 5)	{
		s_clr_type := "bg"
		GoSub,MG_ChooseColor
	}
	else if (id = 7)
		GoSub,MG_SortMenu
	else if (id = 6)
		SetTimer,MG_SetMenuRandClrs,-1
	else if (id = 8)
		SetTimer,MG_CreateSMenu,-1
	return 1
	
	MG_ChooseColor:
		MenuChangeColorChoose(s_clr_type,staticPos)
		SetTimer, MG_RemStaticID, -200
		return
	
	MG_SortMenu:
		ControlGetPos,x,y,w,h,,ahk_id %hMainGuiPropToolbar%
		p := StrSplit(Toolbar_GetRect(hMainGuiPropToolbar,staticPos),A_Space)
		ShowMenu("Sort",x+p[1],y+p[4]+p[2])
		SetTimer, MG_RemStaticID, -200
		return
	
	MG_ChangeBoldness:
		Gui, 1:Default
		tv_id := TV_GetSelection()
		b_state := TB_IsChecked(hMainGuiPropToolbar,staticID)
		TV_Modify(tv_id,(b_state ? "" : "-") "Bold"),SetItemBold(tv_id,b_state)
		return
	
	MG_ChangeCustHotkey:
		MG_ChangeCustHotkey(staticID)
		return
		
	MG_TBChangeIcon:
		WinGetPos, X, Y,,, ahk_id %hMainGuiPropToolbar%
		p := StrSplit(Toolbar_GetRect(hMainGuiPropToolbar,staticPos),A_Space)
		TB_Press(hMainGuiPropToolbar,staticID,1)					;set pressed state of button
		MG_ChangeIcon(x+p[1],y+p[4])
		TB_Press(hMainGuiPropToolbar,staticID,0)
		SetTimer, MG_RemStaticID, -200
		return
		
	MG_SetMenuRandClrs:
		MG_SetMenuRandColors()
		return
		
	MG_CreateSMenu:
		MG_CreateSMenu()
		return
		
	MG_RemStaticID:
		TB_Press(hMainGuiPropToolbar,staticID,0)
		staticID =
		return
}

MG_CmdHandler(Hwnd, Event, Txt, Pos, Id)
{
	global hMG_TB_Cmd, MULTI_TARGET_DIVIDER
	static staticID,staticPos
	if Event not in menu,click
		return 0
	staticID:=id,staticPos:=pos
	if (id = 1) {
		IE_CmdView() ? GuiControlSet("STarget",GuiControlGet("STarget",1) . " " . MULTI_TARGET_DIVIDER . " command","",1) : IE_AddBlank()
		TV_SyncTargetFields(IE_CmdView() ? 1 : 2)
	}
	else if (id = 2)
		SyncTargetSave()
		,TB_Enable(hMG_TB_Cmd,id,0)
	else if (id = 3)
		GoSub,MG_TBCmd_MoveDown
	else if (id = 8)
		GoSub,MG_TBCmd_MoveUp	
	else if (id = 4)
		GoSub,MG_TBCmd_Change
	else if (id = 5)
		SetTimer,MG_TBCmd_Run,-1
	else if (id = 6)
		SetTimer,MG_TBCmd_RunAll,-1
	else if (id = 7)
		IE_CmdView() ? (GuiControlSet("STarget","","",1),TV_SyncTargetFields(1)) : IE_Del()
	return
	
	MG_TBCmd_RunAll:
		Gui, 1:+OwnDialogs
		SplashWait(1,"",1,0)
		RunTarget(IE_CmdView() ? GuiControlGet("STarget",1) : MG_GetLVTargets())
		SplashWait(0)
		return
	
	MG_TBCmd_Run:
		Gui,1:Default
		Gui, 1:+OwnDialogs
		LV_GetText(tg,LV_GetNext())
		RunTarget(tg)
		return
	
	MG_TBCmd_MoveUp:
	MG_TBCmd_MoveDown:
		moveDir := (A_ThisLabel = "MG_TBCmd_MoveUp" ? "UP" : "DOWN")
		LV_Move_Selection( 1, moveDir )
		TV_SyncTargetFields(2)
		GuiControl, Focus, Item_Edit_LV
		return

	
	MG_TBCmd_Change:
		ControlGetPos,x,y,w,h,,ahk_id %hMG_TB_Cmd%
		p := StrSplit(Toolbar_GetRect(hMG_TB_Cmd,staticPos)," ")
		x += p[1], y += p[2]
		ShowMenu(IE_CmdView() ? "Target_List_Menu" : "IE_CmdMenu",x,y+p[4])
		return
}

MG_SetMenuRandColors()
{
	global global_tvDefColors
	Gui, 1:Default
	ItemId := TV_GetSelection()
	if !TV_GetCHild(ItemId)
		return
	MenuSetColor("t",ItemID,tc := RandColor())
	MenuSetColor("bg",ItemID,bgc := RandColor())
	if ItemID
		TV_Modify(ItemID,"Expand VisFirst")
	else if !global_tvDefColors
		MG_ChangeTVBG(tc,"t"), MG_ChangeTVBG(bgc,"bg")
	TV_ArrangeColors(ItemID,1)
	return
}

MG_ChangeCustHotkey(butID)
{
	global hMainGuiPropToolbar
	Gui,1:Default
	itemID := TV_GetSelection()
	orig_hk := GetCustomHotkey(itemID)
	TB_Press(hMainGuiPropToolbar,butID,1)					;set pressed state of button
	new_hk := CustomHotkey_EditGUI(orig_hk,12 "|" 1,"Set Hotkey")
	TB_Press(hMainGuiPropToolbar,butID,0)
	if (new_hk == orig_hk)
		return
	SaveCustomHotkey(itemID,new_hk)
	TVMG_SetControls(itemID)
	return
}

ShowMenu(menu_name,x="",y="")
{
	CoordMode,Menu,Relative
	Menu,% menu_name, Show,% x,% y
	return
}

FixTlbButtons(isMenu,isSep,isItem)
{
	global hMainGuiPropToolbar, hMG_TB_Cmd
	TB_Enable(hMainGuiPropToolbar,"1|2|3|4|5|6|7|8|9|10|11",1)
	if isItem
		TB_Enable(hMainGuiPropToolbar,"4|5|6|7|8|9",0)
		,ClEnable(hMG_TB_Cmd)
	else
		ClEnable(hMG_TB_Cmd,0)
	if isSep
		TB_Enable(hMainGuiPropToolbar,"1|2|3|4|5|6|7|8|9|10|11",0)
	if (isMenu = 2)	;means it is main menu, and itemID = 0
		TB_Enable(hMainGuiPropToolbar,"1|2|3|10|11",0)
	return
}

TVMG_SetControls(itemID)
{
	global SEPARATOR_STRING, MAIN_SECTION_NAME, NOICO, NOICO_HANDLE
	global hMainGuiPropToolbar,TV_hwnd, TV_IL, hPropsTbImageList,hMG_TB_Cmd
	Gui,1:Default
	TV_GetText(CurItemName, itemID)
	if !itemID 
		CurItemName := MAIN_SECTION_NAME
	isMenu := TV_GetChild(itemID) ? (ItemID ? 1 : 2 ) : 0
	isSep := CurItemName = SEPARATOR_STRING ? 1 : 0
	isItem := !(isMenu || isSep)
	FixTlbButtons(isMenu,isSep,isItem)
	GuiControlSet("STarget","",isItem ? "Enable" : "Disable",1,0)
	GuiControlSet("gbTarget",isItem ? CurItemName "'s command line" : isSep ? "Separator" : "Menu: " CurItemName,"",1)
	if isSep
		IL_AddIcon(hPropsTbImageList,NOICO_HANDLE,0,0)
	else if itemID
	{
		if !(hi := TV_IL.Get(TV_GetIconIndex(TV_hwnd,itemID)))
			IL_AddIcon(hPropsTbImageList,NOICO_HANDLE,0,0)
		else
			IL_AddIcon(hPropsTbImageList,hi,0)
		
		if TV_Get(ItemID, "Bold")
			Toolbar_CheckButton(hMainGuiPropToolbar, 2, 1)
		else
			Toolbar_CheckButton(hMainGuiPropToolbar, 2, 0)
		
		if ItemHotkey := GetCustomHotkey(ItemID)
			Toolbar_SetButtonText( hMainGuiPropToolbar, 3, HotkeyToString( ItemHotkey ) )
		else
			Toolbar_SetButtonText(hMainGuiPropToolbar,3,"None")
		;~ WinSet, Redraw,,ahk_id %hMainGuiPropToolbar% ;uncomment in case of any redraw issues
	}
	else
		IL_AddIcon(hPropsTbImageList,NOICO_HANDLE,0,0)
	Toolbar_AutoSize(hMainGuiPropToolbar,2)
	
	cmd := isItem ? ItemGet(GetTarget(ItemID),"Targets") : ""
	cmd := cmd = "ERROR" ? "" : cmd
	GuiControl,1:,STarget,% cmd
	;  targets list sets
		GuiControlSet("Item_Edit_LV","",isItem ? "Enabled" : "Disabled",1,0)
		IE_cmd := isItem ? cmd : ""
		MG_EditToList(IE_cmd)
	
	IE_TBSaveEnable(0)	;disabling save TB button on each item change
	IE_TBButsEnable()	;checking & enabling/disabling TB buttons related to LV of commands
	return
}