﻿HotkeysCompare()
{
	global CLIPX_DEFAULT_GESTURE, MAIN_DEFAULT_GESTURE, WIN_HIDE_DEFAULT_GESTURE, MEMOS_DEFAULT_GESTURE
	global CLIPX_DEFAULT_HOTKEY, MAIN_DEFAULT_HOTKEY, WIN_HIDE_DEFAULT_HOTKEY, HIDE_WINDOW_DEFAULT_HOTKEY, MEMOS_DEFAULT_HOTKEY
	global CustomHotkeys_ActivateList
	global cur_clips_copy_hk, cur_clips_append_hk, cur_clips_paste_hk
	
	errors_log =
	gestures_error := 0
	hotkeys_error := 0
	;getting gestures
	G1 := OptGet("ClipXGesture")
		if (G1 = "ERROR")
			G1 := CLIPX_DEFAULT_GESTURE
		D1 := "ClipsMenu"
	G2 := OptGet("MainGesture")
		if (G2 = "ERROR")
			G2 := MAIN_DEFAULT_GESTURE
		D2 := "MainMenu"
	G3 := OptGet("Win_Hide_Gesture")
		if (G3 = "ERROR")
			G3 := WIN_HIDE_DEFAULT_GESTURE 
		D3 := "WindowsMenu"
	G4 := OptGet("Memos_Gesture")
		if (G4 = "ERROR")
			G4 := MEMOS_DEFAULT_GESTURE 
		D4 := "MemosMenu"
	G5 := GetRecentGesture()
		D5 := "RecentMenu"
	
	;getting hotkeys
	H1 := OptGet("ClipXHotkey")
		if (H1 = "ERROR" || H1 = "")
			H1 := CLIPX_DEFAULT_HOTKEY
		DH1 := "ClipsMenu"
	H2 := OptGet("HotKeyString")
		if (H2 = "ERROR" || H2 = "")
			H2 := MAIN_DEFAULT_HOTKEY
		DH2 := "MainMenu"
	H3 := OptGet("Win_Hide_Show_Hotkey")
		if (H3 = "ERROR" || H3 = "")
			H3 := WIN_HIDE_DEFAULT_HOTKEY
		DH3 := "WindowsMenu"
	H4 := OptGet("Hide_OptionalHotkey")
		if (H4 = "ERROR" || H4 = "")
		{
			H4 := HIDE_WINDOW_DEFAULT_HOTKEY
			if (H4 = "")
				H4 = "-"
		}
		DH4 := "HideWindow"
	H5 := OptGet("Memos_Hotkey")
		if (H5 = "ERROR" || H5 = "")
			H5 := MEMOS_DEFAULT_HOTKEY
		DH5 := "MemosMenu"
	H6 := GetRecentHotkey()
	DH6 := "RecentMenu"
	
	indx := 7
	num := 1
	Loop,Parse,CustomHotkeys_ActivateList,`n,`r%A_Tab%%A_Space%
	{
		if (A_loopfield = "")
			continue
		H%indx% := A_loopfield
		DH%indx% := "CustomHotkey_" . num
		indx++
		num++
	}
	
	Loop,9
	{
		if (cur_clips_copy_hk != "")	{
			H%indx% = %cur_clips_copy_hk%%A_Index%
			DH%indx% := "Clips_Add: " . HotkeyToString(H%indx%)
			indx++
		}
		if (cur_clips_append_hk != "")	{
			H%indx% = %cur_clips_append_hk%%A_Index%
			DH%indx% := "Clips_Append: " . HotkeyToString(H%indx%)
			indx++
		}
		if (cur_clips_paste_hk != "")	{
			H%indx% = %cur_clips_paste_hk%%A_Index%
			DH%indx% := "Clips_Paste: " . HotkeyToString(H%indx%)
			indx++
		}
	}
	
	Loop
	{
		if (G%A_Index% = "")
			break
		pre_index := next_index := A_Index
		Loop
		{
			next_index++
			if (G%next_index% = "")
				break
			if (G%next_index% = G%pre_index%)
			{
				if !gestures_error
				{
					gestures_error := 1
					errors_log .= "`nGestures:"
				}
				errors_log .= "`n" . D%pre_index% . " gesture is a same as " . D%next_index%
			}
		}
	}
	
	Loop
	{
		if (H%A_Index% = "")
			break
		pre_index := next_index := A_Index
		Loop
		{
			next_index++
			if (H%next_index% = "")
				break
			;~ msgbox,,,% pre_index . ":" . H%pre_index% "`n" next_index . ":" . H%next_index%
			if (H%next_index% = H%pre_index%)
			{
				if !hotkeys_error
				{
					hotkeys_error := 1
					errors_log .= "`nHotkeys:"
				}				
				errors_log .= "`n" . DH%pre_index% . " hotkey is a same as " . DH%next_index%
			}
		}
	}
	if errors_log
	{
		return errors_log
	}
	return 0
}