﻿DF_BuildDir(menu_id)
{
	global df_targets,global_Icons_Size,df_built_menus,df_menus,df_targets_count, icons_ext_handles
	global global_Icons_Size, DF_FOLDER, DF_OPEN_FOLDER
	if RegExMatch(df_menus,"`am)^" . menu_id . "\|\K.+?$",tg)
	{
		df_built_menus .= "|" . menu_id . "|"
		IsFolEmpty := 1
		Loop, %tg%\*.*, 1
		{
			if A_LoopFileAttrib contains H,S
				continue
			IsFolEmpty := 0
			break
		}
		
		if IsFolEmpty
		{
			MMenu_Add(menu_id, "(Empty)","","","")
			return
		}
		
		Loop, %tg%\*.*, 2
		{
			if A_LoopFileAttrib contains H,S
				continue
			df_m := MMenu_Create("S" . global_Icons_Size)
			df_menus .= "`n" . df_m . "|" . A_LoopFileLongPath
			MMenu_Add(menu_id, A_LoopFileName, DF_FOLDER . "_DF","","iDF_DFM_" . df_m . " m" . df_m)
			MMenu_Add(df_m, "- :Open Folder: -",DF_OPEN_FOLDER . "_DF","","iDF_DFM_" . df_m)
		}
		Loop, %tg%\*.*, 0
		{
			if A_LoopFileAttrib contains H,S
				continue
			df_targets_count++
			df_targets .= "`n" . df_targets_count . "|" . A_LoopFileLongPath
			i_handle := DF_GetIcon(A_LoopFileExt,A_LoopFileLongPath)
			MMenu_Add(menu_id, A_LoopFileName,i_handle,"","iDF_" . df_targets_count)
		}
	}
	return
}

DF_GetTarget(item_ID,smenu_file="")
{
	tg := ItemGet(item_ID,"Targets",smenu_file)
	if (!tg || tg = "ERROR")
		return
	StringReplace,tg,tg,",,1
	tg := PathResolve( tg )
	return PathGetDir( tg )
}

DF_GetIcon(ext,path)	;lnk
{
	global icons_ext_handles,global_Icons_Size
	if (ext = "lnk")
	{
		FileGetShortcut, %path%, Target,,,,icon_p,icon_num
		i_handle := IconExtract( icon_p, icon_num, global_Icons_Size)
	}
	else if (ext = "ico")
		i_handle := path
	else if (ext = "exe" || !RegExMatch(icons_ext_handles,"`am)^" . ext . "\|\K[\-0-9]+?$",i_handle))
	{
		if (ext != "exe")	
		{
			ico_path := IconFromExt(ext)
			i_handle := IconExtract( IconGetPath(ico_path), IconGetIndex(ico_path), global_Icons_Size)
			if i_handle
				icons_ext_handles .= "`n" . ext . "|" . i_handle
		}
		else
			i_handle := IconExtract( path, 0, global_Icons_Size)
	}
	if !i_handle
	{
		i_handle := IconGetAssociated(path)
		if i_handle
		{
			i_handle := IconCopy(i_handle,global_Icons_Size)
			icons_ext_handles .= "`n" . ext . "|" . i_handle
		}
	}
	if ext not in exe,ico,lnk
		i_handle .= "_DF"	
	return i_handle
}

DF_SetIconsHandle()
{
	global icons_ext_handles, DF_FOLDER, DF_OPEN_FOLDER, FOLDER_ICO
	i_size := GetIconSize()
	path := IconFromExt("dll")
	i_handle := IconExtract( IconGetPath(path), IconGetIndex(path), i_size)
	icons_ext_handles .= "`n" . "dll" . "|" . i_handle
	
	DF_FOLDER := IconExtract( IconGetPath(FOLDER_ICO), IconGetIndex(FOLDER_ICO),i_size)
	DF_OPEN_FOLDER := IconExtract( IconGetPath("SHELL32.dll:45"), IconGetIndex("SHELL32.dll:45"), i_size)
	return
}

DF_DestroyIcons()
{
	global DF_FOLDER, DF_OPEN_FOLDER, icons_ext_handles
	StringTrimRight,handle,DF_FOLDER,3
	MMenu_destroyIcon(handle,1)
	StringTrimRight,handle,DF_OPEN_FOLDER,3
	MMenu_destroyIcon(handle,1)
	loop,Parse,icons_ext_handles,`n,%A_Space%%A_Tab%
	{
		if (A_LoopField = "")
			continue
		StringSplit,fld,A_LoopField,|,%A_Space%%A_Tab%
		MMenu_destroyIcon(fld2,1)
	}
	icons_ext_handles =
	return
}

DF_FreeBrushes()
{
	global brushes_handles
	loop,parse,brushes_handles,`n,%A_Space%%A_Tab%
	{
		if (A_LoopField = "")
			continue
		StringSplit,fld,A_LoopField,|,%A_Space%%A_Tab%
		DeleteObject(fld2)
	}
	free(brushes_handles)
	return
}