﻿API_ShellExecute(target,args = "", work_dir = "",verb = "")
{
	return DllCall("shell32\ShellExecuteW", "Ptr", 0, "str", verb, "str", target, "str", args, "str", work_dir, "int", 1)
}

IL_GetIcon(hIL,ind)
{
	return dllcall("ImageList_GetIcon","Ptr",hIL,"Uint",ind,"Uint",0x00000001,"UPtr")	;ILD_TRANSPARENT
}

IL_CreateNew(size,initVal=10,growVal=5)
{
	return dllcall("ImageList_Create","Uint",size,"Uint",size,"Uint",0x00000020 | 0x00000001,"Uint",initVal,"Uint",growVal,"UPtr")	;ILC_COLOR32 + ILC_ORIGINALSIZE + ILC_MASK
}

IL_AddIcon(hIL,hIcon,ind=-1,erase=1) ;ind -1 to add icon to the end of list
{
	ret := dllcall("ImageList_ReplaceIcon","UPtr",hIL,"Uint",ind,"UPtr",hIcon,"Uint")
	if erase
		MMenu_destroyIcon(hIcon,1)
	return 
}

LoadDllFunction( file, function ) {
    if !hModule := DllCall( "GetModuleHandleW", "Wstr", file, "UPtr" )
        hModule := DllCall( "LoadLibraryW", "Wstr", file, "UPtr" )
	
    ret := DllCall("GetProcAddress", "Ptr", hModule, "AStr", function, "UPtr")
	return ret
}

SendMessage( hWnd, Msg, wParam, lParam )
{
   static SendMessageW

   If not SendMessageW
      SendMessageW := LoadDllFunction( "user32.dll", "SendMessageW" )

   ret := DllCall( SendMessageW, "UPtr", hWnd, "UInt", Msg, "UPtr", wParam, "UPtr", lParam )
   return ret
}

GUID(ByRef GUID, sGUID) ; Converts a string to a binary GUID and returns its address.
{
    VarSetCapacity(GUID, 16, 0)
    return DllCall("ole32\CLSIDFromString", "wstr", sGUID, "ptr", &GUID) >= 0 ? &GUID : ""
}